package Config::Maker::Grammar;
use Parse::RecDescent;
{ my $ERRORS;


package Parse::RecDescent::Config::Maker::Grammar;
use strict;
use vars qw($skip $AUTOLOAD  );
@Parse::RecDescent::Config::Maker::Grammar::ISA = ();
$skip = '\s*';


{
local $SIG{__WARN__} = sub {0};
# PRETEND TO BE IN Parse::RecDescent NAMESPACE
*Parse::RecDescent::Config::Maker::Grammar::AUTOLOAD   = sub
{
    no strict 'refs';

    ${"AUTOLOAD"} =~ s/^Parse::RecDescent::Config::Maker::Grammar/Parse::RecDescent/;
    goto &{${"AUTOLOAD"}};
}
}

push @Parse::RecDescent::Config::Maker::Grammar::ISA, 'Parse::RecDescent';
# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::optpath
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"optpath"};

    Parse::RecDescent::_trace(q{Trying rule: [optpath]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{optpath},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{':'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [':' path]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{optpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{optpath});
        %item = (__RULE__ => q{optpath});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [':']},
                      Parse::RecDescent::_tracefirst($text),
                      q{optpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\:/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying subrule: [path]},
                  Parse::RecDescent::_tracefirst($text),
                  q{optpath},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{path})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::path($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [path]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{optpath},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [path]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{optpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{path}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [':' path]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{optpath},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: []},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{optpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{optpath});
        %item = (__RULE__ => q{optpath});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{optpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { new Config::Maker::Path::This(); };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: []<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{optpath},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{optpath},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{optpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{optpath},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{optpath},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::path_whole
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"path_whole"};

    Parse::RecDescent::_trace(q{Trying rule: [path_whole]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{path_whole},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: [<skip: ''> path eof]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{path_whole},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{path_whole});
        %item = (__RULE__ => q{path_whole});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: ''>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{path_whole},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= ''; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [path]},
                  Parse::RecDescent::_tracefirst($text),
                  q{path_whole},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{path})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::path($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [path]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{path_whole},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [path]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{path_whole},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{path}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [eof]},
                  Parse::RecDescent::_tracefirst($text),
                  q{path_whole},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{eof})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::eof($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [eof]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{path_whole},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [eof]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{path_whole},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{eof}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{path_whole},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $item{path}; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<skip: ''> path eof]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{path_whole},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{path_whole},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{path_whole},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{path_whole},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{path_whole},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_identifier
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_identifier"};

    Parse::RecDescent::_trace(q{Trying rule: [value_identifier]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_identifier},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{identifier});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [identifier]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_identifier});
        %item = (__RULE__ => q{value_identifier});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [identifier]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_identifier},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::identifier($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [identifier]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_identifier},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [identifier]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{identifier}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [identifier]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{value_identifier});
        %item = (__RULE__ => q{value_identifier});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_identifier},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_identifier},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_identifier},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::identifier
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"identifier"};

    Parse::RecDescent::_trace(q{Trying rule: [identifier]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{identifier},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[[:alpha:]][[:alnum:]_-]*/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[[:alpha:]][[:alnum:]_-]*/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{identifier});
        %item = (__RULE__ => q{identifier});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[[:alpha:]][[:alnum:]_-]*/]}, Parse::RecDescent::_tracefirst($text),
                      q{identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[[:alpha:]][[:alnum:]_-]*)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[[:alpha:]][[:alnum:]_-]*/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{identifier},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{identifier},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{identifier},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{identifier},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::literal
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"literal"};

    Parse::RecDescent::_trace(q{Trying rule: [literal]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{literal},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[[:alnum:].!@%*=:\\/?_+-]+/, or /"(?:[^"]|\\\\.)*"/, or /'(?:[^']|\\\\.)*'/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[[:alnum:].!@%*=:\\/?_+-]+/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{literal},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{literal});
        %item = (__RULE__ => q{literal});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[[:alnum:].!@%*=:\\/?_+-]+/]}, Parse::RecDescent::_tracefirst($text),
                      q{literal},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[[:alnum:].!@%*=:\/?_+-]+)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[[:alnum:].!@%*=:\\/?_+-]+/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{literal},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/"(?:[^"]|\\\\.)*"/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{literal},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{literal});
        %item = (__RULE__ => q{literal});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/"(?:[^"]|\\\\.)*"/]}, Parse::RecDescent::_tracefirst($text),
                      q{literal},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:"(?:[^"]|\\.)*")/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{literal},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { Config::Maker::unquote_double($item[1]); };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/"(?:[^"]|\\\\.)*"/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{literal},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/'(?:[^']|\\\\.)*'/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{literal},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{literal});
        %item = (__RULE__ => q{literal});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/'(?:[^']|\\\\.)*'/]}, Parse::RecDescent::_tracefirst($text),
                      q{literal},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:'(?:[^']|\\.)*')/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{literal},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { Config::Maker::unquote_single($item[1]); };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/'(?:[^']|\\\\.)*'/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{literal},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{literal},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        
        my $_savetext;
        @item = (q{literal});
        %item = (__RULE__ => q{literal});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{literal},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{literal},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{literal},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{literal},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{literal},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{literal},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::type
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"type"};

    Parse::RecDescent::_trace(q{Trying rule: [type]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{type},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{identifier});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [identifier <commit>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{type});
        %item = (__RULE__ => q{type});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [identifier]},
                  Parse::RecDescent::_tracefirst($text),
                  q{type},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::identifier($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [identifier]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{type},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [identifier]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{identifier}} = $_tok;
        push @item, $_tok;
        
        }

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{type},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { eval { $arg[0]->get($item[1]); } };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [identifier <commit>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error?:...> <reject>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{type});
        %item = (__RULE__ => q{type});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error?:...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{type},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if ($commit) { do {push @{$thisparser->{errors}}, [qq{ $@},$thisline];} unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Rejecting production<< (found <reject>)},
                     Parse::RecDescent::_tracefirst($text),
                      q{type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $return;
        

        $_tok = undef;
        
        last unless defined $_tok;

        Parse::RecDescent::_trace(q{>>Matched production: [<error?:...> <reject>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{type},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{type},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{type},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{type},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{type},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_pair
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_pair"};

    Parse::RecDescent::_trace(q{Trying rule: [value_pair]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_pair},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{<matchrule:value_$arg[0][0]>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<matchrule:value_$arg[0][0]> <matchrule:value_$arg[1][0]>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_pair},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_pair});
        %item = (__RULE__ => q{value_pair});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [value_$arg[0][0]]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_pair},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = &{'Parse::RecDescent::Config::Maker::Grammar::'.qq{value_$arg[0][0]}}($thisparser,$text,$repeating,$_noactions,sub { return [$arg[0][1..$#{$arg[0]}]] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [value_$arg[0][0]]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_pair},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [value_$arg[0][0]]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_pair},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value_$arg[0][0]}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [value_$arg[1][0]]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_pair},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{<matchrule:value_$arg[1][0]>})->at($text);
        unless (defined ($_tok = &{'Parse::RecDescent::Config::Maker::Grammar::'.qq{value_$arg[1][0]}}($thisparser,$text,$repeating,$_noactions,sub { return [$arg[1][1..$#{$arg[1]}]] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [value_$arg[1][0]]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_pair},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [value_$arg[1][0]]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_pair},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value_$arg[1][0]}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_pair},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { new Config::Maker::Value::List [$item[1], $item[-1]]; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<matchrule:value_$arg[0][0]> <matchrule:value_$arg[1][0]>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_pair},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_pair},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{value_pair});
        %item = (__RULE__ => q{value_pair});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_pair},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_pair},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_pair},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_pair},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_pair},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_pair},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::space
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"space"};

    Parse::RecDescent::_trace(q{Trying rule: [space]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{space},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: [<skip: ''> /[ \\t]*\\n?/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{space},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{space});
        %item = (__RULE__ => q{space});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: ''>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{space},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= ''; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying terminal: [/[ \\t]*\\n?/]}, Parse::RecDescent::_tracefirst($text),
                      q{space},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/[ \\t]*\\n?/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[ \t]*\n?)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<skip: ''> /[ \\t]*\\n?/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{space},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{space},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{space},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{space},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{space},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_list"};

    Parse::RecDescent::_trace(q{Trying rule: [value_list]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_list});
        %item = (__RULE__ => q{value_list});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying repeated subrule: [value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::value, 1, 100000000, $_noactions,$expectation,sub { return [@arg] },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [value]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value(s)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { new Config::Maker::Value::List($item[1]); };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{value_list});
        %item = (__RULE__ => q{value_list});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_list},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_list},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::body
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"body"};

    Parse::RecDescent::_trace(q{Trying rule: [body]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{body},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{<matchrule:body_$arg[1]>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<matchrule:body_$arg[1]>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{body},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{body});
        %item = (__RULE__ => q{body});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [body_$arg[1]]},
                  Parse::RecDescent::_tracefirst($text),
                  q{body},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = &{'Parse::RecDescent::Config::Maker::Grammar::'.qq{body_$arg[1]}}($thisparser,$text,$repeating,$_noactions,sub { return [$arg[0], @arg[2..$#arg]] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [body_$arg[1]]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{body},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [body_$arg[1]]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{body},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{body_$arg[1]}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [<matchrule:body_$arg[1]>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{body},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{body},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{body},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{body},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{body},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_nested_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_nested_list"};

    Parse::RecDescent::_trace(q{Trying rule: [value_nested_list]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_nested_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'['});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['[' value_nestlist_elem ']']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_nested_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_nested_list});
        %item = (__RULE__ => q{value_nested_list});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['[']},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_nested_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\[/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying repeated subrule: [value_nestlist_elem]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_nested_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{value_nestlist_elem})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::value_nestlist_elem, 0, 100000000, $_noactions,$expectation,sub { return [@arg] },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [value_nestlist_elem]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_nested_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [value_nestlist_elem]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_nested_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value_nestlist_elem(s?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying terminal: [']']},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_nested_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{']'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\]/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_nested_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { new Config::Maker::Value::List($item[2]); };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['[' value_nestlist_elem ']']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_nested_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_nested_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{value_nested_list});
        %item = (__RULE__ => q{value_nested_list});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_nested_list},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_nested_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_nested_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_nested_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_nested_list},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_nested_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::eof
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"eof"};

    Parse::RecDescent::_trace(q{Trying rule: [eof]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{eof},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/^\\Z/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/^\\Z/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{eof},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{eof});
        %item = (__RULE__ => q{eof});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/^\\Z/]}, Parse::RecDescent::_tracefirst($text),
                      q{eof},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:^\Z)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/^\\Z/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{eof},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{eof},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{eof},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{eof},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{eof},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_dns_name
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_dns_name"};

    Parse::RecDescent::_trace(q{Trying rule: [value_dns_name]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_dns_name},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[a-zA-Z0-9-]+/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[a-zA-Z0-9-]+/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_dns_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_dns_name});
        %item = (__RULE__ => q{value_dns_name});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[a-zA-Z0-9-]+/]}, Parse::RecDescent::_tracefirst($text),
                      q{value_dns_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[a-zA-Z0-9-]+)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[a-zA-Z0-9-]+/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_dns_name},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_dns_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{value_dns_name});
        %item = (__RULE__ => q{value_dns_name});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_dns_name},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_dns_name},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_dns_name},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_dns_name},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_dns_name},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_dns_name},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_perlcode
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_perlcode"};

    Parse::RecDescent::_trace(q{Trying rule: [value_perlcode]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_perlcode},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{perl_codeblock});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [perl_codeblock]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_perlcode},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_perlcode});
        %item = (__RULE__ => q{value_perlcode});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [perl_codeblock]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_perlcode},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::perl_codeblock($thisparser,$text,$repeating,$_noactions,sub { return [@arg] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [perl_codeblock]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_perlcode},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [perl_codeblock]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_perlcode},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{perl_codeblock}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [perl_codeblock]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_perlcode},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_perlcode},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{value_perlcode});
        %item = (__RULE__ => q{value_perlcode});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_perlcode},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_perlcode},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_perlcode},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_perlcode},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_perlcode},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_perlcode},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::option
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"option"};

    Parse::RecDescent::_trace(q{Trying rule: [option]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{option},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{block, or type});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [block]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{option},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{option});
        %item = (__RULE__ => q{option});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [block]},
                  Parse::RecDescent::_tracefirst($text),
                  q{option},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::block($thisparser,$text,$repeating,$_noactions,sub { return [@arg] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [block]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{option},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [block]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{option},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{block}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [block]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{option},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [type <commit> body]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{option},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{option});
        %item = (__RULE__ => q{option});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [type]},
                  Parse::RecDescent::_tracefirst($text),
                  q{option},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::type($thisparser,$text,$repeating,$_noactions,sub { return [@arg] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [type]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{option},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [type]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{option},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{type}} = $_tok;
        push @item, $_tok;
        
        }

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{option},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [body]},
                  Parse::RecDescent::_tracefirst($text),
                  q{option},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{body})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::body($thisparser,$text,$repeating,$_noactions,sub { return [$item[1], $item[1]->body] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [body]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{option},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [body]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{option},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{body}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{option},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
	    $item[1]->instantiate($item[3]);
	};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [type <commit> body]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{option},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error?:...> <reject>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{option},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        
        my $_savetext;
        @item = (q{option});
        %item = (__RULE__ => q{option});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error?:...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{option},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if ($commit) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Rejecting production<< (found <reject>)},
                     Parse::RecDescent::_tracefirst($text),
                      q{option},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $return;
        

        $_tok = undef;
        
        last unless defined $_tok;

        Parse::RecDescent::_trace(q{>>Matched production: [<error?:...> <reject>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{option},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{option},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{option},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{option},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{option},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::glob
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"glob"};

    Parse::RecDescent::_trace(q{Trying rule: [glob]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{glob},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/([[:alnum:].@%*=?|_\\[\\]\{\}-]|\\\\.)+/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/([[:alnum:].@%*=?|_\\[\\]\{\}-]|\\\\.)+/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{glob},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{glob});
        %item = (__RULE__ => q{glob});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/([[:alnum:].@%*=?|_\\[\\]\{\}-]|\\\\.)+/]}, Parse::RecDescent::_tracefirst($text),
                      q{glob},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:([[:alnum:].@%*=?|_\[\]{}-]|\\.)+)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/([[:alnum:].@%*=?|_\\[\\]\{\}-]|\\\\.)+/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{glob},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{glob},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{glob},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{glob},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{glob},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::body_simple
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"body_simple"};

    Parse::RecDescent::_trace(q{Trying rule: [body_simple]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{body_simple},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [value ';']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{body_simple},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{body_simple});
        %item = (__RULE__ => q{body_simple});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{body_simple},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::value($thisparser,$text,$repeating,$_noactions,sub { return [@{$arg[1]}] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{body_simple},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{body_simple},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying terminal: [';']},
                      Parse::RecDescent::_tracefirst($text),
                      q{body_simple},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{';'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\;/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{body_simple},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { +{ -value => $item[1] }; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [value ';']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{body_simple},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{body_simple},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{body_simple});
        %item = (__RULE__ => q{body_simple});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{body_simple},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{body_simple},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{body_simple},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{body_simple},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{body_simple},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{body_simple},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_ipv4_mask
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_ipv4_mask"};

    Parse::RecDescent::_trace(q{Trying rule: [value_ipv4_mask]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_ipv4_mask},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: [<skip: ''> value_ipv4 '/' decint, or value_ipv4]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_ipv4_mask});
        %item = (__RULE__ => q{value_ipv4_mask});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: ''>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= ''; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [value_ipv4]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_ipv4_mask},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{value_ipv4})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::value_ipv4($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [value_ipv4]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_ipv4_mask},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [value_ipv4]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value_ipv4}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying terminal: ['/']},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'/'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\//)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying subrule: [_alternation_1_of_production_1_of_rule_value_ipv4_mask]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_ipv4_mask},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{decint, or value_ipv4})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::_alternation_1_of_production_1_of_rule_value_ipv4_mask($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [_alternation_1_of_production_1_of_rule_value_ipv4_mask]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_ipv4_mask},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [_alternation_1_of_production_1_of_rule_value_ipv4_mask]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{_alternation_1_of_production_1_of_rule_value_ipv4_mask}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { "$item[2]/$item[-1]"; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<skip: ''> value_ipv4 '/' decint, or value_ipv4]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{value_ipv4_mask});
        %item = (__RULE__ => q{value_ipv4_mask});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_ipv4_mask},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_ipv4_mask},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_ipv4_mask},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::byte
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"byte"};

    Parse::RecDescent::_trace(q{Trying rule: [byte]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{byte},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{decint});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [decint]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{byte},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{byte});
        %item = (__RULE__ => q{byte});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [decint]},
                  Parse::RecDescent::_tracefirst($text),
                  q{byte},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::decint($thisparser,$text,$repeating,$_noactions,sub { return [0,255] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [decint]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{byte},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [decint]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{byte},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{decint}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [decint]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{byte},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{byte},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{byte},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{byte},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{byte},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::decint
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"decint"};

    Parse::RecDescent::_trace(q{Trying rule: [decint]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{decint},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[+-]\\d+/, or /[1-9]\\d*|0/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[+-]\\d+/ <commit>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{decint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{decint});
        %item = (__RULE__ => q{decint});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[+-]\\d+/]}, Parse::RecDescent::_tracefirst($text),
                      q{decint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[+-]\d+)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{decint},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{decint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { Config::Maker::limit(0 + $item[1], @arg); };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[+-]\\d+/ <commit>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{decint},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[1-9]\\d*|0/ <commit>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{decint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{decint});
        %item = (__RULE__ => q{decint});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[1-9]\\d*|0/]}, Parse::RecDescent::_tracefirst($text),
                      q{decint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[1-9]\d*|0)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{decint},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{decint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { Config::Maker::limit(0 + $item[1], @arg); };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[1-9]\\d*|0/ <commit>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{decint},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error?:...> <reject>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{decint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        
        my $_savetext;
        @item = (q{decint});
        %item = (__RULE__ => q{decint});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error?:...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{decint},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if ($commit) { do {push @{$thisparser->{errors}}, [qq{ Number $item[1] out of range},$thisline];} unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Rejecting production<< (found <reject>)},
                     Parse::RecDescent::_tracefirst($text),
                      q{decint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $return;
        

        $_tok = undef;
        
        last unless defined $_tok;

        Parse::RecDescent::_trace(q{>>Matched production: [<error?:...> <reject>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{decint},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{decint},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{decint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{decint},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{decint},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::_alternation_1_of_production_1_of_rule_value_ipv4_mask
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"_alternation_1_of_production_1_of_rule_value_ipv4_mask"};

    Parse::RecDescent::_trace(q{Trying rule: [_alternation_1_of_production_1_of_rule_value_ipv4_mask]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{_alternation_1_of_production_1_of_rule_value_ipv4_mask},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{decint, or value_ipv4});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [decint]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_alternation_1_of_production_1_of_rule_value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_1_of_rule_value_ipv4_mask});
        %item = (__RULE__ => q{_alternation_1_of_production_1_of_rule_value_ipv4_mask});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [decint]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule_value_ipv4_mask},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::decint($thisparser,$text,$repeating,$_noactions,sub { return [0,32] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [decint]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule_value_ipv4_mask},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [decint]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{decint}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [decint]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [value_ipv4]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{_alternation_1_of_production_1_of_rule_value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{_alternation_1_of_production_1_of_rule_value_ipv4_mask});
        %item = (__RULE__ => q{_alternation_1_of_production_1_of_rule_value_ipv4_mask});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [value_ipv4]},
                  Parse::RecDescent::_tracefirst($text),
                  q{_alternation_1_of_production_1_of_rule_value_ipv4_mask},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::value_ipv4($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [value_ipv4]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{_alternation_1_of_production_1_of_rule_value_ipv4_mask},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [value_ipv4]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value_ipv4}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [value_ipv4]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{_alternation_1_of_production_1_of_rule_value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{_alternation_1_of_production_1_of_rule_value_ipv4_mask},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{_alternation_1_of_production_1_of_rule_value_ipv4_mask},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{_alternation_1_of_production_1_of_rule_value_ipv4_mask},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{_alternation_1_of_production_1_of_rule_value_ipv4_mask},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::hexint
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"hexint"};

    Parse::RecDescent::_trace(q{Trying rule: [hexint]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{hexint},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/0x[[:xdigit:]]+/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/0x[[:xdigit:]]+/ <commit>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{hexint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{hexint});
        %item = (__RULE__ => q{hexint});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/0x[[:xdigit:]]+/]}, Parse::RecDescent::_tracefirst($text),
                      q{hexint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:0x[[:xdigit:]]+)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{hexint},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{hexint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { Config::Maker::limit(hex($item[1]), @arg); };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/0x[[:xdigit:]]+/ <commit>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{hexint},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error?:...> <reject>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{hexint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{hexint});
        %item = (__RULE__ => q{hexint});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error?:...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{hexint},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if ($commit) { do {push @{$thisparser->{errors}}, [qq{ Number $item[1] out of range},$thisline];} unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Rejecting production<< (found <reject>)},
                     Parse::RecDescent::_tracefirst($text),
                      q{hexint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $return;
        

        $_tok = undef;
        
        last unless defined $_tok;

        Parse::RecDescent::_trace(q{>>Matched production: [<error?:...> <reject>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{hexint},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{hexint},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{hexint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{hexint},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{hexint},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::opener
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"opener"};

    Parse::RecDescent::_trace(q{Trying rule: [opener]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{opener},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'[$'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: ['[$' <skip: qr/\s*/> '$arg[0]' value '$]' space]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{opener},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{opener});
        %item = (__RULE__ => q{opener});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['[$']},
                      Parse::RecDescent::_tracefirst($text),
                      q{opener},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\[\$/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: qr/\s*/>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{opener},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= qr/\s*/; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying terminal: ['$arg[0]']},
                      Parse::RecDescent::_tracefirst($text),
                      q{opener},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'$arg[0]'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "$arg[0]"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{opener},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{value})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::value($thisparser,$text,$repeating,$_noactions,sub { return [@arg[1..$#arg]] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{opener},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{opener},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying terminal: ['$]']},
                      Parse::RecDescent::_tracefirst($text),
                      q{opener},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'$]'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\$\]/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING3__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying subrule: [space]},
                  Parse::RecDescent::_tracefirst($text),
                  q{opener},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{space})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::space($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [space]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{opener},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [space]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{opener},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{space}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{opener},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $item[-3]; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['[$' <skip: qr/\s*/> '$arg[0]' value '$]' space]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{opener},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{opener},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{opener},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{opener},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{opener},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_string
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_string"};

    Parse::RecDescent::_trace(q{Trying rule: [value_string]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_string},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{literal});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [literal]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_string});
        %item = (__RULE__ => q{value_string});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [literal]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_string},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::literal($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [literal]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_string},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [literal]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{literal}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [literal]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_string},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{value_string});
        %item = (__RULE__ => q{value_string});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_string},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_string},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_string},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_string},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_string},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_string},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_void
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_void"};

    Parse::RecDescent::_trace(q{Trying rule: [value_void]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_void},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: []},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_void},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_void});
        %item = (__RULE__ => q{value_void});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{>>Matched production: []<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_void},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_void},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_void},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_void},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_void},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::path
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"path"};

    Parse::RecDescent::_trace(q{Trying rule: [path]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{path},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{''});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: ['' <skip: ''> metaroot relpath]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{path});
        %item = (__RULE__ => q{path});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['']},
                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: ''>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= ''; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [metaroot]},
                  Parse::RecDescent::_tracefirst($text),
                  q{path},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{metaroot})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::metaroot($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [metaroot]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{path},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [metaroot]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{metaroot}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [relpath]},
                  Parse::RecDescent::_tracefirst($text),
                  q{path},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{relpath})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::relpath($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [relpath]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{path},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [relpath]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{relpath}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
	   new Config::Maker::Path::Meta(-tail => $item[-1]);
       };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['' <skip: ''> metaroot relpath]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: ['' <skip: ''> metaroot]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{path});
        %item = (__RULE__ => q{path});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['']},
                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: ''>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= ''; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [metaroot]},
                  Parse::RecDescent::_tracefirst($text),
                  q{path},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{metaroot})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::metaroot($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [metaroot]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{path},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [metaroot]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{metaroot}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
	   new Config::Maker::Path::Meta();
       };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['' <skip: ''> metaroot]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: ['' <skip: ''> separator relpath]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{path});
        %item = (__RULE__ => q{path});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['']},
                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: ''>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= ''; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [separator]},
                  Parse::RecDescent::_tracefirst($text),
                  q{path},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{separator})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::separator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [separator]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{path},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [separator]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{separator}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [relpath]},
                  Parse::RecDescent::_tracefirst($text),
                  q{path},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{relpath})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::relpath($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [relpath]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{path},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [relpath]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{relpath}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
	   new Config::Maker::Path::Root(-tail => $item[-1]);
       };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['' <skip: ''> separator relpath]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: ['' <skip: ''> separator]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{path});
        %item = (__RULE__ => q{path});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['']},
                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: ''>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= ''; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [separator]},
                  Parse::RecDescent::_tracefirst($text),
                  q{path},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{separator})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::separator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [separator]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{path},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [separator]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{separator}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
	   new Config::Maker::Path::Root();
       };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['' <skip: ''> separator]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: ['' <skip: ''> relpath]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        $text = $_[1];
        my $_savetext;
        @item = (q{path});
        %item = (__RULE__ => q{path});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['']},
                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: ''>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= ''; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [relpath]},
                  Parse::RecDescent::_tracefirst($text),
                  q{path},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{relpath})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::relpath($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [relpath]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{path},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [relpath]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{relpath}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: ['' <skip: ''> relpath]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{path},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{path},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{path},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::relpath
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"relpath"};

    Parse::RecDescent::_trace(q{Trying rule: [relpath]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{relpath},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{nonglob, or pcomponent});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [nonglob ptail]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{relpath});
        %item = (__RULE__ => q{relpath});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [nonglob]},
                  Parse::RecDescent::_tracefirst($text),
                  q{relpath},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::nonglob($thisparser,$text,$repeating,$_noactions,sub { return ['**'] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [nonglob]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{relpath},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [nonglob]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{nonglob}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [ptail]},
                  Parse::RecDescent::_tracefirst($text),
                  q{relpath},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{ptail})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::ptail($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ptail]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{relpath},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ptail]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ptail}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
	      new Config::Maker::Path::AnyPath(@{$item[-1]});
	  };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [nonglob ptail]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [nonglob ptail]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{relpath});
        %item = (__RULE__ => q{relpath});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [nonglob]},
                  Parse::RecDescent::_tracefirst($text),
                  q{relpath},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::nonglob($thisparser,$text,$repeating,$_noactions,sub { return ['..'] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [nonglob]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{relpath},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [nonglob]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{nonglob}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [ptail]},
                  Parse::RecDescent::_tracefirst($text),
                  q{relpath},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{ptail})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::ptail($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ptail]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{relpath},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ptail]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ptail}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
	      new Config::Maker::Path::Parent(@{$item[-1]});
	  };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [nonglob ptail]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [nonglob ptail]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{relpath});
        %item = (__RULE__ => q{relpath});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [nonglob]},
                  Parse::RecDescent::_tracefirst($text),
                  q{relpath},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::nonglob($thisparser,$text,$repeating,$_noactions,sub { return ['.'] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [nonglob]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{relpath},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [nonglob]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{nonglob}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [ptail]},
                  Parse::RecDescent::_tracefirst($text),
                  q{relpath},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{ptail})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::ptail($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ptail]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{relpath},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ptail]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ptail}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
	      new Config::Maker::Path::This(@{$item[-1]});
	  };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [nonglob ptail]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [pcomponent ptail]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{relpath});
        %item = (__RULE__ => q{relpath});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [pcomponent]},
                  Parse::RecDescent::_tracefirst($text),
                  q{relpath},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::pcomponent($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [pcomponent]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{relpath},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [pcomponent]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{pcomponent}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [ptail]},
                  Parse::RecDescent::_tracefirst($text),
                  q{relpath},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{ptail})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::ptail($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ptail]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{relpath},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ptail]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ptail}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
	      new Config::Maker::Path(%{$item[1]}, @{$item[-1]});
	  };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [pcomponent ptail]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{relpath},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{relpath},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{relpath},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{relpath},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::pcomponent
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"pcomponent"};

    Parse::RecDescent::_trace(q{Trying rule: [pcomponent]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{pcomponent},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{glob, or ':'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [glob ':' glob pcondition]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{pcomponent});
        %item = (__RULE__ => q{pcomponent});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [glob]},
                  Parse::RecDescent::_tracefirst($text),
                  q{pcomponent},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::glob($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [glob]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{pcomponent},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [glob]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{glob}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying terminal: [':']},
                      Parse::RecDescent::_tracefirst($text),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{':'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\:/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying subrule: [glob]},
                  Parse::RecDescent::_tracefirst($text),
                  q{pcomponent},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{glob})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::glob($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [glob]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{pcomponent},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [glob]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{glob}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying repeated subrule: [pcondition]},
                  Parse::RecDescent::_tracefirst($text),
                  q{pcomponent},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{pcondition})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::pcondition, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [pcondition]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{pcomponent},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [pcondition]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{pcondition(?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
		 +{
		     -type => $item[1],
		     -value => $item[3],
		     ($item[-1][0] ? (-code => $item[-1][0]) : ())
		 }
	     };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [glob ':' glob pcondition]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [':' glob pcondition]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{pcomponent});
        %item = (__RULE__ => q{pcomponent});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [':']},
                      Parse::RecDescent::_tracefirst($text),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\:/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying subrule: [glob]},
                  Parse::RecDescent::_tracefirst($text),
                  q{pcomponent},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{glob})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::glob($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [glob]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{pcomponent},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [glob]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{glob}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying repeated subrule: [pcondition]},
                  Parse::RecDescent::_tracefirst($text),
                  q{pcomponent},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{pcondition})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::pcondition, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [pcondition]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{pcomponent},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [pcondition]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{pcondition(?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
		 +{
		     -value => $item[2],
		     ($item[-1][0] ? (-code => $item[-1][0]) : ())
		 }
	     };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [':' glob pcondition]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [glob pcondition]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{pcomponent});
        %item = (__RULE__ => q{pcomponent});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [glob]},
                  Parse::RecDescent::_tracefirst($text),
                  q{pcomponent},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::glob($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [glob]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{pcomponent},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [glob]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{glob}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying repeated subrule: [pcondition]},
                  Parse::RecDescent::_tracefirst($text),
                  q{pcomponent},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{pcondition})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::pcondition, 0, 1, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [pcondition]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{pcomponent},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [pcondition]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{pcondition(?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
		 +{
		     -type => $item[1],
		     ($item[-1][0] ? (-code => $item[-1][0]) : ())
		 }
	     };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [glob pcondition]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{pcomponent},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{pcomponent},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{pcomponent},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{pcomponent},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::perl_codeblock
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"perl_codeblock"};

    Parse::RecDescent::_trace(q{Trying rule: [perl_codeblock]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{perl_codeblock},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: []},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{perl_codeblock},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{perl_codeblock});
        %item = (__RULE__ => q{perl_codeblock});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{perl_codeblock},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { Text::Balanced::extract_codeblock($text, '{}()[]', $skip, $arg[0]); };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: []<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{perl_codeblock},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{perl_codeblock},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{perl_codeblock},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{perl_codeblock},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{perl_codeblock},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_mac
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_mac"};

    Parse::RecDescent::_trace(q{Trying rule: [value_mac]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_mac},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/([[:xdigit:]]\{2\}:)\{5\}[[:xdigit:]]\{2\}/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/([[:xdigit:]]\{2\}:)\{5\}[[:xdigit:]]\{2\}/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_mac},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_mac});
        %item = (__RULE__ => q{value_mac});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/([[:xdigit:]]\{2\}:)\{5\}[[:xdigit:]]\{2\}/]}, Parse::RecDescent::_tracefirst($text),
                      q{value_mac},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:([[:xdigit:]]{2}:){5}[[:xdigit:]]{2})/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/([[:xdigit:]]\{2\}:)\{5\}[[:xdigit:]]\{2\}/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_mac},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_mac},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{value_mac});
        %item = (__RULE__ => q{value_mac});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_mac},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_mac},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_mac},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_mac},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_mac},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_mac},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::body_named_group
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"body_named_group"};

    Parse::RecDescent::_trace(q{Trying rule: [body_named_group]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{body_named_group},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [value block]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{body_named_group},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{body_named_group});
        %item = (__RULE__ => q{body_named_group});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{body_named_group},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::value($thisparser,$text,$repeating,$_noactions,sub { return [@{$arg[1]}] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{body_named_group},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [value]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{body_named_group},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [block]},
                  Parse::RecDescent::_tracefirst($text),
                  q{body_named_group},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{block})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::block($thisparser,$text,$repeating,$_noactions,sub { return [$arg[0]] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [block]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{body_named_group},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [block]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{body_named_group},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{block}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{body_named_group},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { +{
	    -value => $item[1],
	    -children => $item[2],
	}; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [value block]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{body_named_group},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{body_named_group},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{body_named_group});
        %item = (__RULE__ => q{body_named_group});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{body_named_group},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{body_named_group},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{body_named_group},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{body_named_group},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{body_named_group},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{body_named_group},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_zero_list
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_zero_list"};

    Parse::RecDescent::_trace(q{Trying rule: [value_zero_list]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_zero_list},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{value});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [value]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_zero_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_zero_list});
        %item = (__RULE__ => q{value_zero_list});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying repeated subrule: [value]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_zero_list},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::value, 0, 100000000, $_noactions,$expectation,sub { return [@arg] },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [value]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_zero_list},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [value]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_zero_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value(s?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_zero_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { new Config::Maker::Value::List($item[1]); };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [value]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_zero_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_zero_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{value_zero_list});
        %item = (__RULE__ => q{value_zero_list});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_zero_list},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_zero_list},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_zero_list},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_zero_list},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_zero_list},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_zero_list},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_port
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_port"};

    Parse::RecDescent::_trace(q{Trying rule: [value_port]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_port},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{decint});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [decint]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_port},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_port});
        %item = (__RULE__ => q{value_port});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [decint]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_port},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::decint($thisparser,$text,$repeating,$_noactions,sub { return [0,65535] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [decint]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_port},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [decint]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_port},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{decint}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [decint]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_port},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_port},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{value_port});
        %item = (__RULE__ => q{value_port});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_port},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_port},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_port},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_port},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_port},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_port},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::block
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"block"};

    Parse::RecDescent::_trace(q{Trying rule: [block]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{block},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'\{', or '<'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['\{' option '\}']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{block});
        %item = (__RULE__ => q{block});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['\{']},
                      Parse::RecDescent::_tracefirst($text),
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\{/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying repeated subrule: [option]},
                  Parse::RecDescent::_tracefirst($text),
                  q{block},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{option})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::option, 0, 100000000, $_noactions,$expectation,sub { return [$arg[0]] },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [option]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{block},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [option]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{option(s?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying terminal: ['\}']},
                      Parse::RecDescent::_tracefirst($text),
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'\}'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\}/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $item[2]; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['\{' option '\}']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: ['<' <skip: ''> /[^>]+/ '>']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{block});
        %item = (__RULE__ => q{block});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['<']},
                      Parse::RecDescent::_tracefirst($text),
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\</)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: ''>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= ''; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying terminal: [/[^>]+/]}, Parse::RecDescent::_tracefirst($text),
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/[^>]+/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[^>]+)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying terminal: ['>']},
                      Parse::RecDescent::_tracefirst($text),
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'>'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\>/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
	    Config::Maker::Config->read($item[3], $arg[0]);
	};
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['<' <skip: ''> /[^>]+/ '>']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        
        my $_savetext;
        @item = (q{block});
        %item = (__RULE__ => q{block});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{block},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{block},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{block},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{block},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::integer
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"integer"};

    Parse::RecDescent::_trace(q{Trying rule: [integer]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{integer},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{hexint, or octint, or decint});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [hexint]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{integer});
        %item = (__RULE__ => q{integer});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [hexint]},
                  Parse::RecDescent::_tracefirst($text),
                  q{integer},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::hexint($thisparser,$text,$repeating,$_noactions,sub { return [@arg] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [hexint]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{integer},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [hexint]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{hexint}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [hexint]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{integer},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [octint]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{integer});
        %item = (__RULE__ => q{integer});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [octint]},
                  Parse::RecDescent::_tracefirst($text),
                  q{integer},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::octint($thisparser,$text,$repeating,$_noactions,sub { return [@arg] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [octint]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{integer},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [octint]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{octint}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [octint]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{integer},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [decint]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{integer});
        %item = (__RULE__ => q{integer});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [decint]},
                  Parse::RecDescent::_tracefirst($text),
                  q{integer},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::decint($thisparser,$text,$repeating,$_noactions,sub { return [@arg] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [decint]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{integer},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [decint]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{decint}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [decint]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{integer},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{integer},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{integer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{integer},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{integer},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::closer
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"closer"};

    Parse::RecDescent::_trace(q{Trying rule: [closer]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{closer},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'[$', or '[/]'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: ['[$' <skip: qr/\s*/> 'end$arg[0]' <skip: ''> /(\\s[^\\$\\[\\]]*)?/ '$]' space]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{closer});
        %item = (__RULE__ => q{closer});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['[$']},
                      Parse::RecDescent::_tracefirst($text),
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\[\$/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: qr/\s*/>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= qr/\s*/; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying terminal: ['end$arg[0]']},
                      Parse::RecDescent::_tracefirst($text),
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'end$arg[0]'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   do { $_tok = "end$arg[0]"; 1 } and
             substr($text,0,length($_tok)) eq $_tok and
             do { substr($text,0,length($_tok)) = ""; 1; }
        )
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $_tok . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$_tok;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: ''>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= ''; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE2__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying terminal: [/(\\s[^\\$\\[\\]]*)?/]}, Parse::RecDescent::_tracefirst($text),
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/(\\s[^\\$\\[\\]]*)?/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:(\s[^\$\[\]]*)?)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying terminal: ['$]']},
                      Parse::RecDescent::_tracefirst($text),
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'$]'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\$\]/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING3__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying subrule: [space]},
                  Parse::RecDescent::_tracefirst($text),
                  q{closer},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{space})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::space($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [space]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{closer},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [space]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{space}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: ['[$' <skip: qr/\s*/> 'end$arg[0]' <skip: ''> /(\\s[^\\$\\[\\]]*)?/ '$]' space]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['[/]' space]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{closer});
        %item = (__RULE__ => q{closer});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['[/]']},
                      Parse::RecDescent::_tracefirst($text),
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\[\/\]/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying subrule: [space]},
                  Parse::RecDescent::_tracefirst($text),
                  q{closer},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{space})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::space($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [space]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{closer},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [space]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{space}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: ['[/]' space]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        
        my $_savetext;
        @item = (q{closer});
        %item = (__RULE__ => q{closer});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{closer},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{closer},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{closer},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{closer},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::octint
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"octint"};

    Parse::RecDescent::_trace(q{Trying rule: [octint]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{octint},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/0[0-7]*/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/0[0-7]*/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{octint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{octint});
        %item = (__RULE__ => q{octint});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/0[0-7]*/]}, Parse::RecDescent::_tracefirst($text),
                      q{octint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:0[0-7]*)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{octint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { Config::Maker::limit(oct($item[1]), @arg); };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/0[0-7]*/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{octint},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error?:...> <reject>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{octint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{octint});
        %item = (__RULE__ => q{octint});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error?:...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{octint},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if ($commit) { do {push @{$thisparser->{errors}}, [qq{ Number $item[1] out of range},$thisline];} unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Rejecting production<< (found <reject>)},
                     Parse::RecDescent::_tracefirst($text),
                      q{octint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $return;
        

        $_tok = undef;
        
        last unless defined $_tok;

        Parse::RecDescent::_trace(q{>>Matched production: [<error?:...> <reject>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{octint},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{octint},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{octint},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{octint},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{octint},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::real
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"real"};

    Parse::RecDescent::_trace(q{Trying rule: [real]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{real},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/[+-]?(\\d+(\\.\\d*)?|\\.\\d+)(e\\d+)?/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/[+-]?(\\d+(\\.\\d*)?|\\.\\d+)(e\\d+)?/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{real},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{real});
        %item = (__RULE__ => q{real});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/[+-]?(\\d+(\\.\\d*)?|\\.\\d+)(e\\d+)?/]}, Parse::RecDescent::_tracefirst($text),
                      q{real},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[+-]?(\d+(\.\d*)?|\.\d+)(e\d+)?)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{real},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { 0 + $item[1]; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/[+-]?(\\d+(\\.\\d*)?|\\.\\d+)(e\\d+)?/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{real},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{real},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{real},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{real},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{real},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::pcondition
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"pcondition"};

    Parse::RecDescent::_trace(q{Trying rule: [pcondition]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{pcondition},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{perl_codeblock});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [perl_codeblock]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{pcondition},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{pcondition});
        %item = (__RULE__ => q{pcondition});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [perl_codeblock]},
                  Parse::RecDescent::_tracefirst($text),
                  q{pcondition},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::perl_codeblock($thisparser,$text,$repeating,$_noactions,sub { return ['()'] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [perl_codeblock]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{pcondition},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [perl_codeblock]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{pcondition},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{perl_codeblock}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [perl_codeblock]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{pcondition},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{pcondition},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{pcondition},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{pcondition},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{pcondition},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::nonglob
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"nonglob"};

    Parse::RecDescent::_trace(q{Trying rule: [nonglob]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{nonglob},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/\\Q$arg[0]\\E(?![[:alnum:].@%*=?|_\\\\\\[\\]\{\}-])/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/\\Q$arg[0]\\E(?![[:alnum:].@%*=?|_\\\\\\[\\]\{\}-])/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{nonglob},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{nonglob});
        %item = (__RULE__ => q{nonglob});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/\\Q$arg[0]\\E(?![[:alnum:].@%*=?|_\\\\\\[\\]\{\}-])/]}, Parse::RecDescent::_tracefirst($text),
                      q{nonglob},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:\Q$arg[0]\E(?![[:alnum:].@%*=?|_\\\[\]{}-]))/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/\\Q$arg[0]\\E(?![[:alnum:].@%*=?|_\\\\\\[\\]\{\}-])/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{nonglob},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{nonglob},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{nonglob},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{nonglob},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{nonglob},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::configuration
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"configuration"};

    Parse::RecDescent::_trace(q{Trying rule: [configuration]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{configuration},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: [<skip: qr/(\s|#[^\n]*)*/> option eof]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{configuration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{configuration});
        %item = (__RULE__ => q{configuration});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: qr/(\s|#[^\n]*)*/>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{configuration},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= qr/(\s|#[^\n]*)*/; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying repeated subrule: [option]},
                  Parse::RecDescent::_tracefirst($text),
                  q{configuration},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{option})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::option, 0, 100000000, $_noactions,$expectation,sub { return [$arg[0]] },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [option]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{configuration},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [option]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{configuration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{option(s?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [eof]},
                  Parse::RecDescent::_tracefirst($text),
                  q{configuration},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{eof})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::eof($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [eof]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{configuration},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [eof]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{configuration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{eof}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{configuration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $item[2]; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<skip: qr/(\s|#[^\n]*)*/> option eof]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{configuration},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{configuration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{configuration});
        %item = (__RULE__ => q{configuration});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{configuration},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{configuration},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{configuration},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{configuration},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{configuration},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{configuration},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::ptail
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ptail"};

    Parse::RecDescent::_trace(q{Trying rule: [ptail]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ptail},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{separator});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [separator relpath]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ptail},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ptail});
        %item = (__RULE__ => q{ptail});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [separator]},
                  Parse::RecDescent::_tracefirst($text),
                  q{ptail},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::separator($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [separator]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{ptail},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [separator]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{ptail},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{separator}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [relpath]},
                  Parse::RecDescent::_tracefirst($text),
                  q{ptail},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{relpath})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::relpath($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [relpath]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{ptail},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [relpath]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{ptail},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{relpath}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ptail},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { [-tail => $item{relpath}] };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [separator relpath]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ptail},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: []},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ptail},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{ptail});
        %item = (__RULE__ => q{ptail});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ptail},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { []; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: []<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ptail},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ptail},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ptail},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ptail},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ptail},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_nestlist_elem
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_nestlist_elem"};

    Parse::RecDescent::_trace(q{Trying rule: [value_nestlist_elem]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_nestlist_elem},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'[', or <matchrule:value_$arg[0]>});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['[' value_nestlist_elem ']']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_nestlist_elem},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_nestlist_elem});
        %item = (__RULE__ => q{value_nestlist_elem});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['[']},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_nestlist_elem},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\[/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying repeated subrule: [value_nestlist_elem]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_nestlist_elem},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{value_nestlist_elem})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::value_nestlist_elem, 0, 100000000, $_noactions,$expectation,sub { return [@arg] },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [value_nestlist_elem]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_nestlist_elem},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [value_nestlist_elem]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_nestlist_elem},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value_nestlist_elem(s?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying terminal: [']']},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_nestlist_elem},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{']'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\]/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_nestlist_elem},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { new Config::Maker::Value::List($item[2]); };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['[' value_nestlist_elem ']']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_nestlist_elem},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<matchrule:value_$arg[0]>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_nestlist_elem},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_nestlist_elem});
        %item = (__RULE__ => q{value_nestlist_elem});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [value_$arg[0]]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_nestlist_elem},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = &{'Parse::RecDescent::Config::Maker::Grammar::'.qq{value_$arg[0]}}($thisparser,$text,$repeating,$_noactions,sub { return [@arg[1..$#arg]] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [value_$arg[0]]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_nestlist_elem},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [value_$arg[0]]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_nestlist_elem},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value_$arg[0]}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [<matchrule:value_$arg[0]>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_nestlist_elem},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_nestlist_elem},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        
        my $_savetext;
        @item = (q{value_nestlist_elem});
        %item = (__RULE__ => q{value_nestlist_elem});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_nestlist_elem},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_nestlist_elem},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_nestlist_elem},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_nestlist_elem},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_nestlist_elem},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_nestlist_elem},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value"};

    Parse::RecDescent::_trace(q{Trying rule: [value]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{''});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['' <matchrule:value_$arg[0]>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value});
        %item = (__RULE__ => q{value});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['']},
                      Parse::RecDescent::_tracefirst($text),
                      q{value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying subrule: [value_$arg[0]]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{<matchrule:value_$arg[0]>})->at($text);
        unless (defined ($_tok = &{'Parse::RecDescent::Config::Maker::Grammar::'.qq{value_$arg[0]}}($thisparser,$text,$repeating,$_noactions,sub { return [@arg[1..$#arg]] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [value_$arg[0]]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [value_$arg[0]]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value_$arg[0]}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: ['' <matchrule:value_$arg[0]>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_ipv4_port
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_ipv4_port"};

    Parse::RecDescent::_trace(q{Trying rule: [value_ipv4_port]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_ipv4_port},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: [<skip: ''> value_ipv4 ':' value_port]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_ipv4_port},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_ipv4_port});
        %item = (__RULE__ => q{value_ipv4_port});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: ''>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4_port},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= ''; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [value_ipv4]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_ipv4_port},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{value_ipv4})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::value_ipv4($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [value_ipv4]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_ipv4_port},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [value_ipv4]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4_port},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value_ipv4}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying terminal: [':']},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4_port},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{':'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\:/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying subrule: [value_port]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_ipv4_port},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{value_port})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::value_port($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [value_port]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_ipv4_port},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [value_port]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4_port},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{value_port}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4_port},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { "$item[2]:$item[-1]"; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<skip: ''> value_ipv4 ':' value_port]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4_port},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_ipv4_port},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{value_ipv4_port});
        %item = (__RULE__ => q{value_ipv4_port});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4_port},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4_port},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_ipv4_port},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_ipv4_port},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_ipv4_port},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_ipv4_port},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_ipv4
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_ipv4"};

    Parse::RecDescent::_trace(q{Trying rule: [value_ipv4]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_ipv4},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: [<skip: ''> <leftop: byte '.' byte>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_ipv4},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_ipv4});
        %item = (__RULE__ => q{value_ipv4});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: ''>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= ''; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying operator: [<leftop: byte '.' byte>]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_ipv4},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{<leftop: byte '.' byte>})->at($text);

        $_tok = undef;
        OPLOOP: while (1)
        {
          $repcount = 0;
          my @item;
          my %item;

          # MATCH LEFTARG
          
        Parse::RecDescent::_trace(q{Trying subrule: [byte]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_ipv4},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{byte})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::byte($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [byte]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_ipv4},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [byte]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{byte}} = $_tok;
        push @item, $_tok;
        
        }



          $repcount++;

          my $savetext = $text;
          my $backtrack;

          # MATCH (OP RIGHTARG)(s)
          while ($repcount < 100000000)
          {
            $backtrack = 0;
            
        Parse::RecDescent::_trace(q{Trying terminal: ['.']},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'.'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\./)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

            pop @item;
            
            
        Parse::RecDescent::_trace(q{Trying subrule: [byte]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_ipv4},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{byte})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::byte($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [byte]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_ipv4},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [byte]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{byte}} = $_tok;
        push @item, $_tok;
        
        }

            $savetext = $text;
            $repcount++;
          }
          $text = $savetext;
          pop @item if $backtrack;

          unless (@item) { undef $_tok; last }
          $_tok = [ @item ];

          last;
        } # end of OPLOOP

        unless ($repcount>=1)
        {
            Parse::RecDescent::_trace(q{<<Didn't match operator: [<leftop: byte '.' byte>]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_ipv4},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched operator: [<leftop: byte '.' byte>]<< (return value: [}
                      . qq{@{$_tok||[]}} . q{]},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4},
                      $tracelevel)
                        if defined $::RD_TRACE;

        push @item, $item{__DIRECTIVE2__}=$_tok||[];

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { @{$item[2]} == 4 ? join '.', @{$item[2]} : undef; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<skip: ''> <leftop: byte '.' byte>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_ipv4},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{value_ipv4});
        %item = (__RULE__ => q{value_ipv4});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_ipv4},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_ipv4},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_ipv4},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_ipv4},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_ipv4},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::metaroot
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"metaroot"};

    Parse::RecDescent::_trace(q{Trying rule: [metaroot]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{metaroot},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{'META:'});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['META:']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{metaroot},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{metaroot});
        %item = (__RULE__ => q{metaroot});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['META:']},
                      Parse::RecDescent::_tracefirst($text),
                      q{metaroot},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\AMETA\:/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['META:']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{metaroot},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{metaroot},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{metaroot},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{metaroot},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{metaroot},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::template
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"template"};

    Parse::RecDescent::_trace(q{Trying rule: [template]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{template},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: [<skip: ''> directive eof]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{template},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{template});
        %item = (__RULE__ => q{template});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: ''>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{template},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= ''; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying repeated subrule: [directive]},
                  Parse::RecDescent::_tracefirst($text),
                  q{template},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{directive})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::directive, 0, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [directive]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{template},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [directive]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{template},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{directive(s?)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [eof]},
                  Parse::RecDescent::_tracefirst($text),
                  q{template},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{eof})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::eof($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [eof]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{template},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [eof]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{template},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{eof}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{template},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $item[2]; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<skip: ''> directive eof]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{template},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{template},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{template});
        %item = (__RULE__ => q{template});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{template},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{template},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{template},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{template},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{template},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{template},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_path
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_path"};

    Parse::RecDescent::_trace(q{Trying rule: [value_path]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_path},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{path});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [path]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_path});
        %item = (__RULE__ => q{value_path});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [path]},
                  Parse::RecDescent::_tracefirst($text),
                  q{value_path},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::path($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [path]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{value_path},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [path]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{value_path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{path}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{>>Matched production: [path]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_path},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_path},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_path},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_path},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_path},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::separator
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"separator"};

    Parse::RecDescent::_trace(q{Trying rule: [separator]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{separator},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/\\/+/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/\\/+/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{separator});
        %item = (__RULE__ => q{separator});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/\\/+/]}, Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:\/+)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/\\/+/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{separator},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{separator},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{separator},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{separator},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::value_dns_zone
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"value_dns_zone"};

    Parse::RecDescent::_trace(q{Trying rule: [value_dns_zone]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{value_dns_zone},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/([a-zA-Z0-9-]+\\.)*[a-zA-Z0-9-]+\\.?/});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/([a-zA-Z0-9-]+\\.)*[a-zA-Z0-9-]+\\.?/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_dns_zone},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{value_dns_zone});
        %item = (__RULE__ => q{value_dns_zone});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/([a-zA-Z0-9-]+\\.)*[a-zA-Z0-9-]+\\.?/]}, Parse::RecDescent::_tracefirst($text),
                      q{value_dns_zone},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:([a-zA-Z0-9-]+\.)*[a-zA-Z0-9-]+\.?)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/([a-zA-Z0-9-]+\\.)*[a-zA-Z0-9-]+\\.?/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_dns_zone},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{value_dns_zone},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{value_dns_zone});
        %item = (__RULE__ => q{value_dns_zone});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{value_dns_zone},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{value_dns_zone},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{value_dns_zone},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{value_dns_zone},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{value_dns_zone},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{value_dns_zone},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::body_anon_group
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"body_anon_group"};

    Parse::RecDescent::_trace(q{Trying rule: [body_anon_group]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{body_anon_group},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{block});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [block]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{body_anon_group},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{body_anon_group});
        %item = (__RULE__ => q{body_anon_group});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [block]},
                  Parse::RecDescent::_tracefirst($text),
                  q{body_anon_group},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::block($thisparser,$text,$repeating,$_noactions,sub { return [$arg[0]] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [block]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{body_anon_group},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [block]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{body_anon_group},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{block}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{body_anon_group},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { +{ -children => $item[1] }; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [block]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{body_anon_group},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error...>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{body_anon_group},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        
        my $_savetext;
        @item = (q{body_anon_group});
        %item = (__RULE__ => q{body_anon_group});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{body_anon_group},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if (1) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [<error...>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{body_anon_group},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{body_anon_group},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{body_anon_group},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{body_anon_group},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{body_anon_group},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::ifrest
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"ifrest"};

    Parse::RecDescent::_trace(q{Trying rule: [ifrest]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{ifrest},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{opener, or closer});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [opener <commit> directive ifrest]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{ifrest});
        %item = (__RULE__ => q{ifrest});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [opener]},
                  Parse::RecDescent::_tracefirst($text),
                  q{ifrest},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::opener($thisparser,$text,$repeating,$_noactions,sub { return ['elsif', perlcode => '()'] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [opener]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{ifrest},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [opener]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{opener}} = $_tok;
        push @item, $_tok;
        
        }

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying repeated subrule: [directive]},
                  Parse::RecDescent::_tracefirst($text),
                  q{ifrest},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{directive})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::directive, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [directive]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{ifrest},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [directive]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{directive(s)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [ifrest]},
                  Parse::RecDescent::_tracefirst($text),
                  q{ifrest},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{ifrest})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::ifrest($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ifrest]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{ifrest},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ifrest]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ifrest}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
	     my $expr = $item[1];
	     my @parts = @{$item[3]};
	     my $else = $item[4];
	     sub {
		 if(Config::Maker::exe($expr)) {
		     Config::Maker::Driver::apply(@parts);
		 } else {
		     Config::Maker::Driver::apply($else);
		 }
	     }
	 };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [opener <commit> directive ifrest]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [opener <commit> directive ifrest]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{ifrest});
        %item = (__RULE__ => q{ifrest});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [opener]},
                  Parse::RecDescent::_tracefirst($text),
                  q{ifrest},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::opener($thisparser,$text,$repeating,$_noactions,sub { return ['elsif', pair => ['identifier'], ['path']] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [opener]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{ifrest},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [opener]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{opener}} = $_tok;
        push @item, $_tok;
        
        }

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying repeated subrule: [directive]},
                  Parse::RecDescent::_tracefirst($text),
                  q{ifrest},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{directive})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::directive, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [directive]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{ifrest},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [directive]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{directive(s)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [ifrest]},
                  Parse::RecDescent::_tracefirst($text),
                  q{ifrest},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{ifrest})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::ifrest($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ifrest]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{ifrest},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ifrest]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ifrest}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
	     my ($test, $path) = @{$item[1]};
	     my @parts = @{$item[3]};
	     my $else = $item[4];
	     sub {
		 die "No if test '$test'"
		     unless $Config::Maker::Path::checks{$test};
		 if($Config::Maker::Path::checks{$test}($path)) {
		     Config::Maker::Driver::apply(@parts);
		 } else {
		     Config::Maker::Driver::apply($else);
		 }
	     }
	 };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [opener <commit> directive ifrest]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [opener <commit> directive closer]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        $text = $_[1];
        my $_savetext;
        @item = (q{ifrest});
        %item = (__RULE__ => q{ifrest});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [opener]},
                  Parse::RecDescent::_tracefirst($text),
                  q{ifrest},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::opener($thisparser,$text,$repeating,$_noactions,sub { return ['else', 'void'] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [opener]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{ifrest},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [opener]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{opener}} = $_tok;
        push @item, $_tok;
        
        }

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying repeated subrule: [directive]},
                  Parse::RecDescent::_tracefirst($text),
                  q{ifrest},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{directive})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::directive, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [directive]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{ifrest},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [directive]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{directive(s)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [closer]},
                  Parse::RecDescent::_tracefirst($text),
                  q{ifrest},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{closer})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::closer($thisparser,$text,$repeating,$_noactions,sub { return ['if'] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [closer]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{ifrest},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [closer]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{closer}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
	     my @parts = @{$item[3]};
	     sub {
		 Config::Maker::Driver::apply(@parts);
	     }
	 };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [opener <commit> directive closer]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [closer]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{ifrest});
        %item = (__RULE__ => q{ifrest});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [closer]},
                  Parse::RecDescent::_tracefirst($text),
                  q{ifrest},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::closer($thisparser,$text,$repeating,$_noactions,sub { return ['if'] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [closer]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{ifrest},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [closer]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{closer}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { ''; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [closer]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{ifrest},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{ifrest},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{ifrest},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{ifrest},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}

# ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args, $_itempos)
sub Parse::RecDescent::Config::Maker::Grammar::directive
{
	my $thisparser = $_[0];
	use vars q{$tracelevel};
	local $tracelevel = ($tracelevel||0)+1;
	$ERRORS = 0;
    my $thisrule = $thisparser->{"rules"}{"directive"};

    Parse::RecDescent::_trace(q{Trying rule: [directive]},
                  Parse::RecDescent::_tracefirst($_[1]),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;

    
    my $err_at = @{$thisparser->{errors}};

    my $score;
    my $score_return;
    my $_tok;
    my $return = undef;
    my $_matched=0;
    my $commit=0;
    my @item = ();
    my %item = ();
    my $repeating =  $_[2];
    my $_noactions = $_[3];
    my @arg =    defined $_[4] ? @{ &{$_[4]} } : ();
    my $_itempos = $_[5];
    my %arg =    ($#arg & 01) ? @arg : (@arg, undef);
    my $text;
    my $lastsep;
    my $current_match;
    my $expectation = new Parse::RecDescent::Expectation(q{/([^\\[]|\\[\\[)+/, or '[#', or '[', or '[+', or '[<', or opener});
    $expectation->at($_[1]);
    
    my $thisline;
    tie $thisline, q{Parse::RecDescent::LineCounter}, \$text, $thisparser;

    

    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [/([^\\[]|\\[\\[)+/]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[0];
        $text = $_[1];
        my $_savetext;
        @item = (q{directive});
        %item = (__RULE__ => q{directive});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: [/([^\\[]|\\[\\[)+/]}, Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:([^\[]|\[\[)+)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { $item[1] =~ s/\[\[/[/g; $item[1] =~ s/\]\]/\]/g; $item[1]; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [/([^\\[]|\\[\\[)+/]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['[#' <commit> /([^#]|#[^\\]])*/ '#]']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[1];
        $text = $_[1];
        my $_savetext;
        @item = (q{directive});
        %item = (__RULE__ => q{directive});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['[#']},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\[\#/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying terminal: [/([^#]|#[^\\]])*/]}, Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/([^#]|#[^\\]])*/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:([^#]|#[^\]])*)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying terminal: ['#]']},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'#]'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\#\]/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do { ''; };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['[#' <commit> /([^#]|#[^\\]])*/ '#]']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error?:...> <reject>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[2];
        
        my $_savetext;
        @item = (q{directive});
        %item = (__RULE__ => q{directive});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error?:...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if ($commit) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Rejecting production<< (found <reject>)},
                     Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $return;
        

        $_tok = undef;
        
        last unless defined $_tok;

        Parse::RecDescent::_trace(q{>>Matched production: [<error?:...> <reject>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: ['[' <perl_codeblock> <commit> ']']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[3];
        $text = $_[1];
        my $_savetext;
        @item = (q{directive});
        %item = (__RULE__ => q{directive});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['[']},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\[/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<perl_codeblock>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { Text::Balanced::extract_codeblock($text,undef,$skip,'{}');
                     };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE2__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying terminal: [']']},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{']'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\]/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
		my $code = $item[2];
		sub {
		    print Config::Maker::exe($code);
		}
	    };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['[' <perl_codeblock> <commit> ']']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error?:...> <reject>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[4];
        
        my $_savetext;
        @item = (q{directive});
        %item = (__RULE__ => q{directive});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error?:...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if ($commit) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Rejecting production<< (found <reject>)},
                     Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $return;
        

        $_tok = undef;
        
        last unless defined $_tok;

        Parse::RecDescent::_trace(q{>>Matched production: [<error?:...> <reject>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: ['[+' <commit> <skip: qr/\s*/> identifier optpath '+]']},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[5];
        $text = $_[1];
        my $_savetext;
        @item = (q{directive});
        %item = (__RULE__ => q{directive});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['[+']},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\[\+/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: qr/\s*/>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= qr/\s*/; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE2__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying subrule: [identifier]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{identifier})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::identifier($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [identifier]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [identifier]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{identifier}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying subrule: [optpath]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{optpath})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::optpath($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [optpath]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [optpath]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{optpath}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying terminal: ['+]']},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'+]'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\+\]/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
		my $key = $item{identifier};
		my $path = $item{optpath};
		sub { print $_->get1($path)->{-$key}; }
	    };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['[+' <commit> <skip: qr/\s*/> identifier optpath '+]']<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error?:...> <reject>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[6];
        
        my $_savetext;
        @item = (q{directive});
        %item = (__RULE__ => q{directive});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error?:...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if ($commit) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Rejecting production<< (found <reject>)},
                     Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $return;
        

        $_tok = undef;
        
        last unless defined $_tok;

        Parse::RecDescent::_trace(q{>>Matched production: [<error?:...> <reject>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        local $skip = defined($skip) ? $skip : $Parse::RecDescent::skip;
        Parse::RecDescent::_trace(q{Trying production: ['[<' <skip: ''> <commit> /[^>]+/ '>]' space]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[7];
        $text = $_[1];
        my $_savetext;
        @item = (q{directive});
        %item = (__RULE__ => q{directive});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying terminal: ['[<']},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\[\</)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING1__}=$current_match;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<skip: ''>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { my $oldskip = $skip; $skip= ''; $oldskip };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE2__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying terminal: [/[^>]+/]}, Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{/[^>]+/})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A(?:[^>]+)/)
        {
            $text = $lastsep . $text if defined $lastsep;
            $expectation->failed();
            Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;

            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                    if defined $::RD_TRACE;
        push @item, $item{__PATTERN1__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying terminal: ['>]']},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $lastsep;
        $expectation->is(q{'>]'})->at($text);
        

        unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ m/\A\>\]/)
        {
            $text = $lastsep . $text if defined $lastsep;
            
            $expectation->failed();
            Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
            last;
        }
        $current_match = substr($text, $-[0], $+[0] - $-[0]);
        substr($text,0,length($current_match),q{});
        Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
                        . $current_match . q{])},
                          Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        push @item, $item{__STRING2__}=$current_match;
        

        Parse::RecDescent::_trace(q{Trying subrule: [space]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{space})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::space($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [space]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [space]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{space}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
		Config::Maker::Driver->load($item[4]);
	    };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: ['[<' <skip: ''> <commit> /[^>]+/ '>]' space]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error?:...> <reject>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[8];
        
        my $_savetext;
        @item = (q{directive});
        %item = (__RULE__ => q{directive});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error?:...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if ($commit) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Rejecting production<< (found <reject>)},
                     Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $return;
        

        $_tok = undef;
        
        last unless defined $_tok;

        Parse::RecDescent::_trace(q{>>Matched production: [<error?:...> <reject>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [opener <commit> directive closer]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[9];
        $text = $_[1];
        my $_savetext;
        @item = (q{directive});
        %item = (__RULE__ => q{directive});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [opener]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::opener($thisparser,$text,$repeating,$_noactions,sub { return ['map', perlcode => '()'] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [opener]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [opener]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{opener}} = $_tok;
        push @item, $_tok;
        
        }

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying repeated subrule: [directive]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{directive})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::directive, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [directive]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [directive]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{directive(s)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [closer]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{closer})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::closer($thisparser,$text,$repeating,$_noactions,sub { return ['map'] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [closer]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [closer]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{closer}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
		my $expr = $item[1];
		my @parts = @{$item[3]};
		sub {
		    for(Config::Maker::exe($expr)) {
			Config::Maker::Driver::apply(@parts);
		    }
		}
	    };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [opener <commit> directive closer]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [opener <commit> directive closer]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[10];
        $text = $_[1];
        my $_savetext;
        @item = (q{directive});
        %item = (__RULE__ => q{directive});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [opener]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::opener($thisparser,$text,$repeating,$_noactions,sub { return ['map', 'path'] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [opener]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [opener]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{opener}} = $_tok;
        push @item, $_tok;
        
        }

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying repeated subrule: [directive]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{directive})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::directive, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [directive]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [directive]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{directive(s)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [closer]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{closer})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::closer($thisparser,$text,$repeating,$_noactions,sub { return ['map'] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [closer]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [closer]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{closer}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
		my $path = $item[1];
		my @parts = @{$item[3]};
		sub {
		    for(@{$path->find($_)}) {
			Config::Maker::Driver::apply(@parts);
		    }
		}
	    };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [opener <commit> directive closer]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [<error?:...> <reject>]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[11];
        
        my $_savetext;
        @item = (q{directive});
        %item = (__RULE__ => q{directive});
        my $repcount = 0;


        

        Parse::RecDescent::_trace(q{Trying directive: [<error?:...>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { if ($commit) { do {
        my $rule = $item[0];
           $rule =~ s/_/ /g;
        #WAS: Parse::RecDescent::_error("Invalid $rule: " . $expectation->message() ,$thisline);
        push @{$thisparser->{errors}}, ["Invalid $rule: " . $expectation->message() ,$thisline];
        } unless  $_noactions; undef } else {0} };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Rejecting production<< (found <reject>)},
                     Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        undef $return;
        

        $_tok = undef;
        
        last unless defined $_tok;

        Parse::RecDescent::_trace(q{>>Matched production: [<error?:...> <reject>]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [opener <commit> directive ifrest]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[12];
        $text = $_[1];
        my $_savetext;
        @item = (q{directive});
        %item = (__RULE__ => q{directive});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [opener]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::opener($thisparser,$text,$repeating,$_noactions,sub { return ['if', perlcode => '()'] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [opener]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [opener]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{opener}} = $_tok;
        push @item, $_tok;
        
        }

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying repeated subrule: [directive]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{directive})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::directive, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [directive]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [directive]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{directive(s)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [ifrest]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{ifrest})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::ifrest($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ifrest]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ifrest]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ifrest}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
		my $expr = $item[1];
		my @parts = @{$item[3]};
		my $else = $item[4];
		sub {
		    if(Config::Maker::exe($expr)) {
			Config::Maker::Driver::apply(@parts);
		    } else {
			Config::Maker::Driver::apply($else);
		    }
		}
	    };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [opener <commit> directive ifrest]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [opener <commit> directive ifrest]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[13];
        $text = $_[1];
        my $_savetext;
        @item = (q{directive});
        %item = (__RULE__ => q{directive});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [opener]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::opener($thisparser,$text,$repeating,$_noactions,sub { return ['if', pair => ['identifier'], ['path']] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [opener]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [opener]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{opener}} = $_tok;
        push @item, $_tok;
        
        }

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying repeated subrule: [directive]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{directive})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::directive, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [directive]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [directive]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{directive(s)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [ifrest]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{ifrest})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::ifrest($thisparser,$text,$repeating,$_noactions,sub { \@arg },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [ifrest]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [ifrest]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{ifrest}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
		my ($test, $path) = @{$item[1]};
		my @parts = @{$item[3]};
		my $else = $item[4];
		sub {
		    die "No if test '$test'"
			unless $Config::Maker::Path::checks{$test};
		    if($Config::Maker::Path::checks{$test}($path)) {
			Config::Maker::Driver::apply(@parts);
		    } else {
			Config::Maker::Driver::apply($else);
		    }
		}
	    };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [opener <commit> directive ifrest]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    while (!$_matched && !$commit)
    {
        
        Parse::RecDescent::_trace(q{Trying production: [opener <commit> directive closer]},
                      Parse::RecDescent::_tracefirst($_[1]),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        my $thisprod = $thisrule->{"prods"}[14];
        $text = $_[1];
        my $_savetext;
        @item = (q{directive});
        %item = (__RULE__ => q{directive});
        my $repcount = 0;


        Parse::RecDescent::_trace(q{Trying subrule: [opener]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::opener($thisparser,$text,$repeating,$_noactions,sub { return ['output', 'identifier'] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [opener]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [opener]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{opener}} = $_tok;
        push @item, $_tok;
        
        }

        

        Parse::RecDescent::_trace(q{Trying directive: [<commit>]},
                    Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE; 
        $_tok = do { $commit = 1 };
        if (defined($_tok))
        {
            Parse::RecDescent::_trace(q{>>Matched directive<< (return value: [}
                        . $_tok . q{])},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        else
        {
            Parse::RecDescent::_trace(q{<<Didn't match directive>>},
                        Parse::RecDescent::_tracefirst($text))
                            if defined $::RD_TRACE;
        }
        
        last unless defined $_tok;
        push @item, $item{__DIRECTIVE1__}=$_tok;
        

        Parse::RecDescent::_trace(q{Trying repeated subrule: [directive]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        $expectation->is(q{directive})->at($text);
        
        unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Config::Maker::Grammar::directive, 1, 100000000, $_noactions,$expectation,sub { \@arg },undef)))
        {
            Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [directive]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched repeated subrule: [directive]<< (}
                    . @$_tok . q{ times)},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{directive(s)}} = $_tok;
        push @item, $_tok;
        


        Parse::RecDescent::_trace(q{Trying subrule: [closer]},
                  Parse::RecDescent::_tracefirst($text),
                  q{directive},
                  $tracelevel)
                    if defined $::RD_TRACE;
        if (1) { no strict qw{refs};
        $expectation->is(q{closer})->at($text);
        unless (defined ($_tok = Parse::RecDescent::Config::Maker::Grammar::closer($thisparser,$text,$repeating,$_noactions,sub { return ['output'] },undef)))
        {
            
            Parse::RecDescent::_trace(q{<<Didn't match subrule: [closer]>>},
                          Parse::RecDescent::_tracefirst($text),
                          q{directive},
                          $tracelevel)
                            if defined $::RD_TRACE;
            $expectation->failed();
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched subrule: [closer]<< (return value: [}
                    . $_tok . q{]},

                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $item{q{closer}} = $_tok;
        push @item, $_tok;
        
        }

        Parse::RecDescent::_trace(q{Trying action},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        

        $_tok = ($_noactions) ? 0 : do {
		my $key = $item[1];
		my @parts = @{$item[3]};
		my ($cache, $output) =
		    $key eq 'all'        ? (1, 1) :
		    $key eq 'both'       ? (1, 1) :
		    $key eq 'only-cache' ? (1, 0) :
		    $key eq 'no-cache'   ? (0, 1) :
		    $key eq 'only-out'   ? (0, 1) :
		    $key eq 'no-out'     ? (1, 0) :
				           die "Bad output option: $key";
		sub {
		    die "output limiting only works when cache is enabled"
			unless UNIVERSAL::isa(select(), 'Config::Maker::Tee');
		    local $Config::Maker::Tee::CACHE = $cache;
		    local $Config::Maker::Tee::OUT = $output;
		    Config::Maker::Driver::apply(@parts);
		}
	    };
        unless (defined $_tok)
        {
            Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
                    if defined $::RD_TRACE;
            last;
        }
        Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
                      . $_tok . q{])},
                      Parse::RecDescent::_tracefirst($text))
                        if defined $::RD_TRACE;
        push @item, $_tok;
        $item{__ACTION1__}=$_tok;
        

        Parse::RecDescent::_trace(q{>>Matched production: [opener <commit> directive closer]<<},
                      Parse::RecDescent::_tracefirst($text),
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;



        $_matched = 1;
        last;
    }


    unless ( $_matched || defined($score) )
    {
        

        $_[1] = $text;  # NOT SURE THIS IS NEEDED
        Parse::RecDescent::_trace(q{<<Didn't match rule>>},
                     Parse::RecDescent::_tracefirst($_[1]),
                     q{directive},
                     $tracelevel)
                    if defined $::RD_TRACE;
        return undef;
    }
    if (!defined($return) && defined($score))
    {
        Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
                      q{directive},
                      $tracelevel)
                        if defined $::RD_TRACE;
        $return = $score_return;
    }
    splice @{$thisparser->{errors}}, $err_at;
    $return = $item[$#item] unless defined $return;
    if (defined $::RD_TRACE)
    {
        Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
                      $return . q{])}, "",
                      q{directive},
                      $tracelevel);
        Parse::RecDescent::_trace(q{(consumed: [} .
                      Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])},
                      Parse::RecDescent::_tracefirst($text),
                      , q{directive},
                      $tracelevel)
    }
    $_[1] = $text;
    return $return;
}
}
package Config::Maker::Grammar; sub new { my $self = bless( {
                 '_AUTOACTION' => undef,
                 'localvars' => '',
                 'startcode' => '',
                 'rules' => {
                              'optpath' => bless( {
                                                  'changed' => 0,
                                                  'opcount' => 0,
                                                  'vars' => '',
                                                  'line' => 137,
                                                  'calls' => [
                                                               'path'
                                                             ],
                                                  'name' => 'optpath',
                                                  'impcount' => 0,
                                                  'prods' => [
                                                               bless( {
                                                                        'strcount' => 1,
                                                                        'number' => 0,
                                                                        'uncommit' => undef,
                                                                        'dircount' => 0,
                                                                        'actcount' => 0,
                                                                        'error' => undef,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'hashname' => '__STRING1__',
                                                                                              'description' => '\':\'',
                                                                                              'pattern' => ':',
                                                                                              'line' => 137,
                                                                                              'lookahead' => 0
                                                                                            }, 'Parse::RecDescent::Literal' ),
                                                                                     bless( {
                                                                                              'matchrule' => 0,
                                                                                              'argcode' => undef,
                                                                                              'line' => 137,
                                                                                              'subrule' => 'path',
                                                                                              'lookahead' => 0,
                                                                                              'implicit' => undef
                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                   ],
                                                                        'patcount' => 0,
                                                                        'line' => undef
                                                                      }, 'Parse::RecDescent::Production' ),
                                                               bless( {
                                                                        'actcount' => 1,
                                                                        'error' => undef,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'hashname' => '__ACTION1__',
                                                                                              'code' => '{ new Config::Maker::Path::This(); }',
                                                                                              'line' => 138,
                                                                                              'lookahead' => 0
                                                                                            }, 'Parse::RecDescent::Action' )
                                                                                   ],
                                                                        'line' => 138,
                                                                        'patcount' => 0,
                                                                        'strcount' => 0,
                                                                        'uncommit' => undef,
                                                                        'number' => 1,
                                                                        'dircount' => 0
                                                                      }, 'Parse::RecDescent::Production' )
                                                             ]
                                                }, 'Parse::RecDescent::Rule' ),
                              'path_whole' => bless( {
                                                     'changed' => 0,
                                                     'name' => 'path_whole',
                                                     'impcount' => 0,
                                                     'line' => 38,
                                                     'calls' => [
                                                                  'path',
                                                                  'eof'
                                                                ],
                                                     'opcount' => 0,
                                                     'vars' => '',
                                                     'prods' => [
                                                                  bless( {
                                                                           'uncommit' => undef,
                                                                           'number' => 0,
                                                                           'strcount' => 0,
                                                                           'dircount' => 1,
                                                                           'error' => undef,
                                                                           'actcount' => 1,
                                                                           'line' => undef,
                                                                           'patcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'name' => '<skip: \'\'>',
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 40,
                                                                                                 'code' => 'my $oldskip = $skip; $skip= \'\'; $oldskip',
                                                                                                 'hashname' => '__DIRECTIVE1__'
                                                                                               }, 'Parse::RecDescent::Directive' ),
                                                                                        bless( {
                                                                                                 'implicit' => undef,
                                                                                                 'line' => 40,
                                                                                                 'lookahead' => 0,
                                                                                                 'subrule' => 'path',
                                                                                                 'argcode' => undef,
                                                                                                 'matchrule' => 0
                                                                                               }, 'Parse::RecDescent::Subrule' ),
                                                                                        bless( {
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 40,
                                                                                                 'subrule' => 'eof',
                                                                                                 'implicit' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' ),
                                                                                        bless( {
                                                                                                 'hashname' => '__ACTION1__',
                                                                                                 'code' => '{ $item{path}; }',
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 40
                                                                                               }, 'Parse::RecDescent::Action' )
                                                                                      ]
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ]
                                                   }, 'Parse::RecDescent::Rule' ),
                              'value_identifier' => bless( {
                                                           'changed' => 0,
                                                           'opcount' => 0,
                                                           'vars' => '',
                                                           'impcount' => 0,
                                                           'name' => 'value_identifier',
                                                           'line' => 395,
                                                           'calls' => [
                                                                        'identifier'
                                                                      ],
                                                           'prods' => [
                                                                        bless( {
                                                                                 'dircount' => 0,
                                                                                 'strcount' => 0,
                                                                                 'number' => 0,
                                                                                 'uncommit' => undef,
                                                                                 'items' => [
                                                                                              bless( {
                                                                                                       'argcode' => undef,
                                                                                                       'matchrule' => 0,
                                                                                                       'subrule' => 'identifier',
                                                                                                       'line' => 395,
                                                                                                       'lookahead' => 0,
                                                                                                       'implicit' => undef
                                                                                                     }, 'Parse::RecDescent::Subrule' )
                                                                                            ],
                                                                                 'patcount' => 0,
                                                                                 'line' => undef,
                                                                                 'actcount' => 0,
                                                                                 'error' => undef
                                                                               }, 'Parse::RecDescent::Production' ),
                                                                        bless( {
                                                                                 'items' => [
                                                                                              bless( {
                                                                                                       'msg' => '',
                                                                                                       'line' => 396,
                                                                                                       'lookahead' => 0,
                                                                                                       'commitonly' => '',
                                                                                                       'hashname' => '__DIRECTIVE1__'
                                                                                                     }, 'Parse::RecDescent::Error' )
                                                                                            ],
                                                                                 'line' => 396,
                                                                                 'patcount' => 0,
                                                                                 'actcount' => 0,
                                                                                 'error' => 1,
                                                                                 'dircount' => 1,
                                                                                 'strcount' => 0,
                                                                                 'uncommit' => 0,
                                                                                 'number' => 1
                                                                               }, 'Parse::RecDescent::Production' )
                                                                      ]
                                                         }, 'Parse::RecDescent::Rule' ),
                              'identifier' => bless( {
                                                     'changed' => 0,
                                                     'line' => 2,
                                                     'calls' => [],
                                                     'name' => 'identifier',
                                                     'impcount' => 0,
                                                     'opcount' => 0,
                                                     'vars' => '',
                                                     'prods' => [
                                                                  bless( {
                                                                           'dircount' => 0,
                                                                           'strcount' => 0,
                                                                           'uncommit' => undef,
                                                                           'number' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'ldelim' => '/',
                                                                                                 'line' => 4,
                                                                                                 'lookahead' => 0,
                                                                                                 'hashname' => '__PATTERN1__',
                                                                                                 'description' => '/[[:alpha:]][[:alnum:]_-]*/',
                                                                                                 'mod' => '',
                                                                                                 'rdelim' => '/',
                                                                                                 'pattern' => '[[:alpha:]][[:alnum:]_-]*'
                                                                                               }, 'Parse::RecDescent::Token' )
                                                                                      ],
                                                                           'line' => undef,
                                                                           'patcount' => 1,
                                                                           'actcount' => 0,
                                                                           'error' => undef
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ]
                                                   }, 'Parse::RecDescent::Rule' ),
                              'literal' => bless( {
                                                  'changed' => 0,
                                                  'line' => 6,
                                                  'calls' => [],
                                                  'name' => 'literal',
                                                  'impcount' => 0,
                                                  'vars' => '',
                                                  'opcount' => 0,
                                                  'prods' => [
                                                               bless( {
                                                                        'dircount' => 0,
                                                                        'uncommit' => undef,
                                                                        'number' => 0,
                                                                        'strcount' => 0,
                                                                        'line' => undef,
                                                                        'patcount' => 1,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'ldelim' => '/',
                                                                                              'lookahead' => 0,
                                                                                              'line' => 6,
                                                                                              'description' => '/[[:alnum:].!@%*=:\\\\/?_+-]+/',
                                                                                              'hashname' => '__PATTERN1__',
                                                                                              'mod' => '',
                                                                                              'rdelim' => '/',
                                                                                              'pattern' => '[[:alnum:].!@%*=:\\/?_+-]+'
                                                                                            }, 'Parse::RecDescent::Token' )
                                                                                   ],
                                                                        'error' => undef,
                                                                        'actcount' => 0
                                                                      }, 'Parse::RecDescent::Production' ),
                                                               bless( {
                                                                        'number' => 1,
                                                                        'uncommit' => undef,
                                                                        'strcount' => 0,
                                                                        'dircount' => 0,
                                                                        'error' => undef,
                                                                        'actcount' => 1,
                                                                        'patcount' => 1,
                                                                        'line' => 7,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'mod' => '',
                                                                                              'hashname' => '__PATTERN1__',
                                                                                              'description' => '/"(?:[^"]|\\\\\\\\.)*"/',
                                                                                              'lookahead' => 0,
                                                                                              'line' => 7,
                                                                                              'ldelim' => '/',
                                                                                              'pattern' => '"(?:[^"]|\\\\.)*"',
                                                                                              'rdelim' => '/'
                                                                                            }, 'Parse::RecDescent::Token' ),
                                                                                     bless( {
                                                                                              'lookahead' => 0,
                                                                                              'line' => 7,
                                                                                              'code' => '{ Config::Maker::unquote_double($item[1]); }',
                                                                                              'hashname' => '__ACTION1__'
                                                                                            }, 'Parse::RecDescent::Action' )
                                                                                   ]
                                                                      }, 'Parse::RecDescent::Production' ),
                                                               bless( {
                                                                        'dircount' => 0,
                                                                        'uncommit' => undef,
                                                                        'number' => 2,
                                                                        'strcount' => 0,
                                                                        'line' => 8,
                                                                        'patcount' => 1,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'rdelim' => '/',
                                                                                              'pattern' => '\'(?:[^\']|\\\\.)*\'',
                                                                                              'ldelim' => '/',
                                                                                              'lookahead' => 0,
                                                                                              'line' => 8,
                                                                                              'hashname' => '__PATTERN1__',
                                                                                              'description' => '/\'(?:[^\']|\\\\\\\\.)*\'/',
                                                                                              'mod' => ''
                                                                                            }, 'Parse::RecDescent::Token' ),
                                                                                     bless( {
                                                                                              'hashname' => '__ACTION1__',
                                                                                              'code' => '{ Config::Maker::unquote_single($item[1]); }',
                                                                                              'lookahead' => 0,
                                                                                              'line' => 8
                                                                                            }, 'Parse::RecDescent::Action' )
                                                                                   ],
                                                                        'error' => undef,
                                                                        'actcount' => 1
                                                                      }, 'Parse::RecDescent::Production' ),
                                                               bless( {
                                                                        'uncommit' => 0,
                                                                        'number' => 3,
                                                                        'strcount' => 0,
                                                                        'dircount' => 1,
                                                                        'error' => 1,
                                                                        'actcount' => 0,
                                                                        'line' => 9,
                                                                        'patcount' => 0,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'lookahead' => 0,
                                                                                              'line' => 9,
                                                                                              'msg' => '',
                                                                                              'hashname' => '__DIRECTIVE1__',
                                                                                              'commitonly' => ''
                                                                                            }, 'Parse::RecDescent::Error' )
                                                                                   ]
                                                                      }, 'Parse::RecDescent::Production' )
                                                             ]
                                                }, 'Parse::RecDescent::Rule' ),
                              'type' => bless( {
                                               'line' => 305,
                                               'calls' => [
                                                            'identifier'
                                                          ],
                                               'impcount' => 0,
                                               'name' => 'type',
                                               'opcount' => 0,
                                               'vars' => '',
                                               'changed' => 0,
                                               'prods' => [
                                                            bless( {
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'implicit' => undef,
                                                                                           'lookahead' => 0,
                                                                                           'line' => 306,
                                                                                           'subrule' => 'identifier',
                                                                                           'matchrule' => 0,
                                                                                           'argcode' => undef
                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                  bless( {
                                                                                           'name' => '<commit>',
                                                                                           'line' => 307,
                                                                                           'lookahead' => 0,
                                                                                           'code' => '$commit = 1',
                                                                                           'hashname' => '__DIRECTIVE1__'
                                                                                         }, 'Parse::RecDescent::Directive' ),
                                                                                  bless( {
                                                                                           'lookahead' => 0,
                                                                                           'line' => 308,
                                                                                           'hashname' => '__ACTION1__',
                                                                                           'code' => '{ eval { $arg[0]->get($item[1]); } }'
                                                                                         }, 'Parse::RecDescent::Action' )
                                                                                ],
                                                                     'line' => undef,
                                                                     'patcount' => 0,
                                                                     'actcount' => 1,
                                                                     'error' => undef,
                                                                     'dircount' => 1,
                                                                     'strcount' => 0,
                                                                     'uncommit' => undef,
                                                                     'number' => 0
                                                                   }, 'Parse::RecDescent::Production' ),
                                                            bless( {
                                                                     'error' => 1,
                                                                     'actcount' => 0,
                                                                     'line' => 309,
                                                                     'patcount' => 0,
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'msg' => ' $@',
                                                                                           'line' => 310,
                                                                                           'lookahead' => 0,
                                                                                           'hashname' => '__DIRECTIVE1__',
                                                                                           'commitonly' => '?'
                                                                                         }, 'Parse::RecDescent::Error' ),
                                                                                  bless( {
                                                                                           'hashname' => '__DIRECTIVE2__',
                                                                                           'line' => 310,
                                                                                           'lookahead' => 0,
                                                                                           'name' => '<reject>'
                                                                                         }, 'Parse::RecDescent::UncondReject' )
                                                                                ],
                                                                     'uncommit' => 0,
                                                                     'number' => 1,
                                                                     'strcount' => 0,
                                                                     'dircount' => 2
                                                                   }, 'Parse::RecDescent::Production' )
                                                          ]
                                             }, 'Parse::RecDescent::Rule' ),
                              'value_pair' => bless( {
                                                     'prods' => [
                                                                  bless( {
                                                                           'dircount' => 0,
                                                                           'uncommit' => undef,
                                                                           'number' => 0,
                                                                           'strcount' => 0,
                                                                           'line' => undef,
                                                                           'patcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'implicit' => undef,
                                                                                                 'subrule' => 'value_$arg[0][0]',
                                                                                                 'line' => 380,
                                                                                                 'lookahead' => 0,
                                                                                                 'matchrule' => 1,
                                                                                                 'argcode' => '[$arg[0][1..$#{$arg[0]}]]'
                                                                                               }, 'Parse::RecDescent::Subrule' ),
                                                                                        bless( {
                                                                                                 'matchrule' => 1,
                                                                                                 'argcode' => '[$arg[1][1..$#{$arg[1]}]]',
                                                                                                 'subrule' => 'value_$arg[1][0]',
                                                                                                 'line' => 381,
                                                                                                 'lookahead' => 0,
                                                                                                 'implicit' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' ),
                                                                                        bless( {
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 383,
                                                                                                 'hashname' => '__ACTION1__',
                                                                                                 'code' => '{ new Config::Maker::Value::List [$item[1], $item[-1]]; }'
                                                                                               }, 'Parse::RecDescent::Action' )
                                                                                      ],
                                                                           'error' => undef,
                                                                           'actcount' => 1
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'strcount' => 0,
                                                                           'number' => 1,
                                                                           'uncommit' => 0,
                                                                           'dircount' => 1,
                                                                           'actcount' => 0,
                                                                           'error' => 1,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'line' => 384,
                                                                                                 'lookahead' => 0,
                                                                                                 'msg' => '',
                                                                                                 'commitonly' => '',
                                                                                                 'hashname' => '__DIRECTIVE1__'
                                                                                               }, 'Parse::RecDescent::Error' )
                                                                                      ],
                                                                           'patcount' => 0,
                                                                           'line' => 384
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'changed' => 0,
                                                     'opcount' => 0,
                                                     'vars' => '',
                                                     'calls' => [],
                                                     'line' => 379,
                                                     'impcount' => 0,
                                                     'name' => 'value_pair'
                                                   }, 'Parse::RecDescent::Rule' ),
                              'space' => bless( {
                                                'prods' => [
                                                             bless( {
                                                                      'dircount' => 1,
                                                                      'uncommit' => undef,
                                                                      'number' => 0,
                                                                      'strcount' => 0,
                                                                      'line' => undef,
                                                                      'patcount' => 1,
                                                                      'items' => [
                                                                                   bless( {
                                                                                            'name' => '<skip: \'\'>',
                                                                                            'lookahead' => 0,
                                                                                            'line' => 279,
                                                                                            'hashname' => '__DIRECTIVE1__',
                                                                                            'code' => 'my $oldskip = $skip; $skip= \'\'; $oldskip'
                                                                                          }, 'Parse::RecDescent::Directive' ),
                                                                                   bless( {
                                                                                            'rdelim' => '/',
                                                                                            'pattern' => '[ \\t]*\\n?',
                                                                                            'line' => 279,
                                                                                            'lookahead' => 0,
                                                                                            'ldelim' => '/',
                                                                                            'mod' => '',
                                                                                            'hashname' => '__PATTERN1__',
                                                                                            'description' => '/[ \\\\t]*\\\\n?/'
                                                                                          }, 'Parse::RecDescent::Token' )
                                                                                 ],
                                                                      'error' => undef,
                                                                      'actcount' => 0
                                                                    }, 'Parse::RecDescent::Production' )
                                                           ],
                                                'opcount' => 0,
                                                'vars' => '',
                                                'line' => 279,
                                                'calls' => [],
                                                'name' => 'space',
                                                'impcount' => 0,
                                                'changed' => 0
                                              }, 'Parse::RecDescent::Rule' ),
                              'value_list' => bless( {
                                                     'prods' => [
                                                                  bless( {
                                                                           'strcount' => 0,
                                                                           'number' => 0,
                                                                           'uncommit' => undef,
                                                                           'dircount' => 0,
                                                                           'actcount' => 1,
                                                                           'error' => undef,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'expected' => undef,
                                                                                                 'subrule' => 'value',
                                                                                                 'repspec' => 's',
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 358,
                                                                                                 'argcode' => '[@arg]',
                                                                                                 'matchrule' => 0,
                                                                                                 'min' => 1,
                                                                                                 'max' => 100000000
                                                                                               }, 'Parse::RecDescent::Repetition' ),
                                                                                        bless( {
                                                                                                 'hashname' => '__ACTION1__',
                                                                                                 'code' => '{ new Config::Maker::Value::List($item[1]); }',
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 359
                                                                                               }, 'Parse::RecDescent::Action' )
                                                                                      ],
                                                                           'patcount' => 0,
                                                                           'line' => undef
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'commitonly' => '',
                                                                                                 'hashname' => '__DIRECTIVE1__',
                                                                                                 'msg' => '',
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 360
                                                                                               }, 'Parse::RecDescent::Error' )
                                                                                      ],
                                                                           'patcount' => 0,
                                                                           'line' => 360,
                                                                           'actcount' => 0,
                                                                           'error' => 1,
                                                                           'dircount' => 1,
                                                                           'strcount' => 0,
                                                                           'number' => 1,
                                                                           'uncommit' => 0
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'changed' => 0,
                                                     'calls' => [
                                                                  'value'
                                                                ],
                                                     'line' => 356,
                                                     'name' => 'value_list',
                                                     'impcount' => 0,
                                                     'opcount' => 0,
                                                     'vars' => ''
                                                   }, 'Parse::RecDescent::Rule' ),
                              'body' => bless( {
                                               'prods' => [
                                                            bless( {
                                                                     'strcount' => 0,
                                                                     'uncommit' => undef,
                                                                     'number' => 0,
                                                                     'dircount' => 0,
                                                                     'actcount' => 0,
                                                                     'error' => undef,
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'implicit' => undef,
                                                                                           'line' => 316,
                                                                                           'lookahead' => 0,
                                                                                           'subrule' => 'body_$arg[1]',
                                                                                           'argcode' => '[$arg[0], @arg[2..$#arg]]',
                                                                                           'matchrule' => 1
                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                ],
                                                                     'line' => undef,
                                                                     'patcount' => 0
                                                                   }, 'Parse::RecDescent::Production' )
                                                          ],
                                               'changed' => 0,
                                               'vars' => '',
                                               'opcount' => 0,
                                               'line' => 314,
                                               'calls' => [],
                                               'impcount' => 0,
                                               'name' => 'body'
                                             }, 'Parse::RecDescent::Rule' ),
                              'value_nested_list' => bless( {
                                                            'prods' => [
                                                                         bless( {
                                                                                  'uncommit' => undef,
                                                                                  'number' => 0,
                                                                                  'strcount' => 2,
                                                                                  'dircount' => 0,
                                                                                  'error' => undef,
                                                                                  'actcount' => 1,
                                                                                  'line' => undef,
                                                                                  'patcount' => 0,
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'line' => 368,
                                                                                                        'lookahead' => 0,
                                                                                                        'description' => '\'[\'',
                                                                                                        'hashname' => '__STRING1__',
                                                                                                        'pattern' => '['
                                                                                                      }, 'Parse::RecDescent::Literal' ),
                                                                                               bless( {
                                                                                                        'matchrule' => 0,
                                                                                                        'argcode' => '[@arg]',
                                                                                                        'min' => 0,
                                                                                                        'line' => 368,
                                                                                                        'lookahead' => 0,
                                                                                                        'max' => 100000000,
                                                                                                        'expected' => undef,
                                                                                                        'subrule' => 'value_nestlist_elem',
                                                                                                        'repspec' => 's?'
                                                                                                      }, 'Parse::RecDescent::Repetition' ),
                                                                                               bless( {
                                                                                                        'hashname' => '__STRING2__',
                                                                                                        'pattern' => ']',
                                                                                                        'description' => '\']\'',
                                                                                                        'lookahead' => 0,
                                                                                                        'line' => 368
                                                                                                      }, 'Parse::RecDescent::Literal' ),
                                                                                               bless( {
                                                                                                        'lookahead' => 0,
                                                                                                        'line' => 369,
                                                                                                        'code' => '{ new Config::Maker::Value::List($item[2]); }',
                                                                                                        'hashname' => '__ACTION1__'
                                                                                                      }, 'Parse::RecDescent::Action' )
                                                                                             ]
                                                                                }, 'Parse::RecDescent::Production' ),
                                                                         bless( {
                                                                                  'items' => [
                                                                                               bless( {
                                                                                                        'commitonly' => '',
                                                                                                        'hashname' => '__DIRECTIVE1__',
                                                                                                        'msg' => '',
                                                                                                        'lookahead' => 0,
                                                                                                        'line' => 370
                                                                                                      }, 'Parse::RecDescent::Error' )
                                                                                             ],
                                                                                  'line' => 370,
                                                                                  'patcount' => 0,
                                                                                  'actcount' => 0,
                                                                                  'error' => 1,
                                                                                  'dircount' => 1,
                                                                                  'strcount' => 0,
                                                                                  'uncommit' => 0,
                                                                                  'number' => 1
                                                                                }, 'Parse::RecDescent::Production' )
                                                                       ],
                                                            'opcount' => 0,
                                                            'vars' => '',
                                                            'line' => 367,
                                                            'calls' => [
                                                                         'value_nestlist_elem'
                                                                       ],
                                                            'impcount' => 0,
                                                            'name' => 'value_nested_list',
                                                            'changed' => 0
                                                          }, 'Parse::RecDescent::Rule' ),
                              'eof' => bless( {
                                              'prods' => [
                                                           bless( {
                                                                    'items' => [
                                                                                 bless( {
                                                                                          'rdelim' => '/',
                                                                                          'pattern' => '^\\Z',
                                                                                          'ldelim' => '/',
                                                                                          'line' => 33,
                                                                                          'lookahead' => 0,
                                                                                          'hashname' => '__PATTERN1__',
                                                                                          'description' => '/^\\\\Z/',
                                                                                          'mod' => ''
                                                                                        }, 'Parse::RecDescent::Token' )
                                                                               ],
                                                                    'patcount' => 1,
                                                                    'line' => undef,
                                                                    'actcount' => 0,
                                                                    'error' => undef,
                                                                    'dircount' => 0,
                                                                    'strcount' => 0,
                                                                    'number' => 0,
                                                                    'uncommit' => undef
                                                                  }, 'Parse::RecDescent::Production' )
                                                         ],
                                              'changed' => 0,
                                              'impcount' => 0,
                                              'name' => 'eof',
                                              'line' => 31,
                                              'calls' => [],
                                              'vars' => '',
                                              'opcount' => 0
                                            }, 'Parse::RecDescent::Rule' ),
                              'value_dns_name' => bless( {
                                                         'changed' => 0,
                                                         'calls' => [],
                                                         'line' => 398,
                                                         'impcount' => 0,
                                                         'name' => 'value_dns_name',
                                                         'opcount' => 0,
                                                         'vars' => '',
                                                         'prods' => [
                                                                      bless( {
                                                                               'dircount' => 0,
                                                                               'strcount' => 0,
                                                                               'number' => 0,
                                                                               'uncommit' => undef,
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'pattern' => '[a-zA-Z0-9-]+',
                                                                                                     'rdelim' => '/',
                                                                                                     'description' => '/[a-zA-Z0-9-]+/',
                                                                                                     'hashname' => '__PATTERN1__',
                                                                                                     'mod' => '',
                                                                                                     'ldelim' => '/',
                                                                                                     'line' => 399,
                                                                                                     'lookahead' => 0
                                                                                                   }, 'Parse::RecDescent::Token' )
                                                                                          ],
                                                                               'patcount' => 1,
                                                                               'line' => undef,
                                                                               'actcount' => 0,
                                                                               'error' => undef
                                                                             }, 'Parse::RecDescent::Production' ),
                                                                      bless( {
                                                                               'patcount' => 0,
                                                                               'line' => 400,
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'line' => 400,
                                                                                                     'lookahead' => 0,
                                                                                                     'msg' => '',
                                                                                                     'hashname' => '__DIRECTIVE1__',
                                                                                                     'commitonly' => ''
                                                                                                   }, 'Parse::RecDescent::Error' )
                                                                                          ],
                                                                               'error' => 1,
                                                                               'actcount' => 0,
                                                                               'dircount' => 1,
                                                                               'number' => 1,
                                                                               'uncommit' => 0,
                                                                               'strcount' => 0
                                                                             }, 'Parse::RecDescent::Production' )
                                                                    ]
                                                       }, 'Parse::RecDescent::Rule' ),
                              'value_perlcode' => bless( {
                                                         'prods' => [
                                                                      bless( {
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'matchrule' => 0,
                                                                                                     'argcode' => '[@arg]',
                                                                                                     'line' => 387,
                                                                                                     'lookahead' => 0,
                                                                                                     'subrule' => 'perl_codeblock',
                                                                                                     'implicit' => undef
                                                                                                   }, 'Parse::RecDescent::Subrule' )
                                                                                          ],
                                                                               'patcount' => 0,
                                                                               'line' => undef,
                                                                               'actcount' => 0,
                                                                               'error' => undef,
                                                                               'dircount' => 0,
                                                                               'strcount' => 0,
                                                                               'number' => 0,
                                                                               'uncommit' => undef
                                                                             }, 'Parse::RecDescent::Production' ),
                                                                      bless( {
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'msg' => '',
                                                                                                     'line' => 388,
                                                                                                     'lookahead' => 0,
                                                                                                     'commitonly' => '',
                                                                                                     'hashname' => '__DIRECTIVE1__'
                                                                                                   }, 'Parse::RecDescent::Error' )
                                                                                          ],
                                                                               'patcount' => 0,
                                                                               'line' => 388,
                                                                               'actcount' => 0,
                                                                               'error' => 1,
                                                                               'dircount' => 1,
                                                                               'strcount' => 0,
                                                                               'number' => 1,
                                                                               'uncommit' => 0
                                                                             }, 'Parse::RecDescent::Production' )
                                                                    ],
                                                         'changed' => 0,
                                                         'name' => 'value_perlcode',
                                                         'impcount' => 0,
                                                         'line' => 386,
                                                         'calls' => [
                                                                      'perl_codeblock'
                                                                    ],
                                                         'vars' => '',
                                                         'opcount' => 0
                                                       }, 'Parse::RecDescent::Rule' ),
                              'option' => bless( {
                                                 'prods' => [
                                                              bless( {
                                                                       'actcount' => 0,
                                                                       'error' => undef,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'implicit' => undef,
                                                                                             'argcode' => '[@arg]',
                                                                                             'matchrule' => 0,
                                                                                             'subrule' => 'block',
                                                                                             'line' => 295,
                                                                                             'lookahead' => 0
                                                                                           }, 'Parse::RecDescent::Subrule' )
                                                                                  ],
                                                                       'line' => undef,
                                                                       'patcount' => 0,
                                                                       'strcount' => 0,
                                                                       'uncommit' => undef,
                                                                       'number' => 0,
                                                                       'dircount' => 0
                                                                     }, 'Parse::RecDescent::Production' ),
                                                              bless( {
                                                                       'dircount' => 1,
                                                                       'number' => 1,
                                                                       'uncommit' => undef,
                                                                       'strcount' => 0,
                                                                       'patcount' => 0,
                                                                       'line' => 296,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'matchrule' => 0,
                                                                                             'argcode' => '[@arg]',
                                                                                             'lookahead' => 0,
                                                                                             'line' => 297,
                                                                                             'subrule' => 'type',
                                                                                             'implicit' => undef
                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                    bless( {
                                                                                             'name' => '<commit>',
                                                                                             'line' => 297,
                                                                                             'lookahead' => 0,
                                                                                             'hashname' => '__DIRECTIVE1__',
                                                                                             'code' => '$commit = 1'
                                                                                           }, 'Parse::RecDescent::Directive' ),
                                                                                    bless( {
                                                                                             'implicit' => undef,
                                                                                             'argcode' => '[$item[1], $item[1]->body]',
                                                                                             'matchrule' => 0,
                                                                                             'subrule' => 'body',
                                                                                             'line' => 298,
                                                                                             'lookahead' => 0
                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                    bless( {
                                                                                             'hashname' => '__ACTION1__',
                                                                                             'code' => '{
	    $item[1]->instantiate($item[3]);
	}',
                                                                                             'lookahead' => 0,
                                                                                             'line' => 299
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ],
                                                                       'error' => undef,
                                                                       'actcount' => 1
                                                                     }, 'Parse::RecDescent::Production' ),
                                                              bless( {
                                                                       'error' => 1,
                                                                       'actcount' => 0,
                                                                       'line' => 302,
                                                                       'patcount' => 0,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'commitonly' => '?',
                                                                                             'hashname' => '__DIRECTIVE1__',
                                                                                             'lookahead' => 0,
                                                                                             'line' => 303,
                                                                                             'msg' => ''
                                                                                           }, 'Parse::RecDescent::Error' ),
                                                                                    bless( {
                                                                                             'name' => '<reject>',
                                                                                             'line' => 303,
                                                                                             'lookahead' => 0,
                                                                                             'hashname' => '__DIRECTIVE2__'
                                                                                           }, 'Parse::RecDescent::UncondReject' )
                                                                                  ],
                                                                       'uncommit' => 0,
                                                                       'number' => 2,
                                                                       'strcount' => 0,
                                                                       'dircount' => 2
                                                                     }, 'Parse::RecDescent::Production' )
                                                            ],
                                                 'line' => 293,
                                                 'calls' => [
                                                              'block',
                                                              'type',
                                                              'body'
                                                            ],
                                                 'impcount' => 0,
                                                 'name' => 'option',
                                                 'opcount' => 0,
                                                 'vars' => '',
                                                 'changed' => 0
                                               }, 'Parse::RecDescent::Rule' ),
                              'glob' => bless( {
                                               'prods' => [
                                                            bless( {
                                                                     'number' => 0,
                                                                     'uncommit' => undef,
                                                                     'strcount' => 0,
                                                                     'dircount' => 0,
                                                                     'error' => undef,
                                                                     'actcount' => 0,
                                                                     'patcount' => 1,
                                                                     'line' => undef,
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'pattern' => '([[:alnum:].@%*=?|_\\[\\]{}-]|\\\\.)+',
                                                                                           'rdelim' => '/',
                                                                                           'mod' => '',
                                                                                           'hashname' => '__PATTERN1__',
                                                                                           'description' => '/([[:alnum:].@%*=?|_\\\\[\\\\]\\{\\}-]|\\\\\\\\.)+/',
                                                                                           'line' => 105,
                                                                                           'lookahead' => 0,
                                                                                           'ldelim' => '/'
                                                                                         }, 'Parse::RecDescent::Token' )
                                                                                ]
                                                                   }, 'Parse::RecDescent::Production' )
                                                          ],
                                               'vars' => '',
                                               'opcount' => 0,
                                               'impcount' => 0,
                                               'name' => 'glob',
                                               'line' => 105,
                                               'calls' => [],
                                               'changed' => 0
                                             }, 'Parse::RecDescent::Rule' ),
                              'body_simple' => bless( {
                                                      'prods' => [
                                                                   bless( {
                                                                            'strcount' => 1,
                                                                            'uncommit' => undef,
                                                                            'number' => 0,
                                                                            'dircount' => 0,
                                                                            'actcount' => 1,
                                                                            'error' => undef,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'lookahead' => 0,
                                                                                                  'line' => 329,
                                                                                                  'subrule' => 'value',
                                                                                                  'matchrule' => 0,
                                                                                                  'argcode' => '[@{$arg[1]}]',
                                                                                                  'implicit' => undef
                                                                                                }, 'Parse::RecDescent::Subrule' ),
                                                                                         bless( {
                                                                                                  'line' => 329,
                                                                                                  'lookahead' => 0,
                                                                                                  'description' => '\';\'',
                                                                                                  'hashname' => '__STRING1__',
                                                                                                  'pattern' => ';'
                                                                                                }, 'Parse::RecDescent::Literal' ),
                                                                                         bless( {
                                                                                                  'lookahead' => 0,
                                                                                                  'line' => 330,
                                                                                                  'hashname' => '__ACTION1__',
                                                                                                  'code' => '{ +{ -value => $item[1] }; }'
                                                                                                }, 'Parse::RecDescent::Action' )
                                                                                       ],
                                                                            'line' => undef,
                                                                            'patcount' => 0
                                                                          }, 'Parse::RecDescent::Production' ),
                                                                   bless( {
                                                                            'error' => 1,
                                                                            'actcount' => 0,
                                                                            'line' => 331,
                                                                            'patcount' => 0,
                                                                            'items' => [
                                                                                         bless( {
                                                                                                  'msg' => '',
                                                                                                  'line' => 331,
                                                                                                  'lookahead' => 0,
                                                                                                  'hashname' => '__DIRECTIVE1__',
                                                                                                  'commitonly' => ''
                                                                                                }, 'Parse::RecDescent::Error' )
                                                                                       ],
                                                                            'uncommit' => 0,
                                                                            'number' => 1,
                                                                            'strcount' => 0,
                                                                            'dircount' => 1
                                                                          }, 'Parse::RecDescent::Production' )
                                                                 ],
                                                      'opcount' => 0,
                                                      'vars' => '',
                                                      'impcount' => 0,
                                                      'name' => 'body_simple',
                                                      'line' => 328,
                                                      'calls' => [
                                                                   'value'
                                                                 ],
                                                      'changed' => 0
                                                    }, 'Parse::RecDescent::Rule' ),
                              'value_ipv4_mask' => bless( {
                                                          'changed' => 0,
                                                          'opcount' => 0,
                                                          'vars' => '',
                                                          'line' => 421,
                                                          'calls' => [
                                                                       'value_ipv4',
                                                                       '_alternation_1_of_production_1_of_rule_value_ipv4_mask'
                                                                     ],
                                                          'impcount' => 0,
                                                          'name' => 'value_ipv4_mask',
                                                          'prods' => [
                                                                       bless( {
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'hashname' => '__DIRECTIVE1__',
                                                                                                      'code' => 'my $oldskip = $skip; $skip= \'\'; $oldskip',
                                                                                                      'name' => '<skip: \'\'>',
                                                                                                      'lookahead' => 0,
                                                                                                      'line' => 422
                                                                                                    }, 'Parse::RecDescent::Directive' ),
                                                                                             bless( {
                                                                                                      'line' => 422,
                                                                                                      'subrule' => 'value_ipv4',
                                                                                                      'lookahead' => 0,
                                                                                                      'matchrule' => 0,
                                                                                                      'argcode' => undef,
                                                                                                      'implicit' => undef
                                                                                                    }, 'Parse::RecDescent::Subrule' ),
                                                                                             bless( {
                                                                                                      'pattern' => '/',
                                                                                                      'hashname' => '__STRING1__',
                                                                                                      'description' => '\'/\'',
                                                                                                      'line' => 422,
                                                                                                      'lookahead' => 0
                                                                                                    }, 'Parse::RecDescent::Literal' ),
                                                                                             bless( {
                                                                                                      'implicit' => 'decint, or value_ipv4',
                                                                                                      'line' => 422,
                                                                                                      'lookahead' => 0,
                                                                                                      'subrule' => '_alternation_1_of_production_1_of_rule_value_ipv4_mask',
                                                                                                      'matchrule' => 0,
                                                                                                      'argcode' => undef
                                                                                                    }, 'Parse::RecDescent::Subrule' ),
                                                                                             bless( {
                                                                                                      'lookahead' => 0,
                                                                                                      'line' => 423,
                                                                                                      'code' => '{ "$item[2]/$item[-1]"; }',
                                                                                                      'hashname' => '__ACTION1__'
                                                                                                    }, 'Parse::RecDescent::Action' )
                                                                                           ],
                                                                                'patcount' => 0,
                                                                                'line' => undef,
                                                                                'actcount' => 1,
                                                                                'error' => undef,
                                                                                'dircount' => 1,
                                                                                'strcount' => 1,
                                                                                'number' => 0,
                                                                                'uncommit' => undef
                                                                              }, 'Parse::RecDescent::Production' ),
                                                                       bless( {
                                                                                'strcount' => 0,
                                                                                'number' => 1,
                                                                                'uncommit' => 0,
                                                                                'dircount' => 1,
                                                                                'actcount' => 0,
                                                                                'error' => 1,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'hashname' => '__DIRECTIVE1__',
                                                                                                      'commitonly' => '',
                                                                                                      'lookahead' => 0,
                                                                                                      'line' => 424,
                                                                                                      'msg' => ''
                                                                                                    }, 'Parse::RecDescent::Error' )
                                                                                           ],
                                                                                'patcount' => 0,
                                                                                'line' => 424
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ]
                                                        }, 'Parse::RecDescent::Rule' ),
                              'byte' => bless( {
                                               'changed' => 0,
                                               'opcount' => 0,
                                               'vars' => '',
                                               'name' => 'byte',
                                               'impcount' => 0,
                                               'line' => 406,
                                               'calls' => [
                                                            'decint'
                                                          ],
                                               'prods' => [
                                                            bless( {
                                                                     'dircount' => 0,
                                                                     'strcount' => 0,
                                                                     'number' => 0,
                                                                     'uncommit' => undef,
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'implicit' => undef,
                                                                                           'subrule' => 'decint',
                                                                                           'line' => 406,
                                                                                           'lookahead' => 0,
                                                                                           'matchrule' => 0,
                                                                                           'argcode' => '[0,255]'
                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                ],
                                                                     'patcount' => 0,
                                                                     'line' => undef,
                                                                     'actcount' => 0,
                                                                     'error' => undef
                                                                   }, 'Parse::RecDescent::Production' )
                                                          ]
                                             }, 'Parse::RecDescent::Rule' ),
                              'decint' => bless( {
                                                 'line' => 21,
                                                 'calls' => [],
                                                 'impcount' => 0,
                                                 'name' => 'decint',
                                                 'vars' => '',
                                                 'opcount' => 0,
                                                 'changed' => 0,
                                                 'prods' => [
                                                              bless( {
                                                                       'actcount' => 1,
                                                                       'error' => undef,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'ldelim' => '/',
                                                                                             'lookahead' => 0,
                                                                                             'line' => 22,
                                                                                             'hashname' => '__PATTERN1__',
                                                                                             'description' => '/[+-]\\\\d+/',
                                                                                             'mod' => '',
                                                                                             'rdelim' => '/',
                                                                                             'pattern' => '[+-]\\d+'
                                                                                           }, 'Parse::RecDescent::Token' ),
                                                                                    bless( {
                                                                                             'name' => '<commit>',
                                                                                             'line' => 22,
                                                                                             'lookahead' => 0,
                                                                                             'hashname' => '__DIRECTIVE1__',
                                                                                             'code' => '$commit = 1'
                                                                                           }, 'Parse::RecDescent::Directive' ),
                                                                                    bless( {
                                                                                             'line' => 22,
                                                                                             'lookahead' => 0,
                                                                                             'hashname' => '__ACTION1__',
                                                                                             'code' => '{ Config::Maker::limit(0 + $item[1], @arg); }'
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ],
                                                                       'patcount' => 1,
                                                                       'line' => undef,
                                                                       'strcount' => 0,
                                                                       'number' => 0,
                                                                       'uncommit' => undef,
                                                                       'dircount' => 1
                                                                     }, 'Parse::RecDescent::Production' ),
                                                              bless( {
                                                                       'strcount' => 0,
                                                                       'number' => 1,
                                                                       'uncommit' => undef,
                                                                       'dircount' => 1,
                                                                       'actcount' => 1,
                                                                       'error' => undef,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'rdelim' => '/',
                                                                                             'pattern' => '[1-9]\\d*|0',
                                                                                             'ldelim' => '/',
                                                                                             'lookahead' => 0,
                                                                                             'line' => 24,
                                                                                             'hashname' => '__PATTERN1__',
                                                                                             'description' => '/[1-9]\\\\d*|0/',
                                                                                             'mod' => ''
                                                                                           }, 'Parse::RecDescent::Token' ),
                                                                                    bless( {
                                                                                             'code' => '$commit = 1',
                                                                                             'hashname' => '__DIRECTIVE1__',
                                                                                             'lookahead' => 0,
                                                                                             'line' => 24,
                                                                                             'name' => '<commit>'
                                                                                           }, 'Parse::RecDescent::Directive' ),
                                                                                    bless( {
                                                                                             'hashname' => '__ACTION1__',
                                                                                             'code' => '{ Config::Maker::limit(0 + $item[1], @arg); }',
                                                                                             'lookahead' => 0,
                                                                                             'line' => 24
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ],
                                                                       'patcount' => 1,
                                                                       'line' => 23
                                                                     }, 'Parse::RecDescent::Production' ),
                                                              bless( {
                                                                       'dircount' => 2,
                                                                       'uncommit' => 0,
                                                                       'number' => 2,
                                                                       'strcount' => 0,
                                                                       'line' => 25,
                                                                       'patcount' => 0,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'commitonly' => '?',
                                                                                             'hashname' => '__DIRECTIVE1__',
                                                                                             'msg' => ' Number $item[1] out of range',
                                                                                             'line' => 26,
                                                                                             'lookahead' => 0
                                                                                           }, 'Parse::RecDescent::Error' ),
                                                                                    bless( {
                                                                                             'hashname' => '__DIRECTIVE2__',
                                                                                             'name' => '<reject>',
                                                                                             'line' => 26,
                                                                                             'lookahead' => 0
                                                                                           }, 'Parse::RecDescent::UncondReject' )
                                                                                  ],
                                                                       'error' => 1,
                                                                       'actcount' => 0
                                                                     }, 'Parse::RecDescent::Production' )
                                                            ]
                                               }, 'Parse::RecDescent::Rule' ),
                              '_alternation_1_of_production_1_of_rule_value_ipv4_mask' => bless( {
                                                                                                 'prods' => [
                                                                                                              bless( {
                                                                                                                       'dircount' => 0,
                                                                                                                       'strcount' => 0,
                                                                                                                       'number' => 0,
                                                                                                                       'uncommit' => undef,
                                                                                                                       'items' => [
                                                                                                                                    bless( {
                                                                                                                                             'implicit' => undef,
                                                                                                                                             'subrule' => 'decint',
                                                                                                                                             'line' => 432,
                                                                                                                                             'lookahead' => 0,
                                                                                                                                             'argcode' => '[0,32]',
                                                                                                                                             'matchrule' => 0
                                                                                                                                           }, 'Parse::RecDescent::Subrule' )
                                                                                                                                  ],
                                                                                                                       'patcount' => 0,
                                                                                                                       'line' => undef,
                                                                                                                       'actcount' => 0,
                                                                                                                       'error' => undef
                                                                                                                     }, 'Parse::RecDescent::Production' ),
                                                                                                              bless( {
                                                                                                                       'number' => 1,
                                                                                                                       'uncommit' => undef,
                                                                                                                       'strcount' => 0,
                                                                                                                       'dircount' => 0,
                                                                                                                       'error' => undef,
                                                                                                                       'actcount' => 0,
                                                                                                                       'patcount' => 0,
                                                                                                                       'line' => 432,
                                                                                                                       'items' => [
                                                                                                                                    bless( {
                                                                                                                                             'subrule' => 'value_ipv4',
                                                                                                                                             'line' => 432,
                                                                                                                                             'lookahead' => 0,
                                                                                                                                             'argcode' => undef,
                                                                                                                                             'matchrule' => 0,
                                                                                                                                             'implicit' => undef
                                                                                                                                           }, 'Parse::RecDescent::Subrule' )
                                                                                                                                  ]
                                                                                                                     }, 'Parse::RecDescent::Production' )
                                                                                                            ],
                                                                                                 'opcount' => 0,
                                                                                                 'vars' => '',
                                                                                                 'impcount' => 0,
                                                                                                 'name' => '_alternation_1_of_production_1_of_rule_value_ipv4_mask',
                                                                                                 'line' => 432,
                                                                                                 'calls' => [
                                                                                                              'decint',
                                                                                                              'value_ipv4'
                                                                                                            ],
                                                                                                 'changed' => 0
                                                                                               }, 'Parse::RecDescent::Rule' ),
                              'hexint' => bless( {
                                                 'prods' => [
                                                              bless( {
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'hashname' => '__PATTERN1__',
                                                                                             'description' => '/0x[[:xdigit:]]+/',
                                                                                             'mod' => '',
                                                                                             'ldelim' => '/',
                                                                                             'line' => 12,
                                                                                             'lookahead' => 0,
                                                                                             'pattern' => '0x[[:xdigit:]]+',
                                                                                             'rdelim' => '/'
                                                                                           }, 'Parse::RecDescent::Token' ),
                                                                                    bless( {
                                                                                             'name' => '<commit>',
                                                                                             'line' => 12,
                                                                                             'lookahead' => 0,
                                                                                             'code' => '$commit = 1',
                                                                                             'hashname' => '__DIRECTIVE1__'
                                                                                           }, 'Parse::RecDescent::Directive' ),
                                                                                    bless( {
                                                                                             'lookahead' => 0,
                                                                                             'line' => 12,
                                                                                             'hashname' => '__ACTION1__',
                                                                                             'code' => '{ Config::Maker::limit(hex($item[1]), @arg); }'
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ],
                                                                       'line' => undef,
                                                                       'patcount' => 1,
                                                                       'actcount' => 1,
                                                                       'error' => undef,
                                                                       'dircount' => 1,
                                                                       'strcount' => 0,
                                                                       'uncommit' => undef,
                                                                       'number' => 0
                                                                     }, 'Parse::RecDescent::Production' ),
                                                              bless( {
                                                                       'actcount' => 0,
                                                                       'error' => 1,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'lookahead' => 0,
                                                                                             'line' => 14,
                                                                                             'msg' => ' Number $item[1] out of range',
                                                                                             'hashname' => '__DIRECTIVE1__',
                                                                                             'commitonly' => '?'
                                                                                           }, 'Parse::RecDescent::Error' ),
                                                                                    bless( {
                                                                                             'hashname' => '__DIRECTIVE2__',
                                                                                             'lookahead' => 0,
                                                                                             'line' => 14,
                                                                                             'name' => '<reject>'
                                                                                           }, 'Parse::RecDescent::UncondReject' )
                                                                                  ],
                                                                       'patcount' => 0,
                                                                       'line' => 13,
                                                                       'strcount' => 0,
                                                                       'number' => 1,
                                                                       'uncommit' => 0,
                                                                       'dircount' => 2
                                                                     }, 'Parse::RecDescent::Production' )
                                                            ],
                                                 'changed' => 0,
                                                 'opcount' => 0,
                                                 'vars' => '',
                                                 'name' => 'hexint',
                                                 'impcount' => 0,
                                                 'line' => 11,
                                                 'calls' => []
                                               }, 'Parse::RecDescent::Rule' ),
                              'opener' => bless( {
                                                 'changed' => 0,
                                                 'line' => 154,
                                                 'calls' => [
                                                              'value',
                                                              'space'
                                                            ],
                                                 'name' => 'opener',
                                                 'impcount' => 0,
                                                 'opcount' => 0,
                                                 'vars' => '',
                                                 'prods' => [
                                                              bless( {
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'line' => 155,
                                                                                             'lookahead' => 0,
                                                                                             'hashname' => '__STRING1__',
                                                                                             'description' => '\'[$\'',
                                                                                             'pattern' => '[$'
                                                                                           }, 'Parse::RecDescent::Literal' ),
                                                                                    bless( {
                                                                                             'name' => '<skip: qr/\\s*/>',
                                                                                             'lookahead' => 0,
                                                                                             'line' => 155,
                                                                                             'code' => 'my $oldskip = $skip; $skip= qr/\\s*/; $oldskip',
                                                                                             'hashname' => '__DIRECTIVE1__'
                                                                                           }, 'Parse::RecDescent::Directive' ),
                                                                                    bless( {
                                                                                             'hashname' => '__STRING2__',
                                                                                             'description' => '\'$arg[0]\'',
                                                                                             'pattern' => '$arg[0]',
                                                                                             'lookahead' => 0,
                                                                                             'line' => 155
                                                                                           }, 'Parse::RecDescent::InterpLit' ),
                                                                                    bless( {
                                                                                             'subrule' => 'value',
                                                                                             'line' => 155,
                                                                                             'lookahead' => 0,
                                                                                             'argcode' => '[@arg[1..$#arg]]',
                                                                                             'matchrule' => 0,
                                                                                             'implicit' => undef
                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                    bless( {
                                                                                             'hashname' => '__STRING3__',
                                                                                             'description' => '\'$]\'',
                                                                                             'pattern' => '$]',
                                                                                             'line' => 155,
                                                                                             'lookahead' => 0
                                                                                           }, 'Parse::RecDescent::Literal' ),
                                                                                    bless( {
                                                                                             'implicit' => undef,
                                                                                             'line' => 155,
                                                                                             'subrule' => 'space',
                                                                                             'lookahead' => 0,
                                                                                             'argcode' => undef,
                                                                                             'matchrule' => 0
                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                    bless( {
                                                                                             'code' => '{ $item[-3]; }',
                                                                                             'hashname' => '__ACTION1__',
                                                                                             'line' => 156,
                                                                                             'lookahead' => 0
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ],
                                                                       'line' => undef,
                                                                       'patcount' => 0,
                                                                       'actcount' => 1,
                                                                       'error' => undef,
                                                                       'dircount' => 1,
                                                                       'strcount' => 3,
                                                                       'uncommit' => undef,
                                                                       'number' => 0
                                                                     }, 'Parse::RecDescent::Production' )
                                                            ]
                                               }, 'Parse::RecDescent::Rule' ),
                              'value_string' => bless( {
                                                       'changed' => 0,
                                                       'impcount' => 0,
                                                       'name' => 'value_string',
                                                       'line' => 390,
                                                       'calls' => [
                                                                    'literal'
                                                                  ],
                                                       'vars' => '',
                                                       'opcount' => 0,
                                                       'prods' => [
                                                                    bless( {
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'matchrule' => 0,
                                                                                                   'argcode' => undef,
                                                                                                   'lookahead' => 0,
                                                                                                   'line' => 392,
                                                                                                   'subrule' => 'literal',
                                                                                                   'implicit' => undef
                                                                                                 }, 'Parse::RecDescent::Subrule' )
                                                                                        ],
                                                                             'patcount' => 0,
                                                                             'line' => undef,
                                                                             'actcount' => 0,
                                                                             'error' => undef,
                                                                             'dircount' => 0,
                                                                             'strcount' => 0,
                                                                             'number' => 0,
                                                                             'uncommit' => undef
                                                                           }, 'Parse::RecDescent::Production' ),
                                                                    bless( {
                                                                             'dircount' => 1,
                                                                             'strcount' => 0,
                                                                             'uncommit' => 0,
                                                                             'number' => 1,
                                                                             'items' => [
                                                                                          bless( {
                                                                                                   'msg' => '',
                                                                                                   'line' => 393,
                                                                                                   'lookahead' => 0,
                                                                                                   'hashname' => '__DIRECTIVE1__',
                                                                                                   'commitonly' => ''
                                                                                                 }, 'Parse::RecDescent::Error' )
                                                                                        ],
                                                                             'line' => 393,
                                                                             'patcount' => 0,
                                                                             'actcount' => 0,
                                                                             'error' => 1
                                                                           }, 'Parse::RecDescent::Production' )
                                                                  ]
                                                     }, 'Parse::RecDescent::Rule' ),
                              'value_void' => bless( {
                                                     'prods' => [
                                                                  bless( {
                                                                           'number' => 0,
                                                                           'uncommit' => undef,
                                                                           'strcount' => 0,
                                                                           'dircount' => 0,
                                                                           'error' => undef,
                                                                           'actcount' => 0,
                                                                           'patcount' => 0,
                                                                           'line' => undef,
                                                                           'items' => []
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'impcount' => 0,
                                                     'name' => 'value_void',
                                                     'line' => 353,
                                                     'calls' => [],
                                                     'opcount' => 0,
                                                     'vars' => '',
                                                     'changed' => 0
                                                   }, 'Parse::RecDescent::Rule' ),
                              'path' => bless( {
                                               'prods' => [
                                                            bless( {
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'hashname' => '__STRING1__',
                                                                                           'pattern' => '',
                                                                                           'description' => '\'\'',
                                                                                           'lookahead' => 0,
                                                                                           'line' => 42
                                                                                         }, 'Parse::RecDescent::Literal' ),
                                                                                  bless( {
                                                                                           'name' => '<skip: \'\'>',
                                                                                           'line' => 42,
                                                                                           'lookahead' => 0,
                                                                                           'hashname' => '__DIRECTIVE1__',
                                                                                           'code' => 'my $oldskip = $skip; $skip= \'\'; $oldskip'
                                                                                         }, 'Parse::RecDescent::Directive' ),
                                                                                  bless( {
                                                                                           'matchrule' => 0,
                                                                                           'argcode' => undef,
                                                                                           'subrule' => 'metaroot',
                                                                                           'line' => 42,
                                                                                           'lookahead' => 0,
                                                                                           'implicit' => undef
                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                  bless( {
                                                                                           'argcode' => undef,
                                                                                           'matchrule' => 0,
                                                                                           'line' => 42,
                                                                                           'subrule' => 'relpath',
                                                                                           'lookahead' => 0,
                                                                                           'implicit' => undef
                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                  bless( {
                                                                                           'lookahead' => 0,
                                                                                           'line' => 43,
                                                                                           'code' => '{
	   new Config::Maker::Path::Meta(-tail => $item[-1]);
       }',
                                                                                           'hashname' => '__ACTION1__'
                                                                                         }, 'Parse::RecDescent::Action' )
                                                                                ],
                                                                     'line' => undef,
                                                                     'patcount' => 0,
                                                                     'actcount' => 1,
                                                                     'error' => undef,
                                                                     'dircount' => 1,
                                                                     'strcount' => 1,
                                                                     'uncommit' => undef,
                                                                     'number' => 0
                                                                   }, 'Parse::RecDescent::Production' ),
                                                            bless( {
                                                                     'uncommit' => undef,
                                                                     'number' => 1,
                                                                     'strcount' => 1,
                                                                     'dircount' => 1,
                                                                     'error' => undef,
                                                                     'actcount' => 1,
                                                                     'line' => 46,
                                                                     'patcount' => 0,
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'lookahead' => 0,
                                                                                           'line' => 46,
                                                                                           'pattern' => '',
                                                                                           'hashname' => '__STRING1__',
                                                                                           'description' => '\'\''
                                                                                         }, 'Parse::RecDescent::Literal' ),
                                                                                  bless( {
                                                                                           'code' => 'my $oldskip = $skip; $skip= \'\'; $oldskip',
                                                                                           'hashname' => '__DIRECTIVE1__',
                                                                                           'line' => 46,
                                                                                           'lookahead' => 0,
                                                                                           'name' => '<skip: \'\'>'
                                                                                         }, 'Parse::RecDescent::Directive' ),
                                                                                  bless( {
                                                                                           'implicit' => undef,
                                                                                           'matchrule' => 0,
                                                                                           'argcode' => undef,
                                                                                           'line' => 46,
                                                                                           'subrule' => 'metaroot',
                                                                                           'lookahead' => 0
                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                  bless( {
                                                                                           'code' => '{
	   new Config::Maker::Path::Meta();
       }',
                                                                                           'hashname' => '__ACTION1__',
                                                                                           'line' => 47,
                                                                                           'lookahead' => 0
                                                                                         }, 'Parse::RecDescent::Action' )
                                                                                ]
                                                                   }, 'Parse::RecDescent::Production' ),
                                                            bless( {
                                                                     'line' => 50,
                                                                     'patcount' => 0,
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'hashname' => '__STRING1__',
                                                                                           'description' => '\'\'',
                                                                                           'pattern' => '',
                                                                                           'lookahead' => 0,
                                                                                           'line' => 50
                                                                                         }, 'Parse::RecDescent::Literal' ),
                                                                                  bless( {
                                                                                           'name' => '<skip: \'\'>',
                                                                                           'lookahead' => 0,
                                                                                           'line' => 50,
                                                                                           'hashname' => '__DIRECTIVE1__',
                                                                                           'code' => 'my $oldskip = $skip; $skip= \'\'; $oldskip'
                                                                                         }, 'Parse::RecDescent::Directive' ),
                                                                                  bless( {
                                                                                           'matchrule' => 0,
                                                                                           'argcode' => undef,
                                                                                           'line' => 50,
                                                                                           'lookahead' => 0,
                                                                                           'subrule' => 'separator',
                                                                                           'implicit' => undef
                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                  bless( {
                                                                                           'argcode' => undef,
                                                                                           'matchrule' => 0,
                                                                                           'line' => 50,
                                                                                           'subrule' => 'relpath',
                                                                                           'lookahead' => 0,
                                                                                           'implicit' => undef
                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                  bless( {
                                                                                           'hashname' => '__ACTION1__',
                                                                                           'code' => '{
	   new Config::Maker::Path::Root(-tail => $item[-1]);
       }',
                                                                                           'line' => 51,
                                                                                           'lookahead' => 0
                                                                                         }, 'Parse::RecDescent::Action' )
                                                                                ],
                                                                     'error' => undef,
                                                                     'actcount' => 1,
                                                                     'dircount' => 1,
                                                                     'uncommit' => undef,
                                                                     'number' => 2,
                                                                     'strcount' => 1
                                                                   }, 'Parse::RecDescent::Production' ),
                                                            bless( {
                                                                     'line' => 54,
                                                                     'patcount' => 0,
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'hashname' => '__STRING1__',
                                                                                           'description' => '\'\'',
                                                                                           'pattern' => '',
                                                                                           'line' => 54,
                                                                                           'lookahead' => 0
                                                                                         }, 'Parse::RecDescent::Literal' ),
                                                                                  bless( {
                                                                                           'name' => '<skip: \'\'>',
                                                                                           'lookahead' => 0,
                                                                                           'line' => 54,
                                                                                           'hashname' => '__DIRECTIVE1__',
                                                                                           'code' => 'my $oldskip = $skip; $skip= \'\'; $oldskip'
                                                                                         }, 'Parse::RecDescent::Directive' ),
                                                                                  bless( {
                                                                                           'subrule' => 'separator',
                                                                                           'line' => 54,
                                                                                           'lookahead' => 0,
                                                                                           'matchrule' => 0,
                                                                                           'argcode' => undef,
                                                                                           'implicit' => undef
                                                                                         }, 'Parse::RecDescent::Subrule' ),
                                                                                  bless( {
                                                                                           'code' => '{
	   new Config::Maker::Path::Root();
       }',
                                                                                           'hashname' => '__ACTION1__',
                                                                                           'lookahead' => 0,
                                                                                           'line' => 55
                                                                                         }, 'Parse::RecDescent::Action' )
                                                                                ],
                                                                     'error' => undef,
                                                                     'actcount' => 1,
                                                                     'dircount' => 1,
                                                                     'uncommit' => undef,
                                                                     'number' => 3,
                                                                     'strcount' => 1
                                                                   }, 'Parse::RecDescent::Production' ),
                                                            bless( {
                                                                     'patcount' => 0,
                                                                     'line' => 58,
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'pattern' => '',
                                                                                           'hashname' => '__STRING1__',
                                                                                           'description' => '\'\'',
                                                                                           'lookahead' => 0,
                                                                                           'line' => 58
                                                                                         }, 'Parse::RecDescent::Literal' ),
                                                                                  bless( {
                                                                                           'line' => 58,
                                                                                           'lookahead' => 0,
                                                                                           'name' => '<skip: \'\'>',
                                                                                           'hashname' => '__DIRECTIVE1__',
                                                                                           'code' => 'my $oldskip = $skip; $skip= \'\'; $oldskip'
                                                                                         }, 'Parse::RecDescent::Directive' ),
                                                                                  bless( {
                                                                                           'implicit' => undef,
                                                                                           'subrule' => 'relpath',
                                                                                           'line' => 58,
                                                                                           'lookahead' => 0,
                                                                                           'matchrule' => 0,
                                                                                           'argcode' => undef
                                                                                         }, 'Parse::RecDescent::Subrule' )
                                                                                ],
                                                                     'error' => undef,
                                                                     'actcount' => 0,
                                                                     'dircount' => 1,
                                                                     'number' => 4,
                                                                     'uncommit' => undef,
                                                                     'strcount' => 1
                                                                   }, 'Parse::RecDescent::Production' )
                                                          ],
                                               'changed' => 0,
                                               'vars' => '',
                                               'opcount' => 0,
                                               'impcount' => 0,
                                               'name' => 'path',
                                               'line' => 42,
                                               'calls' => [
                                                            'metaroot',
                                                            'relpath',
                                                            'separator'
                                                          ]
                                             }, 'Parse::RecDescent::Rule' ),
                              'relpath' => bless( {
                                                  'prods' => [
                                                               bless( {
                                                                        'dircount' => 0,
                                                                        'number' => 0,
                                                                        'uncommit' => undef,
                                                                        'strcount' => 0,
                                                                        'patcount' => 0,
                                                                        'line' => undef,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'argcode' => '[\'**\']',
                                                                                              'matchrule' => 0,
                                                                                              'line' => 60,
                                                                                              'subrule' => 'nonglob',
                                                                                              'lookahead' => 0,
                                                                                              'implicit' => undef
                                                                                            }, 'Parse::RecDescent::Subrule' ),
                                                                                     bless( {
                                                                                              'implicit' => undef,
                                                                                              'lookahead' => 0,
                                                                                              'line' => 60,
                                                                                              'subrule' => 'ptail',
                                                                                              'matchrule' => 0,
                                                                                              'argcode' => undef
                                                                                            }, 'Parse::RecDescent::Subrule' ),
                                                                                     bless( {
                                                                                              'code' => '{
	      new Config::Maker::Path::AnyPath(@{$item[-1]});
	  }',
                                                                                              'hashname' => '__ACTION1__',
                                                                                              'lookahead' => 0,
                                                                                              'line' => 61
                                                                                            }, 'Parse::RecDescent::Action' )
                                                                                   ],
                                                                        'error' => undef,
                                                                        'actcount' => 1
                                                                      }, 'Parse::RecDescent::Production' ),
                                                               bless( {
                                                                        'error' => undef,
                                                                        'actcount' => 1,
                                                                        'line' => 64,
                                                                        'patcount' => 0,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'implicit' => undef,
                                                                                              'line' => 64,
                                                                                              'lookahead' => 0,
                                                                                              'subrule' => 'nonglob',
                                                                                              'matchrule' => 0,
                                                                                              'argcode' => '[\'..\']'
                                                                                            }, 'Parse::RecDescent::Subrule' ),
                                                                                     bless( {
                                                                                              'implicit' => undef,
                                                                                              'matchrule' => 0,
                                                                                              'argcode' => undef,
                                                                                              'line' => 64,
                                                                                              'subrule' => 'ptail',
                                                                                              'lookahead' => 0
                                                                                            }, 'Parse::RecDescent::Subrule' ),
                                                                                     bless( {
                                                                                              'code' => '{
	      new Config::Maker::Path::Parent(@{$item[-1]});
	  }',
                                                                                              'hashname' => '__ACTION1__',
                                                                                              'line' => 65,
                                                                                              'lookahead' => 0
                                                                                            }, 'Parse::RecDescent::Action' )
                                                                                   ],
                                                                        'uncommit' => undef,
                                                                        'number' => 1,
                                                                        'strcount' => 0,
                                                                        'dircount' => 0
                                                                      }, 'Parse::RecDescent::Production' ),
                                                               bless( {
                                                                        'dircount' => 0,
                                                                        'uncommit' => undef,
                                                                        'number' => 2,
                                                                        'strcount' => 0,
                                                                        'line' => 68,
                                                                        'patcount' => 0,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'implicit' => undef,
                                                                                              'argcode' => '[\'.\']',
                                                                                              'matchrule' => 0,
                                                                                              'line' => 68,
                                                                                              'subrule' => 'nonglob',
                                                                                              'lookahead' => 0
                                                                                            }, 'Parse::RecDescent::Subrule' ),
                                                                                     bless( {
                                                                                              'argcode' => undef,
                                                                                              'matchrule' => 0,
                                                                                              'subrule' => 'ptail',
                                                                                              'line' => 68,
                                                                                              'lookahead' => 0,
                                                                                              'implicit' => undef
                                                                                            }, 'Parse::RecDescent::Subrule' ),
                                                                                     bless( {
                                                                                              'lookahead' => 0,
                                                                                              'line' => 69,
                                                                                              'hashname' => '__ACTION1__',
                                                                                              'code' => '{
	      new Config::Maker::Path::This(@{$item[-1]});
	  }'
                                                                                            }, 'Parse::RecDescent::Action' )
                                                                                   ],
                                                                        'error' => undef,
                                                                        'actcount' => 1
                                                                      }, 'Parse::RecDescent::Production' ),
                                                               bless( {
                                                                        'error' => undef,
                                                                        'actcount' => 1,
                                                                        'line' => 72,
                                                                        'patcount' => 0,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'matchrule' => 0,
                                                                                              'argcode' => undef,
                                                                                              'subrule' => 'pcomponent',
                                                                                              'line' => 72,
                                                                                              'lookahead' => 0,
                                                                                              'implicit' => undef
                                                                                            }, 'Parse::RecDescent::Subrule' ),
                                                                                     bless( {
                                                                                              'argcode' => undef,
                                                                                              'matchrule' => 0,
                                                                                              'line' => 72,
                                                                                              'subrule' => 'ptail',
                                                                                              'lookahead' => 0,
                                                                                              'implicit' => undef
                                                                                            }, 'Parse::RecDescent::Subrule' ),
                                                                                     bless( {
                                                                                              'lookahead' => 0,
                                                                                              'line' => 73,
                                                                                              'hashname' => '__ACTION1__',
                                                                                              'code' => '{
	      new Config::Maker::Path(%{$item[1]}, @{$item[-1]});
	  }'
                                                                                            }, 'Parse::RecDescent::Action' )
                                                                                   ],
                                                                        'uncommit' => undef,
                                                                        'number' => 3,
                                                                        'strcount' => 0,
                                                                        'dircount' => 0
                                                                      }, 'Parse::RecDescent::Production' )
                                                             ],
                                                  'name' => 'relpath',
                                                  'impcount' => 0,
                                                  'line' => 60,
                                                  'calls' => [
                                                               'nonglob',
                                                               'ptail',
                                                               'pcomponent'
                                                             ],
                                                  'vars' => '',
                                                  'opcount' => 0,
                                                  'changed' => 0
                                                }, 'Parse::RecDescent::Rule' ),
                              'pcomponent' => bless( {
                                                     'prods' => [
                                                                  bless( {
                                                                           'dircount' => 0,
                                                                           'number' => 0,
                                                                           'uncommit' => undef,
                                                                           'strcount' => 1,
                                                                           'patcount' => 0,
                                                                           'line' => undef,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'line' => 80,
                                                                                                 'subrule' => 'glob',
                                                                                                 'lookahead' => 0,
                                                                                                 'implicit' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' ),
                                                                                        bless( {
                                                                                                 'line' => 80,
                                                                                                 'lookahead' => 0,
                                                                                                 'hashname' => '__STRING1__',
                                                                                                 'description' => '\':\'',
                                                                                                 'pattern' => ':'
                                                                                               }, 'Parse::RecDescent::Literal' ),
                                                                                        bless( {
                                                                                                 'implicit' => undef,
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 80,
                                                                                                 'subrule' => 'glob'
                                                                                               }, 'Parse::RecDescent::Subrule' ),
                                                                                        bless( {
                                                                                                 'argcode' => undef,
                                                                                                 'matchrule' => 0,
                                                                                                 'min' => 0,
                                                                                                 'line' => 80,
                                                                                                 'lookahead' => 0,
                                                                                                 'max' => 1,
                                                                                                 'subrule' => 'pcondition',
                                                                                                 'expected' => undef,
                                                                                                 'repspec' => '?'
                                                                                               }, 'Parse::RecDescent::Repetition' ),
                                                                                        bless( {
                                                                                                 'line' => 81,
                                                                                                 'lookahead' => 0,
                                                                                                 'hashname' => '__ACTION1__',
                                                                                                 'code' => '{
		 +{
		     -type => $item[1],
		     -value => $item[3],
		     ($item[-1][0] ? (-code => $item[-1][0]) : ())
		 }
	     }'
                                                                                               }, 'Parse::RecDescent::Action' )
                                                                                      ],
                                                                           'error' => undef,
                                                                           'actcount' => 1
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'error' => undef,
                                                                           'actcount' => 1,
                                                                           'line' => 88,
                                                                           'patcount' => 0,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'pattern' => ':',
                                                                                                 'hashname' => '__STRING1__',
                                                                                                 'description' => '\':\'',
                                                                                                 'line' => 88,
                                                                                                 'lookahead' => 0
                                                                                               }, 'Parse::RecDescent::Literal' ),
                                                                                        bless( {
                                                                                                 'implicit' => undef,
                                                                                                 'line' => 88,
                                                                                                 'lookahead' => 0,
                                                                                                 'subrule' => 'glob',
                                                                                                 'argcode' => undef,
                                                                                                 'matchrule' => 0
                                                                                               }, 'Parse::RecDescent::Subrule' ),
                                                                                        bless( {
                                                                                                 'matchrule' => 0,
                                                                                                 'min' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'line' => 88,
                                                                                                 'lookahead' => 0,
                                                                                                 'max' => 1,
                                                                                                 'expected' => undef,
                                                                                                 'subrule' => 'pcondition',
                                                                                                 'repspec' => '?'
                                                                                               }, 'Parse::RecDescent::Repetition' ),
                                                                                        bless( {
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 89,
                                                                                                 'hashname' => '__ACTION1__',
                                                                                                 'code' => '{
		 +{
		     -value => $item[2],
		     ($item[-1][0] ? (-code => $item[-1][0]) : ())
		 }
	     }'
                                                                                               }, 'Parse::RecDescent::Action' )
                                                                                      ],
                                                                           'uncommit' => undef,
                                                                           'number' => 1,
                                                                           'strcount' => 1,
                                                                           'dircount' => 0
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'error' => undef,
                                                                           'actcount' => 1,
                                                                           'patcount' => 0,
                                                                           'line' => 95,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'line' => 95,
                                                                                                 'subrule' => 'glob',
                                                                                                 'lookahead' => 0,
                                                                                                 'implicit' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' ),
                                                                                        bless( {
                                                                                                 'repspec' => '?',
                                                                                                 'subrule' => 'pcondition',
                                                                                                 'expected' => undef,
                                                                                                 'max' => 1,
                                                                                                 'line' => 95,
                                                                                                 'lookahead' => 0,
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'min' => 0
                                                                                               }, 'Parse::RecDescent::Repetition' ),
                                                                                        bless( {
                                                                                                 'hashname' => '__ACTION1__',
                                                                                                 'code' => '{
		 +{
		     -type => $item[1],
		     ($item[-1][0] ? (-code => $item[-1][0]) : ())
		 }
	     }',
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 96
                                                                                               }, 'Parse::RecDescent::Action' )
                                                                                      ],
                                                                           'number' => 2,
                                                                           'uncommit' => undef,
                                                                           'strcount' => 0,
                                                                           'dircount' => 0
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'vars' => '',
                                                     'opcount' => 0,
                                                     'line' => 80,
                                                     'calls' => [
                                                                  'glob',
                                                                  'pcondition'
                                                                ],
                                                     'name' => 'pcomponent',
                                                     'impcount' => 0,
                                                     'changed' => 0
                                                   }, 'Parse::RecDescent::Rule' ),
                              'perl_codeblock' => bless( {
                                                         'changed' => 0,
                                                         'calls' => [],
                                                         'line' => 35,
                                                         'name' => 'perl_codeblock',
                                                         'impcount' => 0,
                                                         'vars' => '',
                                                         'opcount' => 0,
                                                         'prods' => [
                                                                      bless( {
                                                                               'strcount' => 0,
                                                                               'number' => 0,
                                                                               'uncommit' => undef,
                                                                               'dircount' => 0,
                                                                               'actcount' => 1,
                                                                               'error' => undef,
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'line' => 36,
                                                                                                     'lookahead' => 0,
                                                                                                     'hashname' => '__ACTION1__',
                                                                                                     'code' => '{ Text::Balanced::extract_codeblock($text, \'{}()[]\', $skip, $arg[0]); }'
                                                                                                   }, 'Parse::RecDescent::Action' )
                                                                                          ],
                                                                               'patcount' => 0,
                                                                               'line' => undef
                                                                             }, 'Parse::RecDescent::Production' )
                                                                    ]
                                                       }, 'Parse::RecDescent::Rule' ),
                              'value_mac' => bless( {
                                                    'prods' => [
                                                                 bless( {
                                                                          'dircount' => 0,
                                                                          'uncommit' => undef,
                                                                          'number' => 0,
                                                                          'strcount' => 0,
                                                                          'line' => undef,
                                                                          'patcount' => 1,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'mod' => '',
                                                                                                'hashname' => '__PATTERN1__',
                                                                                                'description' => '/([[:xdigit:]]\\{2\\}:)\\{5\\}[[:xdigit:]]\\{2\\}/',
                                                                                                'line' => 427,
                                                                                                'lookahead' => 0,
                                                                                                'ldelim' => '/',
                                                                                                'pattern' => '([[:xdigit:]]{2}:){5}[[:xdigit:]]{2}',
                                                                                                'rdelim' => '/'
                                                                                              }, 'Parse::RecDescent::Token' )
                                                                                     ],
                                                                          'error' => undef,
                                                                          'actcount' => 0
                                                                        }, 'Parse::RecDescent::Production' ),
                                                                 bless( {
                                                                          'patcount' => 0,
                                                                          'line' => 428,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'hashname' => '__DIRECTIVE1__',
                                                                                                'commitonly' => '',
                                                                                                'msg' => '',
                                                                                                'line' => 428,
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::Error' )
                                                                                     ],
                                                                          'error' => 1,
                                                                          'actcount' => 0,
                                                                          'dircount' => 1,
                                                                          'number' => 1,
                                                                          'uncommit' => 0,
                                                                          'strcount' => 0
                                                                        }, 'Parse::RecDescent::Production' )
                                                               ],
                                                    'changed' => 0,
                                                    'line' => 426,
                                                    'calls' => [],
                                                    'name' => 'value_mac',
                                                    'impcount' => 0,
                                                    'opcount' => 0,
                                                    'vars' => ''
                                                  }, 'Parse::RecDescent::Rule' ),
                              'body_named_group' => bless( {
                                                           'prods' => [
                                                                        bless( {
                                                                                 'items' => [
                                                                                              bless( {
                                                                                                       'implicit' => undef,
                                                                                                       'matchrule' => 0,
                                                                                                       'argcode' => '[@{$arg[1]}]',
                                                                                                       'subrule' => 'value',
                                                                                                       'line' => 339,
                                                                                                       'lookahead' => 0
                                                                                                     }, 'Parse::RecDescent::Subrule' ),
                                                                                              bless( {
                                                                                                       'argcode' => '[$arg[0]]',
                                                                                                       'matchrule' => 0,
                                                                                                       'subrule' => 'block',
                                                                                                       'line' => 340,
                                                                                                       'lookahead' => 0,
                                                                                                       'implicit' => undef
                                                                                                     }, 'Parse::RecDescent::Subrule' ),
                                                                                              bless( {
                                                                                                       'hashname' => '__ACTION1__',
                                                                                                       'code' => '{ +{
	    -value => $item[1],
	    -children => $item[2],
	}; }',
                                                                                                       'line' => 341,
                                                                                                       'lookahead' => 0
                                                                                                     }, 'Parse::RecDescent::Action' )
                                                                                            ],
                                                                                 'patcount' => 0,
                                                                                 'line' => undef,
                                                                                 'actcount' => 1,
                                                                                 'error' => undef,
                                                                                 'dircount' => 0,
                                                                                 'strcount' => 0,
                                                                                 'number' => 0,
                                                                                 'uncommit' => undef
                                                                               }, 'Parse::RecDescent::Production' ),
                                                                        bless( {
                                                                                 'actcount' => 0,
                                                                                 'error' => 1,
                                                                                 'items' => [
                                                                                              bless( {
                                                                                                       'lookahead' => 0,
                                                                                                       'line' => 345,
                                                                                                       'msg' => '',
                                                                                                       'hashname' => '__DIRECTIVE1__',
                                                                                                       'commitonly' => ''
                                                                                                     }, 'Parse::RecDescent::Error' )
                                                                                            ],
                                                                                 'line' => 345,
                                                                                 'patcount' => 0,
                                                                                 'strcount' => 0,
                                                                                 'uncommit' => 0,
                                                                                 'number' => 1,
                                                                                 'dircount' => 1
                                                                               }, 'Parse::RecDescent::Production' )
                                                                      ],
                                                           'changed' => 0,
                                                           'impcount' => 0,
                                                           'name' => 'body_named_group',
                                                           'calls' => [
                                                                        'value',
                                                                        'block'
                                                                      ],
                                                           'line' => 338,
                                                           'vars' => '',
                                                           'opcount' => 0
                                                         }, 'Parse::RecDescent::Rule' ),
                              'value_zero_list' => bless( {
                                                          'prods' => [
                                                                       bless( {
                                                                                'actcount' => 1,
                                                                                'error' => undef,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'expected' => undef,
                                                                                                      'subrule' => 'value',
                                                                                                      'repspec' => 's?',
                                                                                                      'line' => 363,
                                                                                                      'lookahead' => 0,
                                                                                                      'matchrule' => 0,
                                                                                                      'min' => 0,
                                                                                                      'argcode' => '[@arg]',
                                                                                                      'max' => 100000000
                                                                                                    }, 'Parse::RecDescent::Repetition' ),
                                                                                             bless( {
                                                                                                      'code' => '{ new Config::Maker::Value::List($item[1]); }',
                                                                                                      'hashname' => '__ACTION1__',
                                                                                                      'line' => 364,
                                                                                                      'lookahead' => 0
                                                                                                    }, 'Parse::RecDescent::Action' )
                                                                                           ],
                                                                                'line' => undef,
                                                                                'patcount' => 0,
                                                                                'strcount' => 0,
                                                                                'uncommit' => undef,
                                                                                'number' => 0,
                                                                                'dircount' => 0
                                                                              }, 'Parse::RecDescent::Production' ),
                                                                       bless( {
                                                                                'patcount' => 0,
                                                                                'line' => 365,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'line' => 365,
                                                                                                      'lookahead' => 0,
                                                                                                      'msg' => '',
                                                                                                      'hashname' => '__DIRECTIVE1__',
                                                                                                      'commitonly' => ''
                                                                                                    }, 'Parse::RecDescent::Error' )
                                                                                           ],
                                                                                'error' => 1,
                                                                                'actcount' => 0,
                                                                                'dircount' => 1,
                                                                                'number' => 1,
                                                                                'uncommit' => 0,
                                                                                'strcount' => 0
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'changed' => 0,
                                                          'calls' => [
                                                                       'value'
                                                                     ],
                                                          'line' => 362,
                                                          'name' => 'value_zero_list',
                                                          'impcount' => 0,
                                                          'vars' => '',
                                                          'opcount' => 0
                                                        }, 'Parse::RecDescent::Rule' ),
                              'value_port' => bless( {
                                                     'prods' => [
                                                                  bless( {
                                                                           'actcount' => 0,
                                                                           'error' => undef,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'implicit' => undef,
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 413,
                                                                                                 'subrule' => 'decint',
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => '[0,65535]'
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'line' => undef,
                                                                           'patcount' => 0,
                                                                           'strcount' => 0,
                                                                           'uncommit' => undef,
                                                                           'number' => 0,
                                                                           'dircount' => 0
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'strcount' => 0,
                                                                           'number' => 1,
                                                                           'uncommit' => 0,
                                                                           'dircount' => 1,
                                                                           'actcount' => 0,
                                                                           'error' => 1,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'hashname' => '__DIRECTIVE1__',
                                                                                                 'commitonly' => '',
                                                                                                 'line' => 414,
                                                                                                 'lookahead' => 0,
                                                                                                 'msg' => ''
                                                                                               }, 'Parse::RecDescent::Error' )
                                                                                      ],
                                                                           'patcount' => 0,
                                                                           'line' => 414
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'opcount' => 0,
                                                     'vars' => '',
                                                     'calls' => [
                                                                  'decint'
                                                                ],
                                                     'line' => 413,
                                                     'name' => 'value_port',
                                                     'impcount' => 0,
                                                     'changed' => 0
                                                   }, 'Parse::RecDescent::Rule' ),
                              'block' => bless( {
                                                'prods' => [
                                                             bless( {
                                                                      'dircount' => 0,
                                                                      'strcount' => 2,
                                                                      'number' => 0,
                                                                      'uncommit' => undef,
                                                                      'items' => [
                                                                                   bless( {
                                                                                            'lookahead' => 0,
                                                                                            'line' => 319,
                                                                                            'description' => '\'\\{\'',
                                                                                            'hashname' => '__STRING1__',
                                                                                            'pattern' => '{'
                                                                                          }, 'Parse::RecDescent::Literal' ),
                                                                                   bless( {
                                                                                            'repspec' => 's?',
                                                                                            'subrule' => 'option',
                                                                                            'expected' => undef,
                                                                                            'max' => 100000000,
                                                                                            'min' => 0,
                                                                                            'matchrule' => 0,
                                                                                            'argcode' => '[$arg[0]]',
                                                                                            'line' => 319,
                                                                                            'lookahead' => 0
                                                                                          }, 'Parse::RecDescent::Repetition' ),
                                                                                   bless( {
                                                                                            'pattern' => '}',
                                                                                            'hashname' => '__STRING2__',
                                                                                            'description' => '\'\\}\'',
                                                                                            'line' => 319,
                                                                                            'lookahead' => 0
                                                                                          }, 'Parse::RecDescent::Literal' ),
                                                                                   bless( {
                                                                                            'code' => '{ $item[2]; }',
                                                                                            'hashname' => '__ACTION1__',
                                                                                            'lookahead' => 0,
                                                                                            'line' => 320
                                                                                          }, 'Parse::RecDescent::Action' )
                                                                                 ],
                                                                      'patcount' => 0,
                                                                      'line' => undef,
                                                                      'actcount' => 1,
                                                                      'error' => undef
                                                                    }, 'Parse::RecDescent::Production' ),
                                                             bless( {
                                                                      'dircount' => 1,
                                                                      'strcount' => 2,
                                                                      'number' => 1,
                                                                      'uncommit' => undef,
                                                                      'items' => [
                                                                                   bless( {
                                                                                            'lookahead' => 0,
                                                                                            'line' => 322,
                                                                                            'hashname' => '__STRING1__',
                                                                                            'description' => '\'<\'',
                                                                                            'pattern' => '<'
                                                                                          }, 'Parse::RecDescent::Literal' ),
                                                                                   bless( {
                                                                                            'code' => 'my $oldskip = $skip; $skip= \'\'; $oldskip',
                                                                                            'hashname' => '__DIRECTIVE1__',
                                                                                            'name' => '<skip: \'\'>',
                                                                                            'line' => 322,
                                                                                            'lookahead' => 0
                                                                                          }, 'Parse::RecDescent::Directive' ),
                                                                                   bless( {
                                                                                            'rdelim' => '/',
                                                                                            'pattern' => '[^>]+',
                                                                                            'ldelim' => '/',
                                                                                            'line' => 322,
                                                                                            'lookahead' => 0,
                                                                                            'description' => '/[^>]+/',
                                                                                            'hashname' => '__PATTERN1__',
                                                                                            'mod' => ''
                                                                                          }, 'Parse::RecDescent::Token' ),
                                                                                   bless( {
                                                                                            'lookahead' => 0,
                                                                                            'line' => 322,
                                                                                            'pattern' => '>',
                                                                                            'hashname' => '__STRING2__',
                                                                                            'description' => '\'>\''
                                                                                          }, 'Parse::RecDescent::Literal' ),
                                                                                   bless( {
                                                                                            'hashname' => '__ACTION1__',
                                                                                            'code' => '{
	    Config::Maker::Config->read($item[3], $arg[0]);
	}',
                                                                                            'lookahead' => 0,
                                                                                            'line' => 323
                                                                                          }, 'Parse::RecDescent::Action' )
                                                                                 ],
                                                                      'patcount' => 1,
                                                                      'line' => 321,
                                                                      'actcount' => 1,
                                                                      'error' => undef
                                                                    }, 'Parse::RecDescent::Production' ),
                                                             bless( {
                                                                      'dircount' => 1,
                                                                      'strcount' => 0,
                                                                      'number' => 2,
                                                                      'uncommit' => 0,
                                                                      'items' => [
                                                                                   bless( {
                                                                                            'hashname' => '__DIRECTIVE1__',
                                                                                            'commitonly' => '',
                                                                                            'msg' => '',
                                                                                            'line' => 326,
                                                                                            'lookahead' => 0
                                                                                          }, 'Parse::RecDescent::Error' )
                                                                                 ],
                                                                      'patcount' => 0,
                                                                      'line' => 326,
                                                                      'actcount' => 0,
                                                                      'error' => 1
                                                                    }, 'Parse::RecDescent::Production' )
                                                           ],
                                                'changed' => 0,
                                                'line' => 318,
                                                'calls' => [
                                                             'option'
                                                           ],
                                                'impcount' => 0,
                                                'name' => 'block',
                                                'vars' => '',
                                                'opcount' => 0
                                              }, 'Parse::RecDescent::Rule' ),
                              'integer' => bless( {
                                                  'changed' => 0,
                                                  'name' => 'integer',
                                                  'impcount' => 0,
                                                  'line' => 28,
                                                  'calls' => [
                                                               'hexint',
                                                               'octint',
                                                               'decint'
                                                             ],
                                                  'opcount' => 0,
                                                  'vars' => '',
                                                  'prods' => [
                                                               bless( {
                                                                        'dircount' => 0,
                                                                        'strcount' => 0,
                                                                        'uncommit' => undef,
                                                                        'number' => 0,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'implicit' => undef,
                                                                                              'matchrule' => 0,
                                                                                              'argcode' => '[@arg]',
                                                                                              'lookahead' => 0,
                                                                                              'line' => 28,
                                                                                              'subrule' => 'hexint'
                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                   ],
                                                                        'line' => undef,
                                                                        'patcount' => 0,
                                                                        'actcount' => 0,
                                                                        'error' => undef
                                                                      }, 'Parse::RecDescent::Production' ),
                                                               bless( {
                                                                        'dircount' => 0,
                                                                        'strcount' => 0,
                                                                        'number' => 1,
                                                                        'uncommit' => undef,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'implicit' => undef,
                                                                                              'matchrule' => 0,
                                                                                              'argcode' => '[@arg]',
                                                                                              'lookahead' => 0,
                                                                                              'line' => 28,
                                                                                              'subrule' => 'octint'
                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                   ],
                                                                        'patcount' => 0,
                                                                        'line' => 28,
                                                                        'actcount' => 0,
                                                                        'error' => undef
                                                                      }, 'Parse::RecDescent::Production' ),
                                                               bless( {
                                                                        'actcount' => 0,
                                                                        'error' => undef,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'implicit' => undef,
                                                                                              'subrule' => 'decint',
                                                                                              'line' => 28,
                                                                                              'lookahead' => 0,
                                                                                              'argcode' => '[@arg]',
                                                                                              'matchrule' => 0
                                                                                            }, 'Parse::RecDescent::Subrule' )
                                                                                   ],
                                                                        'line' => 28,
                                                                        'patcount' => 0,
                                                                        'strcount' => 0,
                                                                        'uncommit' => undef,
                                                                        'number' => 2,
                                                                        'dircount' => 0
                                                                      }, 'Parse::RecDescent::Production' )
                                                             ]
                                                }, 'Parse::RecDescent::Rule' ),
                              'closer' => bless( {
                                                 'calls' => [
                                                              'space'
                                                            ],
                                                 'line' => 158,
                                                 'name' => 'closer',
                                                 'impcount' => 0,
                                                 'opcount' => 0,
                                                 'vars' => '',
                                                 'changed' => 0,
                                                 'prods' => [
                                                              bless( {
                                                                       'error' => undef,
                                                                       'actcount' => 0,
                                                                       'line' => undef,
                                                                       'patcount' => 1,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'line' => 158,
                                                                                             'lookahead' => 0,
                                                                                             'description' => '\'[$\'',
                                                                                             'hashname' => '__STRING1__',
                                                                                             'pattern' => '[$'
                                                                                           }, 'Parse::RecDescent::Literal' ),
                                                                                    bless( {
                                                                                             'lookahead' => 0,
                                                                                             'line' => 158,
                                                                                             'name' => '<skip: qr/\\s*/>',
                                                                                             'hashname' => '__DIRECTIVE1__',
                                                                                             'code' => 'my $oldskip = $skip; $skip= qr/\\s*/; $oldskip'
                                                                                           }, 'Parse::RecDescent::Directive' ),
                                                                                    bless( {
                                                                                             'hashname' => '__STRING2__',
                                                                                             'description' => '\'end$arg[0]\'',
                                                                                             'pattern' => 'end$arg[0]',
                                                                                             'lookahead' => 0,
                                                                                             'line' => 158
                                                                                           }, 'Parse::RecDescent::InterpLit' ),
                                                                                    bless( {
                                                                                             'line' => 158,
                                                                                             'lookahead' => 0,
                                                                                             'name' => '<skip: \'\'>',
                                                                                             'code' => 'my $oldskip = $skip; $skip= \'\'; $oldskip',
                                                                                             'hashname' => '__DIRECTIVE2__'
                                                                                           }, 'Parse::RecDescent::Directive' ),
                                                                                    bless( {
                                                                                             'hashname' => '__PATTERN1__',
                                                                                             'description' => '/(\\\\s[^\\\\$\\\\[\\\\]]*)?/',
                                                                                             'mod' => '',
                                                                                             'ldelim' => '/',
                                                                                             'line' => 158,
                                                                                             'lookahead' => 0,
                                                                                             'pattern' => '(\\s[^\\$\\[\\]]*)?',
                                                                                             'rdelim' => '/'
                                                                                           }, 'Parse::RecDescent::Token' ),
                                                                                    bless( {
                                                                                             'hashname' => '__STRING3__',
                                                                                             'description' => '\'$]\'',
                                                                                             'pattern' => '$]',
                                                                                             'lookahead' => 0,
                                                                                             'line' => 158
                                                                                           }, 'Parse::RecDescent::Literal' ),
                                                                                    bless( {
                                                                                             'lookahead' => 0,
                                                                                             'line' => 158,
                                                                                             'subrule' => 'space',
                                                                                             'matchrule' => 0,
                                                                                             'argcode' => undef,
                                                                                             'implicit' => undef
                                                                                           }, 'Parse::RecDescent::Subrule' )
                                                                                  ],
                                                                       'uncommit' => undef,
                                                                       'number' => 0,
                                                                       'strcount' => 3,
                                                                       'dircount' => 2
                                                                     }, 'Parse::RecDescent::Production' ),
                                                              bless( {
                                                                       'dircount' => 0,
                                                                       'number' => 1,
                                                                       'uncommit' => undef,
                                                                       'strcount' => 1,
                                                                       'patcount' => 0,
                                                                       'line' => 159,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'hashname' => '__STRING1__',
                                                                                             'description' => '\'[/]\'',
                                                                                             'pattern' => '[/]',
                                                                                             'lookahead' => 0,
                                                                                             'line' => 159
                                                                                           }, 'Parse::RecDescent::Literal' ),
                                                                                    bless( {
                                                                                             'line' => 159,
                                                                                             'subrule' => 'space',
                                                                                             'lookahead' => 0,
                                                                                             'argcode' => undef,
                                                                                             'matchrule' => 0,
                                                                                             'implicit' => undef
                                                                                           }, 'Parse::RecDescent::Subrule' )
                                                                                  ],
                                                                       'error' => undef,
                                                                       'actcount' => 0
                                                                     }, 'Parse::RecDescent::Production' ),
                                                              bless( {
                                                                       'line' => 160,
                                                                       'patcount' => 0,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'line' => 160,
                                                                                             'lookahead' => 0,
                                                                                             'msg' => '',
                                                                                             'commitonly' => '',
                                                                                             'hashname' => '__DIRECTIVE1__'
                                                                                           }, 'Parse::RecDescent::Error' )
                                                                                  ],
                                                                       'error' => 1,
                                                                       'actcount' => 0,
                                                                       'dircount' => 1,
                                                                       'uncommit' => 0,
                                                                       'number' => 2,
                                                                       'strcount' => 0
                                                                     }, 'Parse::RecDescent::Production' )
                                                            ]
                                               }, 'Parse::RecDescent::Rule' ),
                              'octint' => bless( {
                                                 'changed' => 0,
                                                 'vars' => '',
                                                 'opcount' => 0,
                                                 'line' => 16,
                                                 'calls' => [],
                                                 'name' => 'octint',
                                                 'impcount' => 0,
                                                 'prods' => [
                                                              bless( {
                                                                       'error' => undef,
                                                                       'actcount' => 1,
                                                                       'line' => undef,
                                                                       'patcount' => 1,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'mod' => '',
                                                                                             'hashname' => '__PATTERN1__',
                                                                                             'description' => '/0[0-7]*/',
                                                                                             'line' => 17,
                                                                                             'lookahead' => 0,
                                                                                             'ldelim' => '/',
                                                                                             'pattern' => '0[0-7]*',
                                                                                             'rdelim' => '/'
                                                                                           }, 'Parse::RecDescent::Token' ),
                                                                                    bless( {
                                                                                             'hashname' => '__ACTION1__',
                                                                                             'code' => '{ Config::Maker::limit(oct($item[1]), @arg); }',
                                                                                             'line' => 17,
                                                                                             'lookahead' => 0
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ],
                                                                       'uncommit' => undef,
                                                                       'number' => 0,
                                                                       'strcount' => 0,
                                                                       'dircount' => 0
                                                                     }, 'Parse::RecDescent::Production' ),
                                                              bless( {
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'line' => 19,
                                                                                             'lookahead' => 0,
                                                                                             'msg' => ' Number $item[1] out of range',
                                                                                             'hashname' => '__DIRECTIVE1__',
                                                                                             'commitonly' => '?'
                                                                                           }, 'Parse::RecDescent::Error' ),
                                                                                    bless( {
                                                                                             'lookahead' => 0,
                                                                                             'line' => 19,
                                                                                             'name' => '<reject>',
                                                                                             'hashname' => '__DIRECTIVE2__'
                                                                                           }, 'Parse::RecDescent::UncondReject' )
                                                                                  ],
                                                                       'line' => 18,
                                                                       'patcount' => 0,
                                                                       'actcount' => 0,
                                                                       'error' => 1,
                                                                       'dircount' => 2,
                                                                       'strcount' => 0,
                                                                       'uncommit' => 0,
                                                                       'number' => 1
                                                                     }, 'Parse::RecDescent::Production' )
                                                            ]
                                               }, 'Parse::RecDescent::Rule' ),
                              'real' => bless( {
                                               'prods' => [
                                                            bless( {
                                                                     'dircount' => 0,
                                                                     'strcount' => 0,
                                                                     'uncommit' => undef,
                                                                     'number' => 0,
                                                                     'items' => [
                                                                                  bless( {
                                                                                           'mod' => '',
                                                                                           'description' => '/[+-]?(\\\\d+(\\\\.\\\\d*)?|\\\\.\\\\d+)(e\\\\d+)?/',
                                                                                           'hashname' => '__PATTERN1__',
                                                                                           'lookahead' => 0,
                                                                                           'line' => 31,
                                                                                           'ldelim' => '/',
                                                                                           'pattern' => '[+-]?(\\d+(\\.\\d*)?|\\.\\d+)(e\\d+)?',
                                                                                           'rdelim' => '/'
                                                                                         }, 'Parse::RecDescent::Token' ),
                                                                                  bless( {
                                                                                           'lookahead' => 0,
                                                                                           'line' => 31,
                                                                                           'hashname' => '__ACTION1__',
                                                                                           'code' => '{ 0 + $item[1]; }'
                                                                                         }, 'Parse::RecDescent::Action' )
                                                                                ],
                                                                     'line' => undef,
                                                                     'patcount' => 1,
                                                                     'actcount' => 1,
                                                                     'error' => undef
                                                                   }, 'Parse::RecDescent::Production' )
                                                          ],
                                               'opcount' => 0,
                                               'vars' => '',
                                               'name' => 'real',
                                               'impcount' => 0,
                                               'line' => 28,
                                               'calls' => [],
                                               'changed' => 0
                                             }, 'Parse::RecDescent::Rule' ),
                              'pcondition' => bless( {
                                                     'changed' => 0,
                                                     'vars' => '',
                                                     'opcount' => 0,
                                                     'line' => 103,
                                                     'calls' => [
                                                                  'perl_codeblock'
                                                                ],
                                                     'impcount' => 0,
                                                     'name' => 'pcondition',
                                                     'prods' => [
                                                                  bless( {
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'subrule' => 'perl_codeblock',
                                                                                                 'line' => 103,
                                                                                                 'lookahead' => 0,
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => '[\'()\']',
                                                                                                 'implicit' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'patcount' => 0,
                                                                           'line' => undef,
                                                                           'actcount' => 0,
                                                                           'error' => undef,
                                                                           'dircount' => 0,
                                                                           'strcount' => 0,
                                                                           'number' => 0,
                                                                           'uncommit' => undef
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ]
                                                   }, 'Parse::RecDescent::Rule' ),
                              'nonglob' => bless( {
                                                  'impcount' => 0,
                                                  'name' => 'nonglob',
                                                  'line' => 107,
                                                  'calls' => [],
                                                  'vars' => '',
                                                  'opcount' => 0,
                                                  'changed' => 0,
                                                  'prods' => [
                                                               bless( {
                                                                        'dircount' => 0,
                                                                        'strcount' => 0,
                                                                        'uncommit' => undef,
                                                                        'number' => 0,
                                                                        'items' => [
                                                                                     bless( {
                                                                                              'line' => 107,
                                                                                              'lookahead' => 0,
                                                                                              'ldelim' => '/',
                                                                                              'mod' => '',
                                                                                              'description' => '/\\\\Q$arg[0]\\\\E(?![[:alnum:].@%*=?|_\\\\\\\\\\\\[\\\\]\\{\\}-])/',
                                                                                              'hashname' => '__PATTERN1__',
                                                                                              'rdelim' => '/',
                                                                                              'pattern' => '\\Q$arg[0]\\E(?![[:alnum:].@%*=?|_\\\\\\[\\]{}-])'
                                                                                            }, 'Parse::RecDescent::Token' )
                                                                                   ],
                                                                        'line' => undef,
                                                                        'patcount' => 1,
                                                                        'actcount' => 0,
                                                                        'error' => undef
                                                                      }, 'Parse::RecDescent::Production' )
                                                             ]
                                                }, 'Parse::RecDescent::Rule' ),
                              'configuration' => bless( {
                                                        'prods' => [
                                                                     bless( {
                                                                              'line' => undef,
                                                                              'patcount' => 0,
                                                                              'items' => [
                                                                                           bless( {
                                                                                                    'name' => '<skip: qr/(\\s|#[^\\n]*)*/>',
                                                                                                    'line' => 285,
                                                                                                    'lookahead' => 0,
                                                                                                    'hashname' => '__DIRECTIVE1__',
                                                                                                    'code' => 'my $oldskip = $skip; $skip= qr/(\\s|#[^\\n]*)*/; $oldskip'
                                                                                                  }, 'Parse::RecDescent::Directive' ),
                                                                                           bless( {
                                                                                                    'max' => 100000000,
                                                                                                    'min' => 0,
                                                                                                    'matchrule' => 0,
                                                                                                    'argcode' => '[$arg[0]]',
                                                                                                    'line' => 286,
                                                                                                    'lookahead' => 0,
                                                                                                    'repspec' => 's?',
                                                                                                    'subrule' => 'option',
                                                                                                    'expected' => undef
                                                                                                  }, 'Parse::RecDescent::Repetition' ),
                                                                                           bless( {
                                                                                                    'implicit' => undef,
                                                                                                    'argcode' => undef,
                                                                                                    'matchrule' => 0,
                                                                                                    'line' => 287,
                                                                                                    'lookahead' => 0,
                                                                                                    'subrule' => 'eof'
                                                                                                  }, 'Parse::RecDescent::Subrule' ),
                                                                                           bless( {
                                                                                                    'lookahead' => 0,
                                                                                                    'line' => 288,
                                                                                                    'code' => '{ $item[2]; }',
                                                                                                    'hashname' => '__ACTION1__'
                                                                                                  }, 'Parse::RecDescent::Action' )
                                                                                         ],
                                                                              'error' => undef,
                                                                              'actcount' => 1,
                                                                              'dircount' => 1,
                                                                              'uncommit' => undef,
                                                                              'number' => 0,
                                                                              'strcount' => 0
                                                                            }, 'Parse::RecDescent::Production' ),
                                                                     bless( {
                                                                              'items' => [
                                                                                           bless( {
                                                                                                    'commitonly' => '',
                                                                                                    'hashname' => '__DIRECTIVE1__',
                                                                                                    'line' => 290,
                                                                                                    'lookahead' => 0,
                                                                                                    'msg' => ''
                                                                                                  }, 'Parse::RecDescent::Error' )
                                                                                         ],
                                                                              'patcount' => 0,
                                                                              'line' => 289,
                                                                              'actcount' => 0,
                                                                              'error' => 1,
                                                                              'dircount' => 1,
                                                                              'strcount' => 0,
                                                                              'number' => 1,
                                                                              'uncommit' => 0
                                                                            }, 'Parse::RecDescent::Production' )
                                                                   ],
                                                        'line' => 283,
                                                        'calls' => [
                                                                     'option',
                                                                     'eof'
                                                                   ],
                                                        'impcount' => 0,
                                                        'name' => 'configuration',
                                                        'vars' => '',
                                                        'opcount' => 0,
                                                        'changed' => 0
                                                      }, 'Parse::RecDescent::Rule' ),
                              'ptail' => bless( {
                                                'prods' => [
                                                             bless( {
                                                                      'actcount' => 1,
                                                                      'error' => undef,
                                                                      'items' => [
                                                                                   bless( {
                                                                                            'line' => 77,
                                                                                            'lookahead' => 0,
                                                                                            'subrule' => 'separator',
                                                                                            'argcode' => undef,
                                                                                            'matchrule' => 0,
                                                                                            'implicit' => undef
                                                                                          }, 'Parse::RecDescent::Subrule' ),
                                                                                   bless( {
                                                                                            'implicit' => undef,
                                                                                            'line' => 77,
                                                                                            'lookahead' => 0,
                                                                                            'subrule' => 'relpath',
                                                                                            'argcode' => undef,
                                                                                            'matchrule' => 0
                                                                                          }, 'Parse::RecDescent::Subrule' ),
                                                                                   bless( {
                                                                                            'hashname' => '__ACTION1__',
                                                                                            'code' => '{ [-tail => $item{relpath}] }',
                                                                                            'lookahead' => 0,
                                                                                            'line' => 77
                                                                                          }, 'Parse::RecDescent::Action' )
                                                                                 ],
                                                                      'line' => undef,
                                                                      'patcount' => 0,
                                                                      'strcount' => 0,
                                                                      'uncommit' => undef,
                                                                      'number' => 0,
                                                                      'dircount' => 0
                                                                    }, 'Parse::RecDescent::Production' ),
                                                             bless( {
                                                                      'uncommit' => undef,
                                                                      'number' => 1,
                                                                      'strcount' => 0,
                                                                      'dircount' => 0,
                                                                      'error' => undef,
                                                                      'actcount' => 1,
                                                                      'line' => 78,
                                                                      'patcount' => 0,
                                                                      'items' => [
                                                                                   bless( {
                                                                                            'code' => '{ []; }',
                                                                                            'hashname' => '__ACTION1__',
                                                                                            'lookahead' => 0,
                                                                                            'line' => 78
                                                                                          }, 'Parse::RecDescent::Action' )
                                                                                 ]
                                                                    }, 'Parse::RecDescent::Production' )
                                                           ],
                                                'opcount' => 0,
                                                'vars' => '',
                                                'impcount' => 0,
                                                'name' => 'ptail',
                                                'line' => 77,
                                                'calls' => [
                                                             'separator',
                                                             'relpath'
                                                           ],
                                                'changed' => 0
                                              }, 'Parse::RecDescent::Rule' ),
                              'value_nestlist_elem' => bless( {
                                                              'name' => 'value_nestlist_elem',
                                                              'impcount' => 0,
                                                              'line' => 372,
                                                              'calls' => [
                                                                           'value_nestlist_elem'
                                                                         ],
                                                              'vars' => '',
                                                              'opcount' => 0,
                                                              'changed' => 0,
                                                              'prods' => [
                                                                           bless( {
                                                                                    'strcount' => 2,
                                                                                    'uncommit' => undef,
                                                                                    'number' => 0,
                                                                                    'dircount' => 0,
                                                                                    'actcount' => 1,
                                                                                    'error' => undef,
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'line' => 373,
                                                                                                          'lookahead' => 0,
                                                                                                          'hashname' => '__STRING1__',
                                                                                                          'description' => '\'[\'',
                                                                                                          'pattern' => '['
                                                                                                        }, 'Parse::RecDescent::Literal' ),
                                                                                                 bless( {
                                                                                                          'max' => 100000000,
                                                                                                          'argcode' => '[@arg]',
                                                                                                          'matchrule' => 0,
                                                                                                          'min' => 0,
                                                                                                          'line' => 373,
                                                                                                          'lookahead' => 0,
                                                                                                          'repspec' => 's?',
                                                                                                          'subrule' => 'value_nestlist_elem',
                                                                                                          'expected' => undef
                                                                                                        }, 'Parse::RecDescent::Repetition' ),
                                                                                                 bless( {
                                                                                                          'line' => 373,
                                                                                                          'lookahead' => 0,
                                                                                                          'hashname' => '__STRING2__',
                                                                                                          'description' => '\']\'',
                                                                                                          'pattern' => ']'
                                                                                                        }, 'Parse::RecDescent::Literal' ),
                                                                                                 bless( {
                                                                                                          'code' => '{ new Config::Maker::Value::List($item[2]); }',
                                                                                                          'hashname' => '__ACTION1__',
                                                                                                          'lookahead' => 0,
                                                                                                          'line' => 374
                                                                                                        }, 'Parse::RecDescent::Action' )
                                                                                               ],
                                                                                    'line' => undef,
                                                                                    'patcount' => 0
                                                                                  }, 'Parse::RecDescent::Production' ),
                                                                           bless( {
                                                                                    'uncommit' => undef,
                                                                                    'number' => 1,
                                                                                    'strcount' => 0,
                                                                                    'dircount' => 0,
                                                                                    'error' => undef,
                                                                                    'actcount' => 0,
                                                                                    'line' => 375,
                                                                                    'patcount' => 0,
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'implicit' => undef,
                                                                                                          'matchrule' => 1,
                                                                                                          'argcode' => '[@arg[1..$#arg]]',
                                                                                                          'line' => 376,
                                                                                                          'subrule' => 'value_$arg[0]',
                                                                                                          'lookahead' => 0
                                                                                                        }, 'Parse::RecDescent::Subrule' )
                                                                                               ]
                                                                                  }, 'Parse::RecDescent::Production' ),
                                                                           bless( {
                                                                                    'dircount' => 1,
                                                                                    'strcount' => 0,
                                                                                    'number' => 2,
                                                                                    'uncommit' => 0,
                                                                                    'items' => [
                                                                                                 bless( {
                                                                                                          'commitonly' => '',
                                                                                                          'hashname' => '__DIRECTIVE1__',
                                                                                                          'lookahead' => 0,
                                                                                                          'line' => 377,
                                                                                                          'msg' => ''
                                                                                                        }, 'Parse::RecDescent::Error' )
                                                                                               ],
                                                                                    'patcount' => 0,
                                                                                    'line' => 377,
                                                                                    'actcount' => 0,
                                                                                    'error' => 1
                                                                                  }, 'Parse::RecDescent::Production' )
                                                                         ]
                                                            }, 'Parse::RecDescent::Rule' ),
                              'value' => bless( {
                                                'name' => 'value',
                                                'impcount' => 0,
                                                'line' => 350,
                                                'calls' => [],
                                                'opcount' => 0,
                                                'vars' => '',
                                                'changed' => 0,
                                                'prods' => [
                                                             bless( {
                                                                      'uncommit' => undef,
                                                                      'number' => 0,
                                                                      'strcount' => 1,
                                                                      'dircount' => 0,
                                                                      'error' => undef,
                                                                      'actcount' => 0,
                                                                      'line' => undef,
                                                                      'patcount' => 0,
                                                                      'items' => [
                                                                                   bless( {
                                                                                            'lookahead' => 0,
                                                                                            'line' => 351,
                                                                                            'pattern' => '',
                                                                                            'hashname' => '__STRING1__',
                                                                                            'description' => '\'\''
                                                                                          }, 'Parse::RecDescent::Literal' ),
                                                                                   bless( {
                                                                                            'implicit' => undef,
                                                                                            'argcode' => '[@arg[1..$#arg]]',
                                                                                            'matchrule' => 1,
                                                                                            'lookahead' => 0,
                                                                                            'line' => 351,
                                                                                            'subrule' => 'value_$arg[0]'
                                                                                          }, 'Parse::RecDescent::Subrule' )
                                                                                 ]
                                                                    }, 'Parse::RecDescent::Production' )
                                                           ]
                                              }, 'Parse::RecDescent::Rule' ),
                              'value_ipv4_port' => bless( {
                                                          'prods' => [
                                                                       bless( {
                                                                                'error' => undef,
                                                                                'actcount' => 1,
                                                                                'patcount' => 0,
                                                                                'line' => undef,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'lookahead' => 0,
                                                                                                      'line' => 417,
                                                                                                      'name' => '<skip: \'\'>',
                                                                                                      'hashname' => '__DIRECTIVE1__',
                                                                                                      'code' => 'my $oldskip = $skip; $skip= \'\'; $oldskip'
                                                                                                    }, 'Parse::RecDescent::Directive' ),
                                                                                             bless( {
                                                                                                      'argcode' => undef,
                                                                                                      'matchrule' => 0,
                                                                                                      'subrule' => 'value_ipv4',
                                                                                                      'line' => 417,
                                                                                                      'lookahead' => 0,
                                                                                                      'implicit' => undef
                                                                                                    }, 'Parse::RecDescent::Subrule' ),
                                                                                             bless( {
                                                                                                      'line' => 417,
                                                                                                      'lookahead' => 0,
                                                                                                      'hashname' => '__STRING1__',
                                                                                                      'description' => '\':\'',
                                                                                                      'pattern' => ':'
                                                                                                    }, 'Parse::RecDescent::Literal' ),
                                                                                             bless( {
                                                                                                      'implicit' => undef,
                                                                                                      'line' => 417,
                                                                                                      'subrule' => 'value_port',
                                                                                                      'lookahead' => 0,
                                                                                                      'matchrule' => 0,
                                                                                                      'argcode' => undef
                                                                                                    }, 'Parse::RecDescent::Subrule' ),
                                                                                             bless( {
                                                                                                      'line' => 418,
                                                                                                      'lookahead' => 0,
                                                                                                      'code' => '{ "$item[2]:$item[-1]"; }',
                                                                                                      'hashname' => '__ACTION1__'
                                                                                                    }, 'Parse::RecDescent::Action' )
                                                                                           ],
                                                                                'number' => 0,
                                                                                'uncommit' => undef,
                                                                                'strcount' => 1,
                                                                                'dircount' => 1
                                                                              }, 'Parse::RecDescent::Production' ),
                                                                       bless( {
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'msg' => '',
                                                                                                      'lookahead' => 0,
                                                                                                      'line' => 419,
                                                                                                      'commitonly' => '',
                                                                                                      'hashname' => '__DIRECTIVE1__'
                                                                                                    }, 'Parse::RecDescent::Error' )
                                                                                           ],
                                                                                'line' => 419,
                                                                                'patcount' => 0,
                                                                                'actcount' => 0,
                                                                                'error' => 1,
                                                                                'dircount' => 1,
                                                                                'strcount' => 0,
                                                                                'uncommit' => 0,
                                                                                'number' => 1
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'changed' => 0,
                                                          'line' => 416,
                                                          'calls' => [
                                                                       'value_ipv4',
                                                                       'value_port'
                                                                     ],
                                                          'name' => 'value_ipv4_port',
                                                          'impcount' => 0,
                                                          'vars' => '',
                                                          'opcount' => 0
                                                        }, 'Parse::RecDescent::Rule' ),
                              'value_ipv4' => bless( {
                                                     'prods' => [
                                                                  bless( {
                                                                           'number' => 0,
                                                                           'uncommit' => undef,
                                                                           'strcount' => 1,
                                                                           'dircount' => 2,
                                                                           'error' => undef,
                                                                           'actcount' => 1,
                                                                           'patcount' => 0,
                                                                           'line' => undef,
                                                                           'op' => [],
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'code' => 'my $oldskip = $skip; $skip= \'\'; $oldskip',
                                                                                                 'hashname' => '__DIRECTIVE1__',
                                                                                                 'name' => '<skip: \'\'>',
                                                                                                 'line' => 409,
                                                                                                 'lookahead' => 0
                                                                                               }, 'Parse::RecDescent::Directive' ),
                                                                                        bless( {
                                                                                                 'type' => 'leftop',
                                                                                                 'expected' => '<leftop: byte \'.\' byte>',
                                                                                                 'rightarg' => bless( {
                                                                                                                        'matchrule' => 0,
                                                                                                                        'argcode' => undef,
                                                                                                                        'line' => 409,
                                                                                                                        'subrule' => 'byte',
                                                                                                                        'lookahead' => 0,
                                                                                                                        'implicit' => undef
                                                                                                                      }, 'Parse::RecDescent::Subrule' ),
                                                                                                 'max' => 100000000,
                                                                                                 'hashname' => '__DIRECTIVE2__',
                                                                                                 'name' => '',
                                                                                                 'leftarg' => bless( {
                                                                                                                       'line' => 409,
                                                                                                                       'subrule' => 'byte',
                                                                                                                       'lookahead' => 0,
                                                                                                                       'matchrule' => 0,
                                                                                                                       'argcode' => undef,
                                                                                                                       'implicit' => undef
                                                                                                                     }, 'Parse::RecDescent::Subrule' ),
                                                                                                 'op' => bless( {
                                                                                                                  'lookahead' => 0,
                                                                                                                  'line' => 409,
                                                                                                                  'hashname' => '__STRING1__',
                                                                                                                  'description' => '\'.\'',
                                                                                                                  'pattern' => '.'
                                                                                                                }, 'Parse::RecDescent::Literal' ),
                                                                                                 'min' => 1
                                                                                               }, 'Parse::RecDescent::Operator' ),
                                                                                        bless( {
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 410,
                                                                                                 'code' => '{ @{$item[2]} == 4 ? join \'.\', @{$item[2]} : undef; }',
                                                                                                 'hashname' => '__ACTION1__'
                                                                                               }, 'Parse::RecDescent::Action' )
                                                                                      ]
                                                                         }, 'Parse::RecDescent::Production' ),
                                                                  bless( {
                                                                           'error' => 1,
                                                                           'actcount' => 0,
                                                                           'patcount' => 0,
                                                                           'line' => 411,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'msg' => '',
                                                                                                 'lookahead' => 0,
                                                                                                 'line' => 411,
                                                                                                 'commitonly' => '',
                                                                                                 'hashname' => '__DIRECTIVE1__'
                                                                                               }, 'Parse::RecDescent::Error' )
                                                                                      ],
                                                                           'number' => 1,
                                                                           'uncommit' => 0,
                                                                           'strcount' => 0,
                                                                           'dircount' => 1
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'changed' => 0,
                                                     'name' => 'value_ipv4',
                                                     'impcount' => 0,
                                                     'line' => 408,
                                                     'calls' => [
                                                                  'byte'
                                                                ],
                                                     'opcount' => 0,
                                                     'vars' => ''
                                                   }, 'Parse::RecDescent::Rule' ),
                              'metaroot' => bless( {
                                                   'line' => 109,
                                                   'calls' => [],
                                                   'impcount' => 0,
                                                   'name' => 'metaroot',
                                                   'vars' => '',
                                                   'opcount' => 0,
                                                   'changed' => 0,
                                                   'prods' => [
                                                                bless( {
                                                                         'patcount' => 0,
                                                                         'line' => undef,
                                                                         'items' => [
                                                                                      bless( {
                                                                                               'hashname' => '__STRING1__',
                                                                                               'pattern' => 'META:',
                                                                                               'description' => '\'META:\'',
                                                                                               'lookahead' => 0,
                                                                                               'line' => 109
                                                                                             }, 'Parse::RecDescent::Literal' )
                                                                                    ],
                                                                         'error' => undef,
                                                                         'actcount' => 0,
                                                                         'dircount' => 0,
                                                                         'number' => 0,
                                                                         'uncommit' => undef,
                                                                         'strcount' => 1
                                                                       }, 'Parse::RecDescent::Production' )
                                                              ]
                                                 }, 'Parse::RecDescent::Rule' ),
                              'template' => bless( {
                                                   'changed' => 0,
                                                   'vars' => '',
                                                   'opcount' => 0,
                                                   'calls' => [
                                                                'directive',
                                                                'eof'
                                                              ],
                                                   'line' => 113,
                                                   'name' => 'template',
                                                   'impcount' => 0,
                                                   'prods' => [
                                                                bless( {
                                                                         'dircount' => 1,
                                                                         'number' => 0,
                                                                         'uncommit' => undef,
                                                                         'strcount' => 0,
                                                                         'patcount' => 0,
                                                                         'line' => undef,
                                                                         'items' => [
                                                                                      bless( {
                                                                                               'hashname' => '__DIRECTIVE1__',
                                                                                               'code' => 'my $oldskip = $skip; $skip= \'\'; $oldskip',
                                                                                               'line' => 115,
                                                                                               'lookahead' => 0,
                                                                                               'name' => '<skip: \'\'>'
                                                                                             }, 'Parse::RecDescent::Directive' ),
                                                                                      bless( {
                                                                                               'repspec' => 's?',
                                                                                               'subrule' => 'directive',
                                                                                               'expected' => undef,
                                                                                               'max' => 100000000,
                                                                                               'line' => 115,
                                                                                               'lookahead' => 0,
                                                                                               'matchrule' => 0,
                                                                                               'argcode' => undef,
                                                                                               'min' => 0
                                                                                             }, 'Parse::RecDescent::Repetition' ),
                                                                                      bless( {
                                                                                               'implicit' => undef,
                                                                                               'lookahead' => 0,
                                                                                               'line' => 115,
                                                                                               'subrule' => 'eof',
                                                                                               'matchrule' => 0,
                                                                                               'argcode' => undef
                                                                                             }, 'Parse::RecDescent::Subrule' ),
                                                                                      bless( {
                                                                                               'code' => '{ $item[2]; }',
                                                                                               'hashname' => '__ACTION1__',
                                                                                               'line' => 115,
                                                                                               'lookahead' => 0
                                                                                             }, 'Parse::RecDescent::Action' )
                                                                                    ],
                                                                         'error' => undef,
                                                                         'actcount' => 1
                                                                       }, 'Parse::RecDescent::Production' ),
                                                                bless( {
                                                                         'strcount' => 0,
                                                                         'uncommit' => 0,
                                                                         'number' => 1,
                                                                         'dircount' => 1,
                                                                         'actcount' => 0,
                                                                         'error' => 1,
                                                                         'items' => [
                                                                                      bless( {
                                                                                               'commitonly' => '',
                                                                                               'hashname' => '__DIRECTIVE1__',
                                                                                               'lookahead' => 0,
                                                                                               'line' => 116,
                                                                                               'msg' => ''
                                                                                             }, 'Parse::RecDescent::Error' )
                                                                                    ],
                                                                         'line' => 116,
                                                                         'patcount' => 0
                                                                       }, 'Parse::RecDescent::Production' )
                                                              ]
                                                 }, 'Parse::RecDescent::Rule' ),
                              'value_path' => bless( {
                                                     'prods' => [
                                                                  bless( {
                                                                           'actcount' => 0,
                                                                           'error' => undef,
                                                                           'items' => [
                                                                                        bless( {
                                                                                                 'line' => 430,
                                                                                                 'subrule' => 'path',
                                                                                                 'lookahead' => 0,
                                                                                                 'matchrule' => 0,
                                                                                                 'argcode' => undef,
                                                                                                 'implicit' => undef
                                                                                               }, 'Parse::RecDescent::Subrule' )
                                                                                      ],
                                                                           'line' => undef,
                                                                           'patcount' => 0,
                                                                           'strcount' => 0,
                                                                           'uncommit' => undef,
                                                                           'number' => 0,
                                                                           'dircount' => 0
                                                                         }, 'Parse::RecDescent::Production' )
                                                                ],
                                                     'changed' => 0,
                                                     'opcount' => 0,
                                                     'vars' => '',
                                                     'name' => 'value_path',
                                                     'impcount' => 0,
                                                     'line' => 430,
                                                     'calls' => [
                                                                  'path'
                                                                ]
                                                   }, 'Parse::RecDescent::Rule' ),
                              'separator' => bless( {
                                                    'prods' => [
                                                                 bless( {
                                                                          'actcount' => 0,
                                                                          'error' => undef,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'rdelim' => '/',
                                                                                                'pattern' => '\\/+',
                                                                                                'ldelim' => '/',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 111,
                                                                                                'hashname' => '__PATTERN1__',
                                                                                                'description' => '/\\\\/+/',
                                                                                                'mod' => ''
                                                                                              }, 'Parse::RecDescent::Token' )
                                                                                     ],
                                                                          'patcount' => 1,
                                                                          'line' => undef,
                                                                          'strcount' => 0,
                                                                          'number' => 0,
                                                                          'uncommit' => undef,
                                                                          'dircount' => 0
                                                                        }, 'Parse::RecDescent::Production' )
                                                               ],
                                                    'changed' => 0,
                                                    'impcount' => 0,
                                                    'name' => 'separator',
                                                    'line' => 111,
                                                    'calls' => [],
                                                    'vars' => '',
                                                    'opcount' => 0
                                                  }, 'Parse::RecDescent::Rule' ),
                              'value_dns_zone' => bless( {
                                                         'vars' => '',
                                                         'opcount' => 0,
                                                         'calls' => [],
                                                         'line' => 402,
                                                         'name' => 'value_dns_zone',
                                                         'impcount' => 0,
                                                         'changed' => 0,
                                                         'prods' => [
                                                                      bless( {
                                                                               'error' => undef,
                                                                               'actcount' => 0,
                                                                               'line' => undef,
                                                                               'patcount' => 1,
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'ldelim' => '/',
                                                                                                     'line' => 403,
                                                                                                     'lookahead' => 0,
                                                                                                     'description' => '/([a-zA-Z0-9-]+\\\\.)*[a-zA-Z0-9-]+\\\\.?/',
                                                                                                     'hashname' => '__PATTERN1__',
                                                                                                     'mod' => '',
                                                                                                     'rdelim' => '/',
                                                                                                     'pattern' => '([a-zA-Z0-9-]+\\.)*[a-zA-Z0-9-]+\\.?'
                                                                                                   }, 'Parse::RecDescent::Token' )
                                                                                          ],
                                                                               'uncommit' => undef,
                                                                               'number' => 0,
                                                                               'strcount' => 0,
                                                                               'dircount' => 0
                                                                             }, 'Parse::RecDescent::Production' ),
                                                                      bless( {
                                                                               'items' => [
                                                                                            bless( {
                                                                                                     'msg' => '',
                                                                                                     'line' => 404,
                                                                                                     'lookahead' => 0,
                                                                                                     'commitonly' => '',
                                                                                                     'hashname' => '__DIRECTIVE1__'
                                                                                                   }, 'Parse::RecDescent::Error' )
                                                                                          ],
                                                                               'line' => 404,
                                                                               'patcount' => 0,
                                                                               'actcount' => 0,
                                                                               'error' => 1,
                                                                               'dircount' => 1,
                                                                               'strcount' => 0,
                                                                               'uncommit' => 0,
                                                                               'number' => 1
                                                                             }, 'Parse::RecDescent::Production' )
                                                                    ]
                                                       }, 'Parse::RecDescent::Rule' ),
                              'body_anon_group' => bless( {
                                                          'prods' => [
                                                                       bless( {
                                                                                'patcount' => 0,
                                                                                'line' => undef,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'argcode' => '[$arg[0]]',
                                                                                                      'matchrule' => 0,
                                                                                                      'line' => 334,
                                                                                                      'lookahead' => 0,
                                                                                                      'subrule' => 'block',
                                                                                                      'implicit' => undef
                                                                                                    }, 'Parse::RecDescent::Subrule' ),
                                                                                             bless( {
                                                                                                      'lookahead' => 0,
                                                                                                      'line' => 335,
                                                                                                      'hashname' => '__ACTION1__',
                                                                                                      'code' => '{ +{ -children => $item[1] }; }'
                                                                                                    }, 'Parse::RecDescent::Action' )
                                                                                           ],
                                                                                'error' => undef,
                                                                                'actcount' => 1,
                                                                                'dircount' => 0,
                                                                                'number' => 0,
                                                                                'uncommit' => undef,
                                                                                'strcount' => 0
                                                                              }, 'Parse::RecDescent::Production' ),
                                                                       bless( {
                                                                                'error' => 1,
                                                                                'actcount' => 0,
                                                                                'patcount' => 0,
                                                                                'line' => 336,
                                                                                'items' => [
                                                                                             bless( {
                                                                                                      'commitonly' => '',
                                                                                                      'hashname' => '__DIRECTIVE1__',
                                                                                                      'msg' => '',
                                                                                                      'line' => 336,
                                                                                                      'lookahead' => 0
                                                                                                    }, 'Parse::RecDescent::Error' )
                                                                                           ],
                                                                                'number' => 1,
                                                                                'uncommit' => 0,
                                                                                'strcount' => 0,
                                                                                'dircount' => 1
                                                                              }, 'Parse::RecDescent::Production' )
                                                                     ],
                                                          'vars' => '',
                                                          'opcount' => 0,
                                                          'calls' => [
                                                                       'block'
                                                                     ],
                                                          'line' => 333,
                                                          'impcount' => 0,
                                                          'name' => 'body_anon_group',
                                                          'changed' => 0
                                                        }, 'Parse::RecDescent::Rule' ),
                              'ifrest' => bless( {
                                                 'prods' => [
                                                              bless( {
                                                                       'strcount' => 0,
                                                                       'number' => 0,
                                                                       'uncommit' => undef,
                                                                       'dircount' => 1,
                                                                       'actcount' => 1,
                                                                       'error' => undef,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'implicit' => undef,
                                                                                             'matchrule' => 0,
                                                                                             'argcode' => '[\'elsif\', perlcode => \'()\']',
                                                                                             'line' => 185,
                                                                                             'lookahead' => 0,
                                                                                             'subrule' => 'opener'
                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                    bless( {
                                                                                             'lookahead' => 0,
                                                                                             'line' => 185,
                                                                                             'name' => '<commit>',
                                                                                             'hashname' => '__DIRECTIVE1__',
                                                                                             'code' => '$commit = 1'
                                                                                           }, 'Parse::RecDescent::Directive' ),
                                                                                    bless( {
                                                                                             'matchrule' => 0,
                                                                                             'min' => 1,
                                                                                             'argcode' => undef,
                                                                                             'lookahead' => 0,
                                                                                             'line' => 185,
                                                                                             'max' => 100000000,
                                                                                             'subrule' => 'directive',
                                                                                             'expected' => undef,
                                                                                             'repspec' => 's'
                                                                                           }, 'Parse::RecDescent::Repetition' ),
                                                                                    bless( {
                                                                                             'implicit' => undef,
                                                                                             'line' => 185,
                                                                                             'lookahead' => 0,
                                                                                             'subrule' => 'ifrest',
                                                                                             'matchrule' => 0,
                                                                                             'argcode' => undef
                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                    bless( {
                                                                                             'hashname' => '__ACTION1__',
                                                                                             'code' => '{
	     my $expr = $item[1];
	     my @parts = @{$item[3]};
	     my $else = $item[4];
	     sub {
		 if(Config::Maker::exe($expr)) {
		     Config::Maker::Driver::apply(@parts);
		 } else {
		     Config::Maker::Driver::apply($else);
		 }
	     }
	 }',
                                                                                             'lookahead' => 0,
                                                                                             'line' => 186
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ],
                                                                       'patcount' => 0,
                                                                       'line' => undef
                                                                     }, 'Parse::RecDescent::Production' ),
                                                              bless( {
                                                                       'dircount' => 1,
                                                                       'strcount' => 0,
                                                                       'number' => 1,
                                                                       'uncommit' => undef,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'implicit' => undef,
                                                                                             'matchrule' => 0,
                                                                                             'argcode' => '[\'elsif\', pair => [\'identifier\'], [\'path\']]',
                                                                                             'line' => 199,
                                                                                             'subrule' => 'opener',
                                                                                             'lookahead' => 0
                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                    bless( {
                                                                                             'line' => 199,
                                                                                             'lookahead' => 0,
                                                                                             'name' => '<commit>',
                                                                                             'code' => '$commit = 1',
                                                                                             'hashname' => '__DIRECTIVE1__'
                                                                                           }, 'Parse::RecDescent::Directive' ),
                                                                                    bless( {
                                                                                             'repspec' => 's',
                                                                                             'expected' => undef,
                                                                                             'subrule' => 'directive',
                                                                                             'max' => 100000000,
                                                                                             'matchrule' => 0,
                                                                                             'argcode' => undef,
                                                                                             'min' => 1,
                                                                                             'lookahead' => 0,
                                                                                             'line' => 200
                                                                                           }, 'Parse::RecDescent::Repetition' ),
                                                                                    bless( {
                                                                                             'argcode' => undef,
                                                                                             'matchrule' => 0,
                                                                                             'line' => 200,
                                                                                             'subrule' => 'ifrest',
                                                                                             'lookahead' => 0,
                                                                                             'implicit' => undef
                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                    bless( {
                                                                                             'code' => '{
	     my ($test, $path) = @{$item[1]};
	     my @parts = @{$item[3]};
	     my $else = $item[4];
	     sub {
		 die "No if test \'$test\'"
		     unless $Config::Maker::Path::checks{$test};
		 if($Config::Maker::Path::checks{$test}($path)) {
		     Config::Maker::Driver::apply(@parts);
		 } else {
		     Config::Maker::Driver::apply($else);
		 }
	     }
	 }',
                                                                                             'hashname' => '__ACTION1__',
                                                                                             'lookahead' => 0,
                                                                                             'line' => 201
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ],
                                                                       'patcount' => 0,
                                                                       'line' => undef,
                                                                       'actcount' => 1,
                                                                       'error' => undef
                                                                     }, 'Parse::RecDescent::Production' ),
                                                              bless( {
                                                                       'actcount' => 1,
                                                                       'error' => undef,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'subrule' => 'opener',
                                                                                             'line' => 216,
                                                                                             'lookahead' => 0,
                                                                                             'argcode' => '[\'else\', \'void\']',
                                                                                             'matchrule' => 0,
                                                                                             'implicit' => undef
                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                    bless( {
                                                                                             'name' => '<commit>',
                                                                                             'line' => 216,
                                                                                             'lookahead' => 0,
                                                                                             'code' => '$commit = 1',
                                                                                             'hashname' => '__DIRECTIVE1__'
                                                                                           }, 'Parse::RecDescent::Directive' ),
                                                                                    bless( {
                                                                                             'matchrule' => 0,
                                                                                             'min' => 1,
                                                                                             'argcode' => undef,
                                                                                             'line' => 216,
                                                                                             'lookahead' => 0,
                                                                                             'max' => 100000000,
                                                                                             'expected' => undef,
                                                                                             'subrule' => 'directive',
                                                                                             'repspec' => 's'
                                                                                           }, 'Parse::RecDescent::Repetition' ),
                                                                                    bless( {
                                                                                             'implicit' => undef,
                                                                                             'matchrule' => 0,
                                                                                             'argcode' => '[\'if\']',
                                                                                             'line' => 216,
                                                                                             'subrule' => 'closer',
                                                                                             'lookahead' => 0
                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                    bless( {
                                                                                             'lookahead' => 0,
                                                                                             'line' => 217,
                                                                                             'code' => '{
	     my @parts = @{$item[3]};
	     sub {
		 Config::Maker::Driver::apply(@parts);
	     }
	 }',
                                                                                             'hashname' => '__ACTION1__'
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ],
                                                                       'patcount' => 0,
                                                                       'line' => undef,
                                                                       'strcount' => 0,
                                                                       'number' => 2,
                                                                       'uncommit' => undef,
                                                                       'dircount' => 1
                                                                     }, 'Parse::RecDescent::Production' ),
                                                              bless( {
                                                                       'strcount' => 0,
                                                                       'uncommit' => undef,
                                                                       'number' => 3,
                                                                       'dircount' => 0,
                                                                       'actcount' => 1,
                                                                       'error' => undef,
                                                                       'items' => [
                                                                                    bless( {
                                                                                             'matchrule' => 0,
                                                                                             'argcode' => '[\'if\']',
                                                                                             'line' => 224,
                                                                                             'subrule' => 'closer',
                                                                                             'lookahead' => 0,
                                                                                             'implicit' => undef
                                                                                           }, 'Parse::RecDescent::Subrule' ),
                                                                                    bless( {
                                                                                             'lookahead' => 0,
                                                                                             'line' => 224,
                                                                                             'code' => '{ \'\'; }',
                                                                                             'hashname' => '__ACTION1__'
                                                                                           }, 'Parse::RecDescent::Action' )
                                                                                  ],
                                                                       'line' => undef,
                                                                       'patcount' => 0
                                                                     }, 'Parse::RecDescent::Production' )
                                                            ],
                                                 'changed' => 0,
                                                 'opcount' => 0,
                                                 'vars' => '',
                                                 'line' => 185,
                                                 'calls' => [
                                                              'opener',
                                                              'directive',
                                                              'ifrest',
                                                              'closer'
                                                            ],
                                                 'impcount' => 0,
                                                 'name' => 'ifrest'
                                               }, 'Parse::RecDescent::Rule' ),
                              'directive' => bless( {
                                                    'prods' => [
                                                                 bless( {
                                                                          'error' => undef,
                                                                          'actcount' => 1,
                                                                          'line' => undef,
                                                                          'patcount' => 1,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'rdelim' => '/',
                                                                                                'pattern' => '([^\\[]|\\[\\[)+',
                                                                                                'ldelim' => '/',
                                                                                                'line' => 120,
                                                                                                'lookahead' => 0,
                                                                                                'hashname' => '__PATTERN1__',
                                                                                                'description' => '/([^\\\\[]|\\\\[\\\\[)+/',
                                                                                                'mod' => ''
                                                                                              }, 'Parse::RecDescent::Token' ),
                                                                                       bless( {
                                                                                                'lookahead' => 0,
                                                                                                'line' => 121,
                                                                                                'code' => '{ $item[1] =~ s/\\[\\[/[/g; $item[1] =~ s/\\]\\]/\\]/g; $item[1]; }',
                                                                                                'hashname' => '__ACTION1__'
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ],
                                                                          'uncommit' => undef,
                                                                          'number' => 0,
                                                                          'strcount' => 0,
                                                                          'dircount' => 0
                                                                        }, 'Parse::RecDescent::Production' ),
                                                                 bless( {
                                                                          'line' => undef,
                                                                          'patcount' => 1,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'lookahead' => 0,
                                                                                                'line' => 124,
                                                                                                'description' => '\'[#\'',
                                                                                                'hashname' => '__STRING1__',
                                                                                                'pattern' => '[#'
                                                                                              }, 'Parse::RecDescent::Literal' ),
                                                                                       bless( {
                                                                                                'name' => '<commit>',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 124,
                                                                                                'code' => '$commit = 1',
                                                                                                'hashname' => '__DIRECTIVE1__'
                                                                                              }, 'Parse::RecDescent::Directive' ),
                                                                                       bless( {
                                                                                                'description' => '/([^#]|#[^\\\\]])*/',
                                                                                                'hashname' => '__PATTERN1__',
                                                                                                'mod' => '',
                                                                                                'ldelim' => '/',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 124,
                                                                                                'pattern' => '([^#]|#[^\\]])*',
                                                                                                'rdelim' => '/'
                                                                                              }, 'Parse::RecDescent::Token' ),
                                                                                       bless( {
                                                                                                'line' => 124,
                                                                                                'lookahead' => 0,
                                                                                                'hashname' => '__STRING2__',
                                                                                                'pattern' => '#]',
                                                                                                'description' => '\'#]\''
                                                                                              }, 'Parse::RecDescent::Literal' ),
                                                                                       bless( {
                                                                                                'code' => '{ \'\'; }',
                                                                                                'hashname' => '__ACTION1__',
                                                                                                'line' => 124,
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ],
                                                                          'error' => undef,
                                                                          'actcount' => 1,
                                                                          'dircount' => 1,
                                                                          'uncommit' => undef,
                                                                          'number' => 1,
                                                                          'strcount' => 2
                                                                        }, 'Parse::RecDescent::Production' ),
                                                                 bless( {
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'hashname' => '__DIRECTIVE1__',
                                                                                                'commitonly' => '?',
                                                                                                'line' => 125,
                                                                                                'lookahead' => 0,
                                                                                                'msg' => ''
                                                                                              }, 'Parse::RecDescent::Error' ),
                                                                                       bless( {
                                                                                                'name' => '<reject>',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 125,
                                                                                                'hashname' => '__DIRECTIVE2__'
                                                                                              }, 'Parse::RecDescent::UncondReject' )
                                                                                     ],
                                                                          'patcount' => 0,
                                                                          'line' => 125,
                                                                          'actcount' => 0,
                                                                          'error' => 1,
                                                                          'dircount' => 2,
                                                                          'strcount' => 0,
                                                                          'number' => 2,
                                                                          'uncommit' => 0
                                                                        }, 'Parse::RecDescent::Production' ),
                                                                 bless( {
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'lookahead' => 0,
                                                                                                'line' => 128,
                                                                                                'hashname' => '__STRING1__',
                                                                                                'pattern' => '[',
                                                                                                'description' => '\'[\''
                                                                                              }, 'Parse::RecDescent::Literal' ),
                                                                                       bless( {
                                                                                                'name' => '<perl_codeblock>',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 128,
                                                                                                'hashname' => '__DIRECTIVE1__',
                                                                                                'code' => 'Text::Balanced::extract_codeblock($text,undef,$skip,\'{}\');
                    '
                                                                                              }, 'Parse::RecDescent::Directive' ),
                                                                                       bless( {
                                                                                                'code' => '$commit = 1',
                                                                                                'hashname' => '__DIRECTIVE2__',
                                                                                                'line' => 128,
                                                                                                'lookahead' => 0,
                                                                                                'name' => '<commit>'
                                                                                              }, 'Parse::RecDescent::Directive' ),
                                                                                       bless( {
                                                                                                'hashname' => '__STRING2__',
                                                                                                'description' => '\']\'',
                                                                                                'pattern' => ']',
                                                                                                'line' => 128,
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::Literal' ),
                                                                                       bless( {
                                                                                                'hashname' => '__ACTION1__',
                                                                                                'code' => '{
		my $code = $item[2];
		sub {
		    print Config::Maker::exe($code);
		}
	    }',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 129
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ],
                                                                          'line' => undef,
                                                                          'patcount' => 0,
                                                                          'actcount' => 1,
                                                                          'error' => undef,
                                                                          'dircount' => 2,
                                                                          'strcount' => 2,
                                                                          'uncommit' => undef,
                                                                          'number' => 3
                                                                        }, 'Parse::RecDescent::Production' ),
                                                                 bless( {
                                                                          'dircount' => 2,
                                                                          'uncommit' => 0,
                                                                          'number' => 4,
                                                                          'strcount' => 0,
                                                                          'line' => 135,
                                                                          'patcount' => 0,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'hashname' => '__DIRECTIVE1__',
                                                                                                'commitonly' => '?',
                                                                                                'msg' => '',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 135
                                                                                              }, 'Parse::RecDescent::Error' ),
                                                                                       bless( {
                                                                                                'lookahead' => 0,
                                                                                                'line' => 135,
                                                                                                'name' => '<reject>',
                                                                                                'hashname' => '__DIRECTIVE2__'
                                                                                              }, 'Parse::RecDescent::UncondReject' )
                                                                                     ],
                                                                          'error' => 1,
                                                                          'actcount' => 0
                                                                        }, 'Parse::RecDescent::Production' ),
                                                                 bless( {
                                                                          'uncommit' => undef,
                                                                          'number' => 5,
                                                                          'strcount' => 2,
                                                                          'dircount' => 2,
                                                                          'error' => undef,
                                                                          'actcount' => 1,
                                                                          'line' => undef,
                                                                          'patcount' => 0,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'pattern' => '[+',
                                                                                                'hashname' => '__STRING1__',
                                                                                                'description' => '\'[+\'',
                                                                                                'line' => 140,
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::Literal' ),
                                                                                       bless( {
                                                                                                'hashname' => '__DIRECTIVE1__',
                                                                                                'code' => '$commit = 1',
                                                                                                'line' => 140,
                                                                                                'lookahead' => 0,
                                                                                                'name' => '<commit>'
                                                                                              }, 'Parse::RecDescent::Directive' ),
                                                                                       bless( {
                                                                                                'line' => 140,
                                                                                                'lookahead' => 0,
                                                                                                'name' => '<skip: qr/\\s*/>',
                                                                                                'code' => 'my $oldskip = $skip; $skip= qr/\\s*/; $oldskip',
                                                                                                'hashname' => '__DIRECTIVE2__'
                                                                                              }, 'Parse::RecDescent::Directive' ),
                                                                                       bless( {
                                                                                                'implicit' => undef,
                                                                                                'subrule' => 'identifier',
                                                                                                'line' => 140,
                                                                                                'lookahead' => 0,
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => undef
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'lookahead' => 0,
                                                                                                'line' => 140,
                                                                                                'subrule' => 'optpath',
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => undef,
                                                                                                'implicit' => undef
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'hashname' => '__STRING2__',
                                                                                                'pattern' => '+]',
                                                                                                'description' => '\'+]\'',
                                                                                                'line' => 140,
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::Literal' ),
                                                                                       bless( {
                                                                                                'line' => 141,
                                                                                                'lookahead' => 0,
                                                                                                'hashname' => '__ACTION1__',
                                                                                                'code' => '{
		my $key = $item{identifier};
		my $path = $item{optpath};
		sub { print $_->get1($path)->{-$key}; }
	    }'
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ]
                                                                        }, 'Parse::RecDescent::Production' ),
                                                                 bless( {
                                                                          'number' => 6,
                                                                          'uncommit' => 0,
                                                                          'strcount' => 0,
                                                                          'dircount' => 2,
                                                                          'error' => 1,
                                                                          'actcount' => 0,
                                                                          'patcount' => 0,
                                                                          'line' => 146,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'msg' => '',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 146,
                                                                                                'commitonly' => '?',
                                                                                                'hashname' => '__DIRECTIVE1__'
                                                                                              }, 'Parse::RecDescent::Error' ),
                                                                                       bless( {
                                                                                                'name' => '<reject>',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 146,
                                                                                                'hashname' => '__DIRECTIVE2__'
                                                                                              }, 'Parse::RecDescent::UncondReject' )
                                                                                     ]
                                                                        }, 'Parse::RecDescent::Production' ),
                                                                 bless( {
                                                                          'dircount' => 2,
                                                                          'number' => 7,
                                                                          'uncommit' => undef,
                                                                          'strcount' => 2,
                                                                          'patcount' => 1,
                                                                          'line' => undef,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'line' => 148,
                                                                                                'lookahead' => 0,
                                                                                                'hashname' => '__STRING1__',
                                                                                                'description' => '\'[<\'',
                                                                                                'pattern' => '[<'
                                                                                              }, 'Parse::RecDescent::Literal' ),
                                                                                       bless( {
                                                                                                'lookahead' => 0,
                                                                                                'line' => 148,
                                                                                                'name' => '<skip: \'\'>',
                                                                                                'hashname' => '__DIRECTIVE1__',
                                                                                                'code' => 'my $oldskip = $skip; $skip= \'\'; $oldskip'
                                                                                              }, 'Parse::RecDescent::Directive' ),
                                                                                       bless( {
                                                                                                'name' => '<commit>',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 148,
                                                                                                'hashname' => '__DIRECTIVE2__',
                                                                                                'code' => '$commit = 1'
                                                                                              }, 'Parse::RecDescent::Directive' ),
                                                                                       bless( {
                                                                                                'ldelim' => '/',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 148,
                                                                                                'hashname' => '__PATTERN1__',
                                                                                                'description' => '/[^>]+/',
                                                                                                'mod' => '',
                                                                                                'rdelim' => '/',
                                                                                                'pattern' => '[^>]+'
                                                                                              }, 'Parse::RecDescent::Token' ),
                                                                                       bless( {
                                                                                                'lookahead' => 0,
                                                                                                'line' => 148,
                                                                                                'pattern' => '>]',
                                                                                                'hashname' => '__STRING2__',
                                                                                                'description' => '\'>]\''
                                                                                              }, 'Parse::RecDescent::Literal' ),
                                                                                       bless( {
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => undef,
                                                                                                'line' => 148,
                                                                                                'lookahead' => 0,
                                                                                                'subrule' => 'space',
                                                                                                'implicit' => undef
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'line' => 149,
                                                                                                'lookahead' => 0,
                                                                                                'code' => '{
		Config::Maker::Driver->load($item[4]);
	    }',
                                                                                                'hashname' => '__ACTION1__'
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ],
                                                                          'error' => undef,
                                                                          'actcount' => 1
                                                                        }, 'Parse::RecDescent::Production' ),
                                                                 bless( {
                                                                          'dircount' => 2,
                                                                          'number' => 8,
                                                                          'uncommit' => 0,
                                                                          'strcount' => 0,
                                                                          'patcount' => 0,
                                                                          'line' => 152,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'commitonly' => '?',
                                                                                                'hashname' => '__DIRECTIVE1__',
                                                                                                'line' => 152,
                                                                                                'lookahead' => 0,
                                                                                                'msg' => ''
                                                                                              }, 'Parse::RecDescent::Error' ),
                                                                                       bless( {
                                                                                                'hashname' => '__DIRECTIVE2__',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 152,
                                                                                                'name' => '<reject>'
                                                                                              }, 'Parse::RecDescent::UncondReject' )
                                                                                     ],
                                                                          'error' => 1,
                                                                          'actcount' => 0
                                                                        }, 'Parse::RecDescent::Production' ),
                                                                 bless( {
                                                                          'dircount' => 1,
                                                                          'uncommit' => undef,
                                                                          'number' => 9,
                                                                          'strcount' => 0,
                                                                          'line' => undef,
                                                                          'patcount' => 0,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'implicit' => undef,
                                                                                                'lookahead' => 0,
                                                                                                'line' => 162,
                                                                                                'subrule' => 'opener',
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => '[\'map\', perlcode => \'()\']'
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'code' => '$commit = 1',
                                                                                                'hashname' => '__DIRECTIVE1__',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 162,
                                                                                                'name' => '<commit>'
                                                                                              }, 'Parse::RecDescent::Directive' ),
                                                                                       bless( {
                                                                                                'expected' => undef,
                                                                                                'subrule' => 'directive',
                                                                                                'repspec' => 's',
                                                                                                'argcode' => undef,
                                                                                                'matchrule' => 0,
                                                                                                'min' => 1,
                                                                                                'line' => 162,
                                                                                                'lookahead' => 0,
                                                                                                'max' => 100000000
                                                                                              }, 'Parse::RecDescent::Repetition' ),
                                                                                       bless( {
                                                                                                'subrule' => 'closer',
                                                                                                'line' => 162,
                                                                                                'lookahead' => 0,
                                                                                                'argcode' => '[\'map\']',
                                                                                                'matchrule' => 0,
                                                                                                'implicit' => undef
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'code' => '{
		my $expr = $item[1];
		my @parts = @{$item[3]};
		sub {
		    for(Config::Maker::exe($expr)) {
			Config::Maker::Driver::apply(@parts);
		    }
		}
	    }',
                                                                                                'hashname' => '__ACTION1__',
                                                                                                'line' => 163,
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ],
                                                                          'error' => undef,
                                                                          'actcount' => 1
                                                                        }, 'Parse::RecDescent::Production' ),
                                                                 bless( {
                                                                          'actcount' => 1,
                                                                          'error' => undef,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => '[\'map\', \'path\']',
                                                                                                'line' => 173,
                                                                                                'lookahead' => 0,
                                                                                                'subrule' => 'opener',
                                                                                                'implicit' => undef
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'name' => '<commit>',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 173,
                                                                                                'hashname' => '__DIRECTIVE1__',
                                                                                                'code' => '$commit = 1'
                                                                                              }, 'Parse::RecDescent::Directive' ),
                                                                                       bless( {
                                                                                                'repspec' => 's',
                                                                                                'subrule' => 'directive',
                                                                                                'expected' => undef,
                                                                                                'max' => 100000000,
                                                                                                'line' => 173,
                                                                                                'lookahead' => 0,
                                                                                                'min' => 1,
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => undef
                                                                                              }, 'Parse::RecDescent::Repetition' ),
                                                                                       bless( {
                                                                                                'implicit' => undef,
                                                                                                'line' => 173,
                                                                                                'lookahead' => 0,
                                                                                                'subrule' => 'closer',
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => '[\'map\']'
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'hashname' => '__ACTION1__',
                                                                                                'code' => '{
		my $path = $item[1];
		my @parts = @{$item[3]};
		sub {
		    for(@{$path->find($_)}) {
			Config::Maker::Driver::apply(@parts);
		    }
		}
	    }',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 174
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ],
                                                                          'patcount' => 0,
                                                                          'line' => undef,
                                                                          'strcount' => 0,
                                                                          'number' => 10,
                                                                          'uncommit' => undef,
                                                                          'dircount' => 1
                                                                        }, 'Parse::RecDescent::Production' ),
                                                                 bless( {
                                                                          'number' => 11,
                                                                          'uncommit' => 0,
                                                                          'strcount' => 0,
                                                                          'dircount' => 2,
                                                                          'error' => 1,
                                                                          'actcount' => 0,
                                                                          'patcount' => 0,
                                                                          'line' => 183,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'msg' => '',
                                                                                                'line' => 183,
                                                                                                'lookahead' => 0,
                                                                                                'hashname' => '__DIRECTIVE1__',
                                                                                                'commitonly' => '?'
                                                                                              }, 'Parse::RecDescent::Error' ),
                                                                                       bless( {
                                                                                                'hashname' => '__DIRECTIVE2__',
                                                                                                'name' => '<reject>',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 183
                                                                                              }, 'Parse::RecDescent::UncondReject' )
                                                                                     ]
                                                                        }, 'Parse::RecDescent::Production' ),
                                                                 bless( {
                                                                          'dircount' => 1,
                                                                          'number' => 12,
                                                                          'uncommit' => undef,
                                                                          'strcount' => 0,
                                                                          'patcount' => 0,
                                                                          'line' => undef,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'implicit' => undef,
                                                                                                'lookahead' => 0,
                                                                                                'line' => 226,
                                                                                                'subrule' => 'opener',
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => '[\'if\', perlcode => \'()\']'
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'code' => '$commit = 1',
                                                                                                'hashname' => '__DIRECTIVE1__',
                                                                                                'name' => '<commit>',
                                                                                                'line' => 226,
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::Directive' ),
                                                                                       bless( {
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => undef,
                                                                                                'min' => 1,
                                                                                                'lookahead' => 0,
                                                                                                'line' => 226,
                                                                                                'max' => 100000000,
                                                                                                'expected' => undef,
                                                                                                'subrule' => 'directive',
                                                                                                'repspec' => 's'
                                                                                              }, 'Parse::RecDescent::Repetition' ),
                                                                                       bless( {
                                                                                                'implicit' => undef,
                                                                                                'lookahead' => 0,
                                                                                                'line' => 226,
                                                                                                'subrule' => 'ifrest',
                                                                                                'argcode' => undef,
                                                                                                'matchrule' => 0
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'hashname' => '__ACTION1__',
                                                                                                'code' => '{
		my $expr = $item[1];
		my @parts = @{$item[3]};
		my $else = $item[4];
		sub {
		    if(Config::Maker::exe($expr)) {
			Config::Maker::Driver::apply(@parts);
		    } else {
			Config::Maker::Driver::apply($else);
		    }
		}
	    }',
                                                                                                'line' => 227,
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ],
                                                                          'error' => undef,
                                                                          'actcount' => 1
                                                                        }, 'Parse::RecDescent::Production' ),
                                                                 bless( {
                                                                          'dircount' => 1,
                                                                          'strcount' => 0,
                                                                          'uncommit' => undef,
                                                                          'number' => 13,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'implicit' => undef,
                                                                                                'argcode' => '[\'if\', pair => [\'identifier\'], [\'path\']]',
                                                                                                'matchrule' => 0,
                                                                                                'subrule' => 'opener',
                                                                                                'line' => 240,
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'code' => '$commit = 1',
                                                                                                'hashname' => '__DIRECTIVE1__',
                                                                                                'line' => 240,
                                                                                                'lookahead' => 0,
                                                                                                'name' => '<commit>'
                                                                                              }, 'Parse::RecDescent::Directive' ),
                                                                                       bless( {
                                                                                                'repspec' => 's',
                                                                                                'expected' => undef,
                                                                                                'subrule' => 'directive',
                                                                                                'max' => 100000000,
                                                                                                'line' => 241,
                                                                                                'lookahead' => 0,
                                                                                                'matchrule' => 0,
                                                                                                'min' => 1,
                                                                                                'argcode' => undef
                                                                                              }, 'Parse::RecDescent::Repetition' ),
                                                                                       bless( {
                                                                                                'implicit' => undef,
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => undef,
                                                                                                'line' => 241,
                                                                                                'subrule' => 'ifrest',
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'lookahead' => 0,
                                                                                                'line' => 242,
                                                                                                'code' => '{
		my ($test, $path) = @{$item[1]};
		my @parts = @{$item[3]};
		my $else = $item[4];
		sub {
		    die "No if test \'$test\'"
			unless $Config::Maker::Path::checks{$test};
		    if($Config::Maker::Path::checks{$test}($path)) {
			Config::Maker::Driver::apply(@parts);
		    } else {
			Config::Maker::Driver::apply($else);
		    }
		}
	    }',
                                                                                                'hashname' => '__ACTION1__'
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ],
                                                                          'line' => undef,
                                                                          'patcount' => 0,
                                                                          'actcount' => 1,
                                                                          'error' => undef
                                                                        }, 'Parse::RecDescent::Production' ),
                                                                 bless( {
                                                                          'dircount' => 1,
                                                                          'number' => 14,
                                                                          'uncommit' => undef,
                                                                          'strcount' => 0,
                                                                          'patcount' => 0,
                                                                          'line' => undef,
                                                                          'items' => [
                                                                                       bless( {
                                                                                                'line' => 257,
                                                                                                'subrule' => 'opener',
                                                                                                'lookahead' => 0,
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => '[\'output\', \'identifier\']',
                                                                                                'implicit' => undef
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'hashname' => '__DIRECTIVE1__',
                                                                                                'code' => '$commit = 1',
                                                                                                'line' => 257,
                                                                                                'lookahead' => 0,
                                                                                                'name' => '<commit>'
                                                                                              }, 'Parse::RecDescent::Directive' ),
                                                                                       bless( {
                                                                                                'max' => 100000000,
                                                                                                'line' => 258,
                                                                                                'lookahead' => 0,
                                                                                                'matchrule' => 0,
                                                                                                'min' => 1,
                                                                                                'argcode' => undef,
                                                                                                'repspec' => 's',
                                                                                                'subrule' => 'directive',
                                                                                                'expected' => undef
                                                                                              }, 'Parse::RecDescent::Repetition' ),
                                                                                       bless( {
                                                                                                'implicit' => undef,
                                                                                                'matchrule' => 0,
                                                                                                'argcode' => '[\'output\']',
                                                                                                'subrule' => 'closer',
                                                                                                'line' => 258,
                                                                                                'lookahead' => 0
                                                                                              }, 'Parse::RecDescent::Subrule' ),
                                                                                       bless( {
                                                                                                'hashname' => '__ACTION1__',
                                                                                                'code' => '{
		my $key = $item[1];
		my @parts = @{$item[3]};
		my ($cache, $output) =
		    $key eq \'all\'        ? (1, 1) :
		    $key eq \'both\'       ? (1, 1) :
		    $key eq \'only-cache\' ? (1, 0) :
		    $key eq \'no-cache\'   ? (0, 1) :
		    $key eq \'only-out\'   ? (0, 1) :
		    $key eq \'no-out\'     ? (1, 0) :
				           die "Bad output option: $key";
		sub {
		    die "output limiting only works when cache is enabled"
			unless UNIVERSAL::isa(select(), \'Config::Maker::Tee\');
		    local $Config::Maker::Tee::CACHE = $cache;
		    local $Config::Maker::Tee::OUT = $output;
		    Config::Maker::Driver::apply(@parts);
		}
	    }',
                                                                                                'lookahead' => 0,
                                                                                                'line' => 259
                                                                                              }, 'Parse::RecDescent::Action' )
                                                                                     ],
                                                                          'error' => undef,
                                                                          'actcount' => 1
                                                                        }, 'Parse::RecDescent::Production' )
                                                               ],
                                                    'changed' => 0,
                                                    'calls' => [
                                                                 'identifier',
                                                                 'optpath',
                                                                 'space',
                                                                 'opener',
                                                                 'directive',
                                                                 'closer',
                                                                 'ifrest'
                                                               ],
                                                    'line' => 118,
                                                    'name' => 'directive',
                                                    'impcount' => 0,
                                                    'vars' => '',
                                                    'opcount' => 0
                                                  }, 'Parse::RecDescent::Rule' )
                            },
                 '_check' => {
                               'prevline' => '',
                               'prevoffset' => '',
                               'itempos' => '',
                               'thiscolumn' => '',
                               'prevcolumn' => '',
                               'thisoffset' => ''
                             },
                 '_AUTOTREE' => undef,
                 'namespace' => 'Parse::RecDescent::Config::Maker::Grammar'
               }, 'Parse::RecDescent' );
}